<?php

class wpi_install_demo {
	
	var $menu_ids = array();// save ids of created menus
	var $menu_position = 1;// index of menu item in database, can not duplicate
	var $post_ids = array();
	var $menu_item_ids = array();

	
	// run when create / construct the class
	function __construct() {
	}
	
	function log($text, $br = '<br/>') {
		/*
		echo '<script type="text/javascript">jQuery("#wpi-demo-sample-process-log").append("'.$text.$br.'");</script>';
		flush();
		 */
		$log = get_option('wpi_demo_log', '');
		$log .= $text.$br;
		update_option('wpi_demo_log', $log);
	}
	function update_progress_bar($percent) {
		/*
		echo '<script type="text/javascript">wpi_install_demo_progressbar_step('.$percent.');</script>';
		flush();
		 */
		update_option('wpi_demo_percent', $percent);
	}
	
	function rand_title(){
		$titles = array(
			'Nullam quis consectetur urna, vel rhoncus massa',
			'Nam nec dui at risus tincidunt vestibulum sed imperdiet',
			'Cras blandit semper erat ac dictum',
			'Mauris mauris ex, pharetra non bibendum ac',
			'Duis tincidunt, dui id interdum iaculis, justo sem',
			'In et magna a velit porttitor ultrices',
			'Proin ante magna, sagittis vel sapien at',
			'Vivamus facilisis blandit tortor',
			'Suspendisse id ullamcorper odio',
			'Fusce placerat odio feugiat metus fringilla commodo',
		);
		return $titles[array_rand($titles, 1)];
	}
	
	function rand_content(){
		$contents = array(
            'Nam scelerisque consequat lorem, vel pulvinar orci luctus quis. Nullam feugiat quis ligula et placerat. Pellentesque feugiat lectus non turpis nullam.',
            'Vestibulum eget odio mauris. Praesent dictum in est vitae fringilla. Curabitur consectetur sit amet nunc sit amet euismod. Sed tristique pretium amet.',
            'Aliquam molestie orci posuere faucibus facilisis. Sed a lacus vitae arcu imperdiet semper quis sed lorem. In dolor magna, viverra sit amet massa nunc.',
            'Cras tristique ex augue, eu pulvinar lacus dignissim id. Donec arcu nulla, iaculis sed rutrum in, euismod a libero. Nam lacinia vitae nunc sit nullam.',
            'Donec ultrices varius tortor, nec fringilla ipsum pretium sit amet. Cras vitae ex diam. Nulla tincidunt ipsum ac quam molestie, at ultrices cras amet.',
            'Sed vitae pharetra mauris, vel mollis est. Aliquam tempus tortor non finibus accumsan. Nunc efficitur velit sed nunc tempor molestie. Vivamus posuere.',
            'Aenean id sem maximus tortor mattis iaculis. Etiam eu urna vitae mauris egestas vulputate in tempus nisi. Quisque in vestibulum diam, a dignissim sed.',
            'Praesent fringilla justo nec felis ornare, at facilisis enim ultrices. Integer pellentesque dapibus nunc, vehicula tempor augue cursus id turpis duis.',
            'Fusce interdum nibh turpis, sit amet facilisis nisl aliquet ac. In hac habitasse platea dictumst. Duis a neque in metus facilisis lobortis at posuere.',
            'Sed quis venenatis eros. Etiam in velit non arcu ultrices ullamcorper sed et enim. Sed tempus condimentum pretium. Phasellus blandit et nibh eget sed.',
            'Suspendisse tortor ligula, hendrerit ut eros mattis, mollis vehicula magna. Phasellus sagittis egestas eros, quis vulputate tortor. Aliquam purus sed.',
        );

		$content = '';
		$count_rand = rand(3,count($contents)-1);
		
		for ($i = 1; $i <= $count_rand; $i++) {
			$content .= '<p>' . $contents[array_rand($contents, 1)] . '</p>';
		}
		return $content;
	}
	
	function create_post($post_type = 'page', $slug = 'blank' , $title = '', $content = '', $meta = array(), $cates = array(), $tags = array()) {
		$create_slug = 'wpi_' . $slug . '_' . count($this->post_ids);
		if (empty($title)) {
			$title = $this->rand_title();
		}
		if (empty($content)) {
			$content = $this->rand_content();
		}
		
		// get current post to check
		$args = array(
			'name' => $create_slug,
			'post_type' => $post_type,
			'post_status' => 'publish',
			'posts_per_page' => 1
		);
		$my_posts = get_posts($args);
		
		$new_post = array(
			'post_title' => $title,
			'post_status' => 'publish',
			'post_type' => $post_type,
			'post_name' => $create_slug,
			'post_content' => $content,
			'comment_status' => 'open',
			'guid' => uniqid()
		);
		$post_id = 0;
		if (!empty($my_posts[0])) {
			//update the existing one
			$new_post['ID'] = $my_posts[0]->ID;
		}
		$post_id = wp_insert_post ($new_post);
		$this->log("Create post with type: ($post_type), slug: ($slug), title: ($title)");

		// do other tasks if create successful
		if (!is_wp_error($post_id)) {
			//update post tags and categories
			if ($post_type == 'post') {
				if (!empty($cates)) {
					wp_set_post_terms($post_id, $cates, 'category');
				}
				if (!empty($tags)) {
					wp_set_post_terms($post_id, $tags);
				}
			}
			// update meta
			if (!empty($meta)) {
				foreach ($meta as $key => $value) {
					if (!empty($key) && !empty($value)) {
						update_post_meta( $post_id, $key, sanitize_key($value) );
					}
				}
			}
			
			// save id to list with custom slug
			wp_parse_args(array(
				$slug => $post_id
			), $this->post_ids);
		}
	}
		
	function create_menu($menu_name){
		$current_menu = wp_get_nav_menu_object($menu_name);
		
		// delete old menu with the same name
        if($current_menu){
			wp_delete_nav_menu($menu_name);
		}
		// and create a new one
		$id = wp_create_nav_menu($menu_name);
		wp_parse_args(array(
			$menu_name => $id
		), $menu_ids);
		$this->log("Create a menu with NAME: ($menu_name) and ID: ($id)");
	}
	
	// assign created menu into a 
	function assign_menu($menu_name, $location) {
		$menu = wp_get_nav_menu_object($menu_name);
		if ($menu) {
			$menu_locations = get_theme_mod('nav_menu_locations');
			$menu_locations[$location] = $menu->term_id;
			set_theme_mod('nav_menu_locations', $menu_locations);
			$this->log("Assign menu: ($menu_name) to location: ($location)");
		}
	}
	
	// add item to menu
	function add_item_to_menu($menu_name = '', $item_args = null) {
		$item_args = wp_parse_args(array(
			'type'				=> '',
			'title'				=> '',
			'link'				=> '#',
			'item_slug'			=>	'',
			'post_slug'			=>	'',
			'parent_slug'		=>	'',
			'item_meta'			=>	array()
		), $item_args);
		
		// not serve if not provide title and slug for item
		if (empty($item_args['title']) || empty($item_args['item_slug'])) {
			return;
		}
		
		// get latest menu if not provide the name
		if (empty($menu_name)) {
			if (empty($this->menu_ids)) {
				return;
			}
			$menu_name = $this->menu_ids[count($this->menu_ids) - 1];
		}
		
		// not serve if provided menu name is not exist
		if (!isset($this->menu_ids[$menu_name])) {
			return;
		}
		
		$item_data =  array(
			'menu-item-position'	=> $this->menu_position,
			'menu-item-object'		=> '',
			'menu-item-type'		=> 'custom',
			'menu-item-title'		=> $item_args['title'],
			'menu-item-url'			=> $item_args['link'],
			'menu-item-status'		=> 'publish'
		);

		// update parent id
		if (!empty($item_args['parent_slug'])) {
			// can not add submenu if not valid parent
			if (!isset($this->menu_item_ids[$item_args['parent_slug']])) {
				return;
			} else {
				// already exist parent, update item data
				$item_data = wp_parse_args(array(
					'menu-item-parent-id' => (int)($this->menu_item_ids[$item_args['parent_slug']]),
				),$item_data);
			}
		}

		// update type for page
		if ($item_args['type'] === 'page') {
			if (!empty($item_args['post_slug']) && !isset($this->post_ids[$item_args['post_slug']])) {
				$item_data = wp_parse_args(array(
					'menu-item-object-id' => (int)($this->post_ids[$item_args['post_slug']]),
					'menu-item-object' => 'page',
					'menu-item-type'	  => 'post_type',
				),$item_data);
			}
		}
		
		$item_id = wp_update_nav_menu_item($this->menu_ids[$menu_name], 0, $item_data);
		$item_slug = $item_args['item_slug'];
		
		// update object if create successful
		if(!is_wp_error( $item_id )) {
			$this->log("Add Item ($title) to Menu ($menu_name)");
			$this->menu_item_ids = wp_parse_args(array(
				$item_slug => $item_id
			),$this->menu_item_ids);
			
			// update menu meta
			if (!empty($item_args['item_meta'])) {
				foreach ($item_args['item_meta'] as $key => $value) {
					if (!empty($key) && !empty($value)) {
						update_post_meta( $item_id, $key, sanitize_key($value) );
					}
				}
			}
			
			$this->menu_position++;
		}
	}
	
	function remove_duplicate_menu_item($menu_name) {
		$items = wp_get_nav_menu_items( $menu_name );
		$prev_title = '';
		foreach ($items as $item) {
			if ($prev_title === '') {
				$prev_title = $item->title;
				continue;
			}
			if ($prev_title === $item->title) {
				wp_delete_post($item->ID, true);
			} else {
				$prev_title = $item->title;
			}
		}
	}
	function remove_menu_item($menu_name, $menu_item_title) {
		$items = wp_get_nav_menu_items( $menu_name );
		foreach ($items as $item) {
			
			if ( $item->title === $menu_item_title ) {
				wp_delete_post($item->ID, true);
				return;
			}
		}
	}
	function update_menu_item_meta($menu_name, $menu_item_title, $meta_key, $meta_value) {
		$items = wp_get_nav_menu_items( $menu_name );
		//wp_update_nav_menu_item($this->menu_ids[$menu_name], 0, $item_data);
		foreach ( $items as $item ) {
			if ( $item->title === $menu_item_title ) {
				update_post_meta( $item->ID, $meta_key, sanitize_key($meta_value) );
			}
		}
	}
	
	// search all $key in a file and replace with a text
	function replace_text_in_file($file_path, $search, $replace) {
		// modify xml file
		$file = file_get_contents($file_path);
		if ($file === false) {
			$this->log("Can not load ($file_path)");
			return false;
		}
		$file = str_replace($search, $replace, $file);
		
		if (file_put_contents($file_path, $file) === false) {
			$this->log("Can not write file ($file_path). Please make sure your hosting files are wriable.");
			return false;
		}
		
		return true;
	}
	
	// remove all old widgets from target sidebar 
	function remove_widgets_from_sidebar($sidebar_id) {
		$sidebars_widgets = get_option( 'sidebars_widgets' );
		
		if (isset($sidebars_widgets[$sidebar_id])) {
			//empty the default sidebar
			$sidebars_widgets[$sidebar_id] = array();
		} else {
			$sidebars_widgets = wp_parse_args($sidebars_widgets, array(
				$sidebar_id => array()
			));
		}
		update_option('sidebars_widgets', $sidebars_widgets);
	}
	
	// add widget for a sidebar
	function create_widget($widget_name, $widget_id, $instances) {
		$widget_instances = get_option('widget_' . $widget_name);
		$widget_id = (string) $widget_id;
		$instances = (array) $instances;
		
		//in the demo mode, all the widgets will have an istance id of 70+
		$widget_instances[$widget_id] = $instances;
		
		//add the widget instance to the database
		update_option('widget_' . $widget_name, $widget_instances);
	}
	function assign_widget_to_sidebar($sidebar_slug, $widget_slug) {
		$sidebars_widgets = get_option( 'sidebars_widgets' );
		
		if (!array_key_exists($sidebar_slug, $sidebars_widgets)) {
			$sidebars_widgets = wp_parse_args($sidebars_widgets, array(
				$sidebar_slug => array()
			));
		}
		$sidebars_widgets[$sidebar_slug] = wp_parse_args($sidebars_widgets[$sidebar_slug], array(
			$widget_slug
		));

		update_option('sidebars_widgets', $sidebars_widgets);
	}
	
	// function import widget json
	function import_widget_json($json) {
		// parse json and create widgets
		foreach ($json[1] as $widget_name => $widget) {
			// delete old widgets
			update_option('widget_'.$widget_name, array());
			foreach ($widget as $widget_id => $instances) {
				$instances = (array) $instances;
				if ($widget_id === '_multiwidget') {
					continue;
				}
				if (!is_object($instances) && !is_array($instances)) {
					continue;
				}
				if (isset($instances['category']) && (((int) $instances['category']) != 0)) {
					$title = '';
					$count = 0;
					if (isset($instances['title'])) {
						$title = $instances['title'];
					}
					if (isset($instances['count'])) {
						$count = (int) $instances['count'];
					}
					if ($widget_name == 'wpi_ab_slider' && empty($title)) {
						$title = 'feature';
					}
					 
					$instances['category'] = $this->random_category_id($title, $widget_name, $count);
				}
				$this->create_widget($widget_name, $widget_id, $instances);
			}
		}
		
		// assign widgets to sidebars
		$widget_db_id = 0;
		foreach ($json[0] as $sidebar_slug => $widget_slugs) {
			// invert widget slugs
			$widget_slug_array = array();
			foreach ($widget_slugs as $widget_slug) {
				$widget_slug_array = wp_parse_args($widget_slug_array, array(
					$widget_slug
				));
			}
			foreach ($widget_slug_array as $widget_slug) {
				$this->assign_widget_to_sidebar($sidebar_slug, $widget_slug);
				$widget_db_id++;
			}
		}
		
	}
	
	function random_category_id($title = '', $search = '', $count = 0){
		$cates = get_categories();
		$title = strtolower($title);
		if (empty($cates)) {
			return 1;
		}
		if ($title) {
			foreach ($cates as $cate) {
				$cate_title = strtolower($cate->cat_name);
				if ($cate_title === $title) {
					return (int) $cate->term_id;
				}
			}
		}
		if ($search) {
			foreach ($cates as $cate) {
				$cate_title = strtolower($cate->cat_name);
				if (strpos($search, $cate_title) !== false) {
					return (int) $cate->term_id;
				}
			}
		}
		if ($count) {
			foreach ($cates as $cate) {
				$cate_count = (int) $cate->category_count;
				if ($cate_count > $count) {
					return (int) $cate->term_id;
				}
			}
		}
		return (int) $cates[array_rand($cates, 1)]->term_id;
	}
	
}