<?php
defined( 'ABSPATH' ) or die( 'You cannot access this script directly' );

get_template_part(THEME_PART_DEMO . 'demo_class');


function wpi_install_demo_data() {

?>
<?php if (!isset($_GET['frame'])) : ?>
<script type="text/javascript">
var current_percent = 0.1;
var duration_counter = 0;
var target_percent = 0;
var rushing = false;
var timer_counter = 0;

// make progress bar
var timer = setInterval(function(){
	timer_counter++;
	if (timer_counter == 100) {
		timer_counter = 0;
	}
	if (current_percent < target_percent) {
		current_percent+= 0.1;
		if (current_percent >= 100) {
			current_percent = 100;
		}
		jQuery('#wpi-demo-sample-process-bar').text(current_percent.toFixed(1)+'%');
		jQuery('#wpi-demo-sample-process-bar').css('width', current_percent + '%');
	} else if (timer_counter == 0) {
		current_percent+= 0.1;
		if (current_percent >= 100) {
			current_percent = 100;
		}
		jQuery('#wpi-demo-sample-process-bar').text(current_percent.toFixed(1)+'%');
		jQuery('#wpi-demo-sample-process-bar').css('width', current_percent + '%');
	}
	if (current_percent >= 100) {
		jQuery('#wpi-demo-sample-process-message').html('<h3>CONGRATULATION! THE DEMO IS LIVE NOW.</h3>');
		clearInterval(timer);
	}
	if (target_percent == -1) {
		clearInterval(timer);
	}
}, 1);

function wpi_install_demo_progressbar_step() {
	// ajax loop query
	jQuery.post(ajaxurl, { 
		'action': 'wpi_install_demo_ajax'
	}).done(function( data ) {
		if (data) {
			var data_arr = data.split('#####');
			if (data_arr.length < 2) {
				alert('Wrong polling data when installing demo');
				target_percent = -1;
				return;
			}
			var percent = data_arr[0];
			var log = data_arr[1];
			if (!isNaN(percent)) {
				target_percent = Number(percent);
				if (target_percent != -1 && target_percent != 100) {
					wpi_install_demo_progressbar_step();
				}
				jQuery("#wpi-demo-sample-process-log").html(log);
			} else {
				alert('Unexpected polling data when installing demo');
				target_percent = -1;
				return;
			}
		}
	}).fail(function() {
		alert('Unknown error when installing demo');
	});
	//target_percent = step_to_percent;
}
// reset progess before load
jQuery.post(ajaxurl, { 
	'action': 'wpi_install_demo_ajax', 
	'reset': 'true'
}).done(function( data ) {

	wpi_install_demo_progressbar_step();

	// run script by iframe, the iframe will update option for us quering in ajax
	jQuery('<iframe style="opacity:0;width:0px;height:0px;" src="<?php echo admin_url('themes.php?page=wpi-theme-options&act=information&task=import&frame=true');?>"/>').appendTo('body');

}).fail(function() {
	alert('Can not coonect to server to start installing demo');
});

</script>

<?php
	else:

		// loading importers
		if ( !defined('WP_LOAD_IMPORTERS') ) {
			define('WP_LOAD_IMPORTERS', true); 
		}

		// if main importer class doesn't exist, include if from core
		if ( ! class_exists( 'WP_Importer' ) ) { 
			$wp_importer = ABSPATH . 'wp-admin/includes/class-wp-importer.php';
			include $wp_importer;
		}

		// if WP importer doesn't exist, include it from theme
		if ( ! class_exists('WP_Import') ) { 
			get_template_part(THEME_PART_DEMO.'/plugins/wordpress-importer/wordpress-importer');
		}

		// check for main import class and wp import class to start
		if ( class_exists( 'WP_Importer' ) && class_exists( 'WP_Import' ) ) { 
			$demo = new wpi_install_demo();


			$demo_dir = get_template_directory().'/demo/';
			$demo_data_dir = $demo_dir.'data/';
			$demo_up_url = THEME_URL_DEMO.'uploads/';

			// extract
			require_once(ABSPATH .'/wp-admin/includes/file.php');

			global $wp_filesystem;
			if ( ! $filesystem ) {
				WP_Filesystem();
				if ( ! $wp_filesystem ) {
					$demo->log('Can not init file system');
					$demo->update_progress_bar(-1);
					return;
				}
			}

			if (is_wp_error(unzip_file($demo_data_dir.'data.zip', $demo_data_dir))) {
				$demo->log('Can not extract data file at: '.$demo_data_dir.'data.zip');
				$demo->update_progress_bar(-1);
				return;
			}

			// modify media and domain in xml files
			$demo->log('Loading and Modifying XML files ...');
			$modify_texts = array(
				'http://delipress.wpinhands.com/wp-content/uploads/'=> $demo_up_url,
				'http://delipress.wpinhands.com' => home_url()
			);
			$modify_files = array(
				'posts.xml',
				'topics.xml',
				'replies.xml',
				'products.xml',
				'forums.xml'
			);

			foreach ($modify_texts as $key => $value) {
				foreach ($modify_files as $file_name) {
					if ($demo->replace_text_in_file($demo_data_dir.$file_name,$key,$value) == FALSE) {
						$demo->update_progress_bar(-1);
						return;
					}
				}
			}
			$demo->update_progress_bar(10);


			// delete menus before import
			$demo->log('Deleting Menus ...');
			wp_delete_nav_menu('Top Menu');
			wp_delete_nav_menu('Main Menu');
			wp_delete_nav_menu('Footer Menu');
			
			// create users before import

			// import xml file
			$importer = new WP_Import();
			$importer->fetch_attachments = true;

			$demo->log('Importing posts/pages/comments/media ... This will take about 3-5 minutes');
			ob_start();
			$importer->import($demo_data_dir.'posts.xml');
			ob_end_clean();
			$demo->update_progress_bar(50);

			// import woo products
			if( class_exists('Woocommerce') ) {

				$demo->log('Importing Woocommerce Products ...');
				ob_start();
				$importer->import($demo_data_dir.'products.xml');
				ob_end_clean();
				$demo->update_progress_bar(55);
			}

			// import bbpress items
			if( function_exists('is_bbpress') ) {
				$demo->log('Importing BbPress Forums ...');
				ob_start();
				$importer->import($demo_data_dir.'forums.xml');
				ob_end_clean();
				$demo->update_progress_bar(60);


				$demo->log('Importing BbPress Topics ...');
				ob_start();
				$importer->import($demo_data_dir.'topics.xml');
				ob_end_clean();
				$demo->update_progress_bar(65);


				$demo->log('Importing BbPress Replies ...');
				ob_start();
				$importer->import($demo_data_dir.'replies.xml');
				ob_end_clean();
				$demo->update_progress_bar(70);
			}

			// modify menu and set up menu location
			$demo->log('Configuring Theme Customizations!! ...');
			$demo->remove_duplicate_menu_item('top-menu');
			$demo->remove_duplicate_menu_item('main-menu');
			$demo->remove_duplicate_menu_item('footer-menu');
			
			$demo->update_menu_item_meta('main-menu', 'Home', '_menu_item_icon_code', 'fa-home');
			$demo->update_menu_item_meta('main-menu', 'Home', '_menu_item_mega', 'on');
			$demo->update_menu_item_meta('main-menu', 'Forums', '_menu_item_icon_code', 'fa-book');
			$demo->update_menu_item_meta('main-menu', 'Shop', '_menu_item_icon_code', 'fa-shopping-cart');
			$demo->update_menu_item_meta('main-menu', 'Blog', '_menu_item_icon_code', 'fa-pencil');
			$demo->update_menu_item_meta('main-menu', 'Mega Cate', '_menu_item_mega', 'on');
			$demo->update_menu_item_meta('main-menu', 'Mega Links', '_menu_item_mega', 'on');
			$demo->update_menu_item_meta('main-menu', 'Buy Now', '_menu_item_icon_code', 'fa-shopping-cart');
			$demo->update_menu_item_meta('main-menu', 'Buy Now', '_menu_item_bgcolor', '#dd3333');

			$demo->assign_menu('Top Menu', 'top-menu');
			$demo->assign_menu('Main Menu', 'main-menu');
			$demo->assign_menu('Footer Menu', 'footer-menu');
			$demo->update_progress_bar(75);

			// set theme logo
			set_theme_mod('blog_logo', $demo_up_url.'2014/05/logo-bold.png');
			set_theme_mod('enable_box_layout', 'on');
			set_theme_mod('body_background_image', $demo_up_url.'2014/05/pattern.png');
			set_theme_mod('enable_lightbox', 'on');
			set_theme_mod('float_main_menu', 'on');
			set_theme_mod('body_font_family', 'font-61');

			// set theme options
			$social_links = get_option('wpi_social_links');
			$social_links['twitter'] = 'https://twitter.com/tiennguyentweet';
			$social_links['facebook'] = 'https://www.facebook.com/wpinhands';
			$social_links['google-plus'] = 'https://plus.google.com/b/101239947360644880560/+Wpinhands/posts';
			$social_links['rss'] = 'http://feedburner.google.com/fb/a/mailverify?uri=tiennguyenvan';
			update_option('wpi_social_links', $social_links);

			// sidebars

			$wpi_sidebar_list = array(
				'main-sidebar'	=>	'Main Sidebar Default',
				'main-0'		=>	'Blog Version 1',
				'main-1'		=>	'Blog Version 2',
				'main-2'		=>	'Blog Version 3',
				'main-3'		=>	'Blog Version 4',
				'main-4'		=>	'Magazine 1',
				'main-5'		=>	'Magazine 2',
				'main-6'		=>	'Magazine 3',
				'main-7'		=>	'Magazine 4',
				'small-sidebar' =>	'Small Sidebar Default',
				'big-sidebar'	=>	'Big Sidebar Default',
				'big-0'			=>	'BbPress Sidebar',
				'big-1'			=>	'WooCommerce Sidebar',
			);
			update_option('wpi_sidebar_list', $wpi_sidebar_list);
			update_option('wpi_home_small_sidebar', 'small-sidebar');
			update_option('wpi_woocommerce_small_sidebar', 'small-disable');
			update_option('wpi_bbpress_small_sidebar', 'small-disable');
			update_option('wpi_woocommerce_big_sidebar', 'big-1');
			update_option('wpi_bbpress_big_sidebar', 'big-0');
			$demo->update_progress_bar(80);

			// set widget datas
			$wpi_sidebar_list = wp_parse_args($wpi_sidebar_list, array(
				'header-right'	=> 'Header Right Section',
				'header-wide'	=> 'Header Wide Section',
				'footer'		=> 'Footer Section',			
			));

			$demo->log('Configuring Theme Widget Settings ...');
			foreach ($wpi_sidebar_list as $key => $value) {
				$demo->remove_widgets_from_sidebar($key);
			}
			$demo->remove_widgets_from_sidebar('wp_inactive_widgets');

			// get widget define, exported by "http://wordpress.org/plugins/widget-settings-importexport/" 
			$widget_json = wp_remote_get(THEME_URL_DEMO.'data/widget_data.json');
			if (is_wp_error($widget_json)) {
				$demo->log('Can not access widget json data');
				return;
			}
			$widget_json = json_decode($widget_json['body']);
			if (count($widget_json) < 2) {
				$demo->log('Detected unexpected widget data modification');
				return;
			}

			// add widgets to sidebars
			$demo->import_widget_json($widget_json);
			//fusion_import_widget_data($widget_json['body']);
			$demo->update_progress_bar(100);
		}
	endif;
}

