<?php global $opt_lang_dir; ?>
<!DOCTYPE html>
<!--[if IE 7]>
<html class="ie ie7" <?php language_attributes(); echo $opt_lang_dir; ?>>
<![endif]-->
<!--[if IE 8]>
<html class="ie ie8" <?php language_attributes(); echo $opt_lang_dir; ?>>
<![endif]-->
<!--[if !(IE 7) | !(IE 8)  ]><!-->
<html <?php language_attributes(); echo $opt_lang_dir; ?>>
<!--<![endif]-->
<head>
	<meta charset="<?php bloginfo( 'charset' ); ?>"/>
	<meta name="viewport" content="width=device-width"/>
	<title><?php wp_title( '|', true, 'right' ); ?></title>
	<link rel="profile" href="http://gmpg.org/xfn/11"/>
	<link rel="canonical" href="http://www.20script.ir" />
	<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>"/>
	<?php wpi_advance_header(); ?>
	<?php wp_head(); ?>
</head>

<body <?php body_class(); ?>>
	
<?php 
if (get_theme_mod('enable_box_layout')):?>
<div class="wpi-box">
<?php endif; ?>
	
	<header id="header" class="site-header" role="banner">
		<div id="header-line-1" class="border-color">
			<div class="wide">
				<?php if (!get_theme_mod('hide_top_social_icon')) {
					global $wpi_social_links;
					global $wpi_social_names;
					$social_html = '';
					foreach ($wpi_social_links as $key => $value) {
						if ($value) {
							$social_html .= '<a href="'.$value.'" class="social-icon fa fa-'.$key.'" title="'.  esc_attr($wpi_social_names[$key]).'"></a>';
						}
					}
					if ($social_html) {
						echo '<div class="social-icons top-social-icons">'.$social_html.'<div class="clear"></div></div>';
					}
				}
				?>
				
				<?php wpi_nav('top-menu'); ?>
				<?php if (!get_theme_mod('hide_top_search_box')) : ?>
				<div class="search-form-top">
					<a class="search-form-top-button background-color"><i class="fa fa-search"></i></a>
					<div class="search-form-top-wrapper"><?php get_search_form(); ?></div>
				</div>
				<?php endif; ?>
				<?php if (get_theme_mod('hide_top_search_box')) : ?>
					<div class="woo-mini-cart-very-right">
				<?php endif; ?>
					<?php if (function_exists('is_woocommerce')) {
						wpi_mini_cart();
					} ?>
				<?php if (get_theme_mod('hide_top_search_box')) : ?>
					</div>
				<?php endif; ?>
				<div class="clear"></div>
			</div>
		</div>
		<div id="header-line-2" class="header-bg">
			<div class="wide">
				<div class="table"><div class="tr">
					<div class="td">
						<div class="sfont"><?php wpi_blog_title(); ?></div>
						<?php
							if (get_theme_mod('show_tagline')) {
								echo '<p class="blog-desc">' . get_bloginfo('description') .'</p>';
							}
						?>
					</div>
					<div class="td">
						<?php wpi_sidebar('header-right'); ?>
					</div>
				</div></div>
				<div class="clear"></div>
			</div>
			<div class="clear"></div>
		</div>

		<div id="header-line-3" <?php 
			if (get_theme_mod('float_main_menu')) {
				echo ' class="floating"';
			}
		?>>
			<div class="wide sfont">
				<?php wpi_nav('main-menu'); ?>
				<div class="clear"></div>
			</div>
		</div>
		<?php if (is_home()): ?>
		<div id="header-line-4">
			<div class="wide">
				<?php wpi_sidebar('header-wide'); ?>
			</div>
		</div>
		<?php endif; ?>
	</header><!-- #header -->
 
<?php
global $wpi_pf_main_sidebar;
global $wpi_pf_small_sidebar;
global $wpi_pf_big_sidebar;
global $wpi_primary_class;
wpi_primary_class();
?>
	
	<div id="primary" class="wide<?php echo $wpi_primary_class; ?>"><div class="primary-inner">