<?php get_header(); ?>
<?php
global $number_of_comment;
$number_of_comment = 0;
$page_sidebar = true;
$page_opened = false;
?>
	
		<?php /* The loop */ ?>
		<?php while ( have_posts() ) : the_post();  
			global $post;
			$pid = get_the_ID();
			$page_opened = true;
			// this is for popular widgets
			$count_key = 'post_views_count';
			if (get_theme_mod('view_count_key')) {
				$count_key = get_theme_mod('view_count_key');
			}
			$count = get_post_meta($pid, $count_key, true);

			if($count != ''){
				update_post_meta($pid, $count_key, ((int) $count) + 1);  
			} else {
				add_post_meta($pid, $count_key, '1', true);        
			}
			
			$wpi_pf_sidebar = get_post_meta($pid, 'wpi_pf_sidebar', true);
			if ($wpi_pf_sidebar == 'no_sidebar') {
				$page_sidebar = false;
			}
			
			?>
<div id="primary" class="single-content wide<?php 
	if ($page_sidebar) {
		echo ' has-side';
	} else {
		echo ' no-side';
	}
?>">
	<div id="content" class="site-content" role="main">
		
		<?php

			if ( (has_post_thumbnail()) && (!get_theme_mod( 'hide_feature_image' ))) : ?>
				<div class="post-feature-image item-thumbnail">
					<?php the_post_thumbnail('large', array('alt' => esc_attr(get_the_title()), 'title' => esc_attr(get_the_title()) )); ?>
				</div>
			<?php endif; ?>
			<?php
			$item_cate = '';
			$categories = get_the_category();
			$counter = 0;
			if($categories){
				foreach($categories as $category) {
					if ($counter > 0) {
						$item_cate .= ', ';
					}
					$item_cate .= '<a class="cate" href="'.get_category_link( $category->term_id ).'" title="' . __wpi('View all posts in') . ' ' . esc_attr($category->cat_name) . '">'.$category->cat_name.'</a>';
					$counter++;
				}
			}


		
			$item_date = '<span>'.get_the_date().'</span>';
			$item_time = '<span>'.get_the_time().'</span>';
			
			$author_id = get_the_author_meta( 'ID' );
			$author = get_userdata($author_id);
			$author_link = get_author_posts_url( $author_id );
			$author_external = false;
			if ($author->user_url) {
				$author_link  = $author->user_url;
				$author_external = true;
			}

			?>
			<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>

				<header class="entry-header">
					<h1 class="entry-title"><?php the_title(); ?></h1>
					<div class="meta">
						
						<div class="meta-line-1">
							<div class="post-caterogies">
								<?php echo $item_cate; ?>
							</div>
							<div class="post-app">
								
								<a href="#zoom-out" class="inb sprites zoom-out zoom txtindent" title="<?php echo esc_attr(__wpi('Zoom out post body text'));?>">
									Zoom Out
								</a>
								<a href="#zoom-in" class="inb sprites zoom-in zoom txtindent"  title="<?php echo esc_attr(__wpi('Zoom in post body text'));?>">
									Zoom In
								</a>
								
							</div>
						</div>
						<div class="meta-line-2">
							<div class="author meta-item vcard author"><span class="icon sprites"></span><?php echo __wpi('By');?>  <span class="fn"><?php the_author_posts_link(); ?></span> </div>
							<div class="post-date-time meta-item date published time updated">
								<?php echo $item_time . ' ' . $item_date; ?>
							</div>
							
							
						</div>
						<div class="clear"></div>
					</div>
				</header><!-- .entry-header -->
				<div class="clear"></div>

				<div class="post-content-body entry-content">
				<?php if ( wp_attachment_is_image( $post->id ) ) : 
					$att_image = wp_get_attachment_image_src( $post->id, "full"); 
				?>

					<p class="attachment">
						<a href="<?php echo wp_get_attachment_url($post->id); ?>" title="<?php echo esc_attr(get_the_title()); ?>" rel="attachment">
							<img src="<?php echo $att_image[0];?>" width="<?php echo $att_image[1];?>" height="<?php echo $att_image[2];?>"  class="attachment-medium" alt="<?php echo esc_attr($post->post_excerpt); ?>" />
						</a>
					</p>
					<?php 
					if (get_the_excerpt()) {
						echo '<p class="media-caption">'.  get_the_excerpt().'</p>';
					}
					?>

				<?php else : ?>
					<a href="<?php echo wp_get_attachment_url($post->id); ?>" title="<?php echo esc_attr(get_the_title()); ?>" rel="attachment">
						<?php echo basename($post->guid) ?>
					</a>
				<?php endif; ?>
				</div>
					
				<div class="clear"></div>
			
				<footer class="entry-footer">
					<span class="image-nav-link previous-image"><?php previous_image_link( false, __wpi( '&larr; Previous Media') ); ?></span>
					<span class="image-nav-link next-image"><?php next_image_link( false, __wpi( 'Next Media &rarr;') ); ?></span>
					<div class="clear"></div>
				</footer><!-- .entry-footer -->
				<div class="clear"></div>
			</article><!-- #post -->
			<?php if( (get_theme_mod( 'hide_sharing_buttons' ) != true)) : ?>
			<div class="clear"></div>
			<div class="sharing-box">
				<h3 class="sub-title"><?php echo __wpi('Sharing this'); ?> </h3>
				<!-- AddThis Button BEGIN -->
				<div class="addthis_toolbox addthis_default_style addthis_32x32_style">
					<a class="addthis_button_pinterest_share"></a>
					<a class="addthis_button_facebook"></a>
					<a class="addthis_button_twitter"></a>
					<a class="addthis_button_tumblr"></a>
					<a class="addthis_button_google_plusone_share"></a>
					<a class="addthis_button_print"></a>
					<a class="addthis_button_email"></a>
				</div>
				<!-- AddThis Button END -->
				<div class="clear"></div>
			</div>
			<?php endif; ?>
			
			<?php comments_template(); ?>
			
		<?php endwhile; ?>
				
				<?php if (!$page_opened) : ?>
<div id="primary" class="single-content wide">
	<div id="content" class="site-content" role="main">
		<p><?php echo __wpi('Not found this post'); ?></p>
	<?php endif; ?>
		
	</div><!-- #content -->

</div><!-- #primary's -->
<?php get_footer(); ?>