<?php

	
global $Google_Font_List;
$Google_Font_List = array(
/* --- Start of system font --- */	
	"Arial",				
	"'Courier New'",
	"Georgia",
	"Impact",
	"'Times New Roman'",
	"'Trebuchet MS'",
	"Verdana",
/* --- Start of webfont --- */	
	"Allerta",
	"Allerta Stencil",
	"Arimo",
	"Arvo",
	"Bentham",
	"Bree Serif",
	"Cabin",
	"Calibri",
	"Calligraffitti",
	"Cambria",
	"Cantarell",
	"Cardo",
	"Cherry Cream Soda",
	"Chewy",
	"Coming Soon",
	"Consolas",
	"Copse",
	"Corsiva",
	"Cousine",
	"Covered By Your Grace",
	"Crafty Girls",
	"Crimson Text",
	"Crushed",
	"Cuprum",
	"Dancing Script",
	"Droid Sans",
	"Droid Sans Mono",
	"Droid Serif",
	"Fontdiner Swanky",
	"GFS Didot",
	"GFS Neohellenic",
	"Geo",
	"Gruppo",
	"Hanuman",
	"Homemade Apple",
	"Inconsolata",
	"Indie Flower",
	"Josefin Sans",
	"Josefin Slab",
	"Just Another Hand",
	"Kenia",
	"Kranky",
	"Lato",
	"Lobster",
	"Lobster Two",
	"Lora",
	"Luckiest Guy",
	"Merriweather",
	"Molengo",
	"Mountains of Christmas",
	"Neucha",
	"Neuton",
	"Nobile",
	"Old Standard TT",
	"Open Sans",
	"Oswald",
	"Pacifico",
	"Patua One",
	"Paytone One",
	"Permanent Marker",
	"Philosopher",
	"Play",
	"Poly",
	"PT Sans",
	"PT Sans Caption",
	"PT Sans Narrow",
	"Puritan",
	"Raleway",
	"Reenie Beanie",
	"Rock Salt",
	"Schoolbell",
	"Slackey",
	"Sorts Mill Goudy",
	"Source Sans Pro",
	"Sue Ellen Francisco",
	"Sunshiney",
	"Syncopate",
	"Tinos",
	"UnifrakturMaguntia",
	"Unkempt",
	"Varela Round",
	"Vollkorn",
	"Walter Turncoat",
	"Yanone Kaffeesatz"
);


// check to prevent define class on front-pages
if ( class_exists( 'WP_Customize_Control' ) ) :
		
	/*Insert custom Google fonts into customizer*/
	/*#######################################################*/
	class GoogleFontPicker extends WP_Customize_Control { 
		public function render_content() {
			global $Google_Font_List;	?>

	<div class="google-font">	
	<span class="customize-control-title"><?php echo $this->label; ?></span>
	<!-- output radio for fonts -->
	<?php
			$default = 'font-62';
			if (property_exists($this, 'setting')) {
				if (property_exists($this->setting, 'default')) {
					$default = $this->setting->default;
				}
			}
			$value = $default;
			if (property_exists($this, 'value')) {
				$value = $this->value;
			}
			if (!$value) {
				$value = $default;
			}
			echo '<a class="font-reset button" data-default="'.$default.'">'.  __wpi('Reset to Default').'</a>';
			echo '<div class="font-container">';
			
			// show font for GOOGLE FONTS			
			for ($i = 0; $i < count($Google_Font_List); $i++) {
				if ($i == 0) {
					echo '<div class="font-hr">System fonts</div>';
				}
				if ($i == 7) {
					echo '<div class="font-hr">Webfonts</div>';
				}
				
				echo '<label class="font-style font-style-'.$i.'"><input type="radio" value="font-'.$i.'" name="'.$this->id.'" '.$this->get_link().' '.(($value == ('font-'.$i))?'checked':'').'/>'.$Google_Font_List[$i].'<br/></label>' ;
			}
			
			// show font for CUSTOM font
			$cufont = array();
			$the_query = new WP_Query( array( 
				'post_status' => 'any', 
				'post_type' => 'attachment',
				'post_mime_type' => 'font/opentype') );

			// The Loop
			if ( $the_query->have_posts() ) :
				while ( $the_query->have_posts() ) : $the_query->the_post();
					$fid = get_the_ID();
					$fname = get_the_title();
					$cufont['cufont-'.$fid] = $fname;
				endwhile;
			endif;
			
			/* Restore original Post Data */
			wp_reset_postdata();
			if (!empty($cufont)) {
				echo '<div class="font-hr">'.  __wpi('Uploaded Fonts').'</div>';
				$index = count($Google_Font_List);
				foreach ($cufont as $key => $name) {
					echo '<label class="font-style font-style-'.$index.'"><input type="radio" value="'.$key.'" name="'.$this->id.'" '.$this->get_link().' '.(($value == $key)?'checked':'').'/>'.$name.'<br/></label>' ;
					$index++;
				}
			}
			
			
			echo '</div></div>';
			
			
		}
		
	}   

	
	
endif; /*check wp control support*/
