<?php
global $opt_lang_dir;
$opt_lang_dir = '';
if (get_theme_mod('rtl') == true) {
	$opt_lang_dir = ' dir="rtl"';
}
global $body_bg_color;
global $body_bg_image;

function customizer_output() {
	$customizer_css = '';
	$main_color = get_theme_mod('main_color');
	$main_nav_color = get_theme_mod('main_nav_color');
	
	if ($main_color == '' || $main_color == NULL) {
		$main_color = '#EA6153';
	}
	if ($main_nav_color == '' || $main_nav_color == NULL) {
		$main_nav_color = '#EA6153';
	}
	
	
	$em_font = get_theme_mod('emphasis_font_family');
	if ($em_font == '' || $em_font == NULL) {
		$em_font = 'font-62';
	}
	
	$body_font = get_theme_mod('body_font_family');
	if ($body_font == '' || $body_font == NULL) {
		$body_font = 'font-0';
	}

	$em_font_index = (int) substr($em_font, strpos($em_font, '-')+1);
	$body_font_index = (int) substr($body_font, strpos($body_font, '-')+1);
	
	// custom header
	$header_bg_color 		= get_theme_mod('header_background_color');
	$header_bg_image 		= get_theme_mod('header_background_image');
	$header_bg_repeat 		= get_theme_mod('header_background_repeat');
	$header_bg_position 	= get_theme_mod('header_background_position');
	$header_bg_attachment 	= get_theme_mod('header_background_attachment');
	switch ($header_bg_repeat) {
		case 'no'	: 	$header_bg_repeat = 'no-repeat';break;
		case 'tile'	:	$header_bg_repeat = 'repeat';	break;
		case 'hor'	:	$header_bg_repeat = 'repeat-x';	break;
		case 'ver'	: 	$header_bg_repeat = 'repeat-y';	break;
		default: $header_bg_repeat = 'repeat';break;
	}
	if (!$header_bg_color) {$header_bg_color = '#FFFFFF';}
	if (!$header_bg_attachment) {$header_bg_attachment = 'scroll';}
	if (!$header_bg_position) {$header_bg_position = 'center';}
	
	
	
	$customizer_css .= '
.header-bg{
	background-color: '.$header_bg_color.';';
	if ($header_bg_image) {
		$customizer_css .= '
	'.(($header_bg_image)? ('background-image: url('.$header_bg_image.')') : '').';	
	background-repeat: '.$header_bg_repeat.';
	background-position: top '.$header_bg_position.';
	background-attachment: '.$header_bg_attachment.';';
	}
	$customizer_css .= '
}';

	// custom body background
	$body_bg_color 		= get_theme_mod('body_background_color');
	$body_bg_image 		= get_theme_mod('body_background_image');
	$body_bg_repeat 	= get_theme_mod('body_background_repeat');
	$body_bg_position 	= get_theme_mod('body_background_position');
	$body_bg_attachment = get_theme_mod('body_background_attachment');
	switch ($body_bg_repeat) {
		case 'no'	: 	$body_bg_repeat = 'no-repeat';break;
		case 'tile'	:	$body_bg_repeat = 'repeat';	break;
		case 'hor'	:	$body_bg_repeat = 'repeat-x';	break;
		case 'ver'	: 	$body_bg_repeat = 'repeat-y';	break;
		default: $body_bg_repeat = 'repeat';break;
	}
	if (!$body_bg_color) {$body_bg_color = '#FFFFFF';}
	if (!$body_bg_attachment) {$body_bg_attachment = 'scroll';}
	if (!$body_bg_position) {$body_bg_position = 'center';}
	
	$customizer_css .= '
body {
	background-color: '.$body_bg_color.';';
	if ($body_bg_image) {
		$customizer_css .= '
	'.(($body_bg_image)? ('background-image: url('.$body_bg_image.')') : '').';	
	background-repeat: '.$body_bg_repeat.';
	background-position: top '.$body_bg_position.';
	background-attachment: '.$body_bg_attachment.';';
	}
	$customizer_css .= '
}';
	
	// main color
	if ($main_color) :
		$customizer_css .= '
.color,
.color-hover:hover,
.color-active:active,
.color-visited:visited,
.color-link:link,
a,
.news-box.tabs .tab-header.active a{
	color:'.$main_color.'
}
.pagination-index .page-numbers,
#respond input#submit,
.background-color,
.background-color-hover:hover,
.widget_wpi_login_form .login-submit input,
.news-box.slider .bar_nav li.active {
	background-color:'.$main_color.'
}
.border-color{border-color: '.$main_color.'}
	
::-webkit-scrollbar-thumb {
	background-color: '.$main_color.';
}
#nav-main-menu .selectnav,
#header-line-3,
#nav-main-menu .sub-menu,
#nav-main-menu .mega-menu {
	background-color: '.$main_nav_color.';
}
';
	endif; //main color
	

	// google font
	$em_font_text = 'Oswald';
	$body_font_text = 'Arial';
	global $Google_Font_List;
	if ($em_font && $body_font) :
		// loading google fonts
		if (strpos($em_font, 'cufont') === false) {
			$em_font_text = $Google_Font_List[$em_font_index];
			if ($em_font_index > 6) {
				echo '<link href="http://fonts.googleapis.com/css?family='.str_replace(' ', '+', $em_font_text).'" rel="stylesheet" type="text/css">';
			}
		} else {
			$fname = get_the_title($em_font_index);
			$fguid = get_the_guid($em_font_index);
			$customizer_css .= '@font-face {
  font-family: \''.$fname.'\';
  src: url('.$fguid.') format(\'woff\');
}';
			$em_font_text = $fname;
		}
		if (strpos($body_font, 'cufont') === false) {
			$body_font_text = $Google_Font_List[$body_font_index];
			if ($body_font_index > 6) {
				echo '<link href="http://fonts.googleapis.com/css?family='.str_replace(' ', '+', $body_font_text).'" rel="stylesheet" type="text/css">';
			}
		} else {
			$fname = get_the_title($body_font_index);
			$fguid = get_the_guid($body_font_index);
			$customizer_css .= '@font-face {
  font-family: \''.$fname.'\';
  src: url('.$fguid.') format(\'woff\');
}';
			$body_font_text = $fname;
		}
		$customizer_css .='
body, .nfont, #nav-main-menu .sub-menu {
	font-family: '.$body_font_text.';
}
.bbpress #bbpress-forums *[class!="fa-"]{
	font-family: '.$body_font_text.'!important;
}
.sfont, #reply-title, #respond input#submit, .widget_wpi_login_form .login-submit input {
	font-family: \''.$em_font_text.'\', sans-serif;
}';

	endif; // google fonts
		
	wp_add_inline_style( THEME_DOMAIN.'-style', $customizer_css );
}

add_action('wp_enqueue_scripts', 'customizer_output');



function custom_favicon() {
	$fav_src = get_theme_mod('favicon');
	$fav_html = '<link rel="shortcut icon" ';
	if (!$fav_src) {
		$fav_src = THEME_URL_IMG.'favicon.png';
	}
	if (strpos($fav_src, '.ico') !== false) {
		$fav_html .= 'type="image/x-icon"';
	} else if (strpos($fav_src, '.png') !== false) {
		$fav_html .= 'type="image/png"';
	} else if (strpos($fav_src, '.gif') !== false) {
		$fav_html .= 'type="image/gif"';
	}
		
	
	$fav_html .= ' href="'.$fav_src.'"/>';
	
	echo $fav_html;
}
add_action('wp_head', 'custom_favicon');