<?php
 //converts a sidebar name to an id that can be used by word press
function wpi_sidebar_name_to_id($sidebar_name) {
	$clean_name = str_replace(array(' '), '-', trim($sidebar_name));
	$clean_name = str_replace(array("'", '"'), '', trim($clean_name));
	return strtolower($clean_name);
}
	
function wpi_related_path($path = '') {
	
	if ($path) {
		
	}
	return $path;
}

function wpi_nav($location, $walker = null) {
	if ($location) {
		if ( has_nav_menu( $location ) ) {
			echo '<nav id="nav-'.$location.'">';
			wp_nav_menu( array( 
				'theme_location' => $location, 
				'menu_class' => $location.'-class', 
				'walker' => new wpi_output_menu_custom_fields  
				)
			);
			echo '</nav>';
		}
	}
}

function wpi_sidebar($location) {
	if ( is_active_sidebar( $location )) : ?>
		<div id="<?php echo $location; ?>" class="sidebar <?php echo $location; ?>">
			<?php dynamic_sidebar( $location ); ?>
			<div class="clear"></div>
		</div>
	<?php endif;
}

function wpi_blog_title() {
	
	
	if (get_theme_mod('blog_logo')) {
		$blog_title = '<a href="'.get_home_url().'" title="'.esc_attr(get_bloginfo( 'name')).'">';
		$blog_title .= '<img alt="blog-logo" src="'.get_theme_mod('blog_logo').'"/>';
		$blog_title .= '</a>';
	}
	else {
		$blog_title = '<a href="'.get_home_url().'" title="'.esc_attr(get_bloginfo( 'description')).'">';
		$blog_title .= get_bloginfo('name');
		$blog_title .= '</a>';
	}
	
	
	if (is_singular()) : ?>
		<h2 class="blog-title"><?php echo $blog_title; ?></h2>
	<?php else : ?>
		<h1 class="blog-title"><?php echo $blog_title; ?></h1>
	<?php endif;
}

function wpi_get_image_attachment_id($image_url) {
	global $wpdb;
	$prefix = $wpdb->prefix;
	$attachment = $wpdb->get_col($wpdb->prepare("SELECT ID FROM " . $prefix . "posts" . " WHERE guid='%s';", $image_url )); 
	if ( $attachment ) {
		foreach ( $attachment as $attachment_id ) 
		{
			return $attachment_id;
		}
	}
    return NULL;
}
function wpi_get_first_image_src_in_content($content = '', $size = 'medium') {
	$src = '';
	if (!($content)) {
		$content = get_the_content();
		if (!($content)) {
			global $post;
			if (is_object($post)) {
				if (property_exists($post, 'post_content')) {
					$content = $post->post_content;
				}
			}
		}
	}
	if ($content) {
		
		$start_image_tag = strpos($content, '<img ');
		if ($start_image_tag !== false) {
			
			// get image id first, if already in library, return match size src, 
			// else, return src only
			
			$start_class_1 = strpos($content, 'class="', $start_image_tag);
			$start_class_2 = strpos($content, 'class=\'', $start_image_tag);
			if (!($start_class_1 === false && $start_class_2 === false)) {
				
				$start_class = -1;
				if ($start_class_1 === false) {
					$start_class = $start_class_2;
				} else if ($start_class_2 === false) {
					$start_class = $start_class_1;
				} else if ($start_class_1 < $start_class_2) {
					$start_class = $start_class_1;
				} else {
					$start_class = $start_class_2;
				}
				
				if ($start_class != -1) {
					
					$offset_key = 'class="';
					$end_class_1 = strpos($content, '"', $start_class + strlen($offset_key));
					$end_class_2 = strpos($content, '\'', $start_class + strlen($offset_key));
					$end_class = -1;
					if ($end_class_1 === false) {
						$end_class = $end_class_2;
					} else if ($end_class_2 === false) {
						$end_class = $end_class_1;
					} else if ($end_class_1 < $end_class_2) {
						$end_class = $end_class_1;
					} else {
						$end_class = $end_class_2;
					}
					
					if ($end_class != -1) {
						
						$len = $end_class - ($start_class + strlen($offset_key));
						$cls = substr($content, $start_class + strlen($offset_key), $len);
						
						if ($cls && strpos($cls, 'wp-image-') !== false) {
							$cls = substr($cls, strpos($cls, 'wp-image-') + strlen('wp-image-'));
						}
						if (strpos($cls, ' ') !== false) {
							$cls = substr($cls, 0, strpos($cls, ' '));
						}
						if (strpos($cls, '\t') !== false) {
							$cls = substr($cls, 0, strpos($cls, '\t'));
						}
						
						if ($cls && is_numeric($cls)) {
							$src = wp_get_attachment_image_src((int)$cls, $size);
							if (is_array($src) && !empty($src)) {
								return $src[0];
							}
						}
					}
				}
			}
			
			
			
			$start_src_1 = strpos($content, 'src="', $start_image_tag);
			$start_src_2 = strpos($content, 'src=\'', $start_image_tag);
			if (!($start_src_1 === false && $start_src_2 === false)) {
				$start_src = -1;
				if ($start_src_1 === false) {
					$start_src = $start_src_2;
				} else if ($start_src_2 === false) {
					$start_src = $start_src_1;
				} else if ($start_src_1 < $start_src_2) {
					$start_src = $start_src_1;
				} else {
					$start_src = $start_src_2;
				}
				
				if ($start_src != -1) {
					$offset_key = 'src="';
					$end_src_1 = strpos($content, '"', $start_src + strlen($offset_key));
					$end_src_2 = strpos($content, '\'', $start_src + strlen($offset_key));
					$end_src = -1;
					if ($end_src_1 === false) {
						$end_src = $end_src_2;
					} else if ($end_src_2 === false) {
						$end_src = $end_src_1;
					} else if ($end_src_1 < $end_src_2) {
						$end_src = $end_src_1;
					} else {
						$end_src = $end_src_2;
					}
					
					if ($end_src != -1) {
						$len = $end_src - ($start_src + strlen($offset_key));
						return substr($content, $start_src + strlen($offset_key), $len);
					}
				}
			}
		}
	}
	
	return $src;
}

// http://stackoverflow.com/questions/1361149/get-img-thumbnails-from-vimeo
function wpi_get_vimeo_image_src_in_content($content = '', $size = 'small') {
	$src = '';
	if ($size == 'thumbnail') {
		$size = 'small';
	} else if ($size == 'full') {
		$size = 'large';
	}
	
	
	if ($size && $content) {
		// search and get vimeo ID
		$key = '//player.vimeo.com/video/';
		$start = strpos($content, $key);
		if ($start !== false) {
			$end_1 = strpos($content, '"', $start + strlen($key));
			$end_2 = strpos($content, '\'', $start + strlen($key));
			$end_3 = strpos($content, '?', $start + strlen($key));
			
			if (!($end_1 === false && $end_2 === false && $end_3 === false)) {
				$end = -1;
				if ($end_1 === false) {
					$end = $end_2;
				} else if ($end_2 === false) {
					$end = $end_1;
				} else if ($end_1 < $end_2) {
					$end = $end_1;
				} else {
					$end = $end_2;
				}
				
				if ($end_3 !== false && $end_3 < $end) {
					$end = $end_3;
				}
				
				$vimeo_id = substr($content, $start + strlen($key), $end - ($start + strlen($key)));
				$src = get_transient('vimeo_thumb-'.$vimeo_id);
				if ($src === false) {
					// load vimeo thumbnail via API
					$vimeo_thumb_xml = wp_remote_get('http://vimeo.com/api/v2/video/'.$vimeo_id.'.php', array( 
						'sslverify' => false, 
						'compress'    => false,
						'decompress'  => false,
						'timeout'	=> WPI_REMOTE_TIMEOUT));

					if ( !is_wp_error($vimeo_thumb_xml) ) {
						$hash = unserialize(wp_remote_retrieve_body($vimeo_thumb_xml));
						$src = $hash[0]['thumbnail_large'];	
						set_transient('vimeo_thumb-'.$vimeo_id, $src, 60*60*24*365);
						update_option('vimeo_thumb-'.$vimeo_id, $src);
					} else {
						$src = get_option('vimeo_thumb-'.$vimeo_id, '');
					}
				}
				
				
			}
		}
	}
	
	return $src;
}


// http://stackoverflow.com/questions/2068344/how-to-get-thumbnail-of-youtube-video-link-using-youtube-api/2068371#2068371
/*
latest short format: http://youtu.be/NLqAF9hrVbY
iframe: http://www.youtube.com/embed/NLqAF9hrVbY
iframe (secure): https://www.youtube.com/embed/NLqAF9hrVbY
object param: http://www.youtube.com/v/NLqAF9hrVbY?fs=1&hl=en_US
object embed: http://www.youtube.com/v/NLqAF9hrVbY?fs=1&hl=en_US
watch: http://www.youtube.com/watch?v=NLqAF9hrVbY
users: http://www.youtube.com/user/Scobleizer#p/u/1/1p3vcRhsYGo
ytscreeningroom: http://www.youtube.com/ytscreeningroom?v=NRHVzbJVx8I
any/thing/goes!: http://www.youtube.com/sandalsResorts#p/c/54B8C800269D7C1B/2/PPS-8DMrAn4
any/subdomain/too: http://gdata.youtube.com/feeds/api/videos/NLqAF9hrVbY
more params: http://www.youtube.com/watch?v=spDj54kf-vY&feature=g-vrec
query may have dot: http://www.youtube.com/watch?v=spDj54kf-vY&feature=youtu.be
nocookie domain: http://www.youtube-nocookie.com
 */
function wpi_get_youtube_image_src_in_content($content = '', $size = 'thumbnail') {
	$src = '';
	if ($size && $content) {
		// search and get vimeo ID
		$key = '//www.youtube.com/embed/';
		$start = strpos($content, $key);
		
		if ($start !== false) {
			$end = 0;
			$end0 = strpos($content, '?', $start + strlen($key));
			$end1 = strpos($content, '"', $start + strlen($key));
			$end2 = strpos($content, '\'', $start + strlen($key));
			if ($end0 !== false) {
				$end = $end0;
			} else if ($end1 !== false) {
				$end = $end1;
			} else if ($end2 !== false) {
				$end = $end2;
			}

			if ($end0 !== false && $end0 < $end) {
				$end = $end0;
			}
			if ($end1 !== false && $end1 < $end) {
				$end = $end1;
			}
			if ($end2 !== false && $end2 < $end) {
				$end = $end2;
			}
			
			if ($end) {
				
				$youtube_id = substr($content, $start + strlen($key), $end - ($start + strlen($key)));
				/*
				if ($size == 'thumbnail') {
					$src = 'http://img.youtube.com/vi/'.$youtube_id.'/default.jpg';
				} else if ($size == 'medium') {
					$src = 'http://img.youtube.com/vi/'.$youtube_id.'/hqdefault.jpg';
				} else if ($size == 'large') {
					$src = 'http://img.youtube.com/vi/'.$youtube_id.'/maxresdefault.jpg';
				} else {
					$src = 'http://img.youtube.com/vi/'.$youtube_id.'/mqdefault.jpg';
				}
				*/
				$src = 'http://img.youtube.com/vi/'.$youtube_id.'/hqdefault.jpg';
			}
		} else {
			$key = '//www.youtube';
			$start = strpos($content, $key);
			
			if ($start !== false) {
				$key = 'v/';
				$start = strpos($content, $key, $start);
			
				if ($start !== false) {
					$end = 0;
					$end0 = strpos($content, '?', $start + strlen($key));
					$end1 = strpos($content, '"', $start + strlen($key));
					$end2 = strpos($content, '\'', $start + strlen($key));
					if ($end0 !== false) {
						$end = $end0;
					} else if ($end1 !== false) {
						$end = $end1;
					} else if ($end2 !== false) {
						$end = $end2;
					}

					if ($end0 !== false && $end0 < $end) {
						$end = $end0;
					}
					if ($end1 !== false && $end1 < $end) {
						$end = $end1;
					}
					if ($end2 !== false && $end2 < $end) {
						$end = $end2;
					}


					if ($end) {
						$youtube_id = substr($content, $start + strlen($key), $end - ($start + strlen($key)));
						/*
						if ($size == 'thumbnail') {
							$src = 'http://img.youtube.com/vi/'.$youtube_id.'/default.jpg';
						} else if ($size == 'medium') {
							$src = 'http://img.youtube.com/vi/'.$youtube_id.'/hqdefault.jpg';
						} else if ($size == 'large') {
							$src = 'http://img.youtube.com/vi/'.$youtube_id.'/maxresdefault.jpg';
						} else {
							$src = 'http://img.youtube.com/vi/'.$youtube_id.'/mqdefault.jpg';
						}
						 */
						$src = 'http://img.youtube.com/vi/'.$youtube_id.'/hqdefault.jpg';
					}
				} else {
					// this for copy & paste video link
					$key = 'watch?v=';
					
					$start = strpos($content, $key, $start);
					if ($start !== false) {
						for ($i = $start+strlen($key); $i < strlen($content) - 1; $i++) {
							$cvalue = ord(substr($content, $i, 1));
							if (($cvalue < 48 || $cvalue > 57) && 
								($cvalue < 65 || $cvalue > 90) &&
								($cvalue < 97 || $cvalue > 122) &&
								$cvalue != 45 && $cvalue != 95) {
								break;
							}
						}
						if ($i < strlen($content)) {
							$end = $i;
							$youtube_id = substr($content, $start + strlen($key), $end - ($start + strlen($key)));
							$src = 'http://img.youtube.com/vi/'.$youtube_id.'/hqdefault.jpg';
						}
					}
				}
			}
		}
	}
	return $src;
}

/*
 * Get the first image of post as SRC only
 */
function wpi_get_post_img_src($post_id = 0, $size = 'medium') {
	$src = '';
	if (!$post_id) {
		$post_id = get_the_ID();
		if (!$post_id) {
			global $post;
			if (is_object($post)) {
				if (property_exists($post, 'ID')) {
					$post_id = $post->ID;
				}
			}
		}
	}
	
	if ($post_id) {
		if (has_post_thumbnail($post_id)) {
			$post_thumbnail_id = get_post_thumbnail_id( $post_id );
			if ($post_thumbnail_id) {
				$image_attributes = wp_get_attachment_image_src( $post_thumbnail_id, $size );
				if (is_array($image_attributes) && isset($image_attributes[0])) {
					$src = $image_attributes[0];
				}
			}
		} else {
			$content_post = get_post($post_id);
			$content = $content_post->post_content;
			
			// search image in post
			$src = wpi_get_first_image_src_in_content($content, $size);
			if ($src == '') {
				$src = wpi_get_vimeo_image_src_in_content($content, $size);
			}
			if ($src == '') {
				$src = wpi_get_youtube_image_src_in_content($content, $size);
			}
		}
	}
	
	if (!($src)) {
		$src = get_theme_mod('default_thumbnail_image');
		if ($src == '') {
			if ($size == 'thumbnail') {
				$src = 'http://lorempixel.com/260/200/';
			} else if ($size == 'medium') {
				$src = 'http://lorempixel.com/340/300/';
			} else if ($size == 'large') {
				$src = 'http://lorempixel.com/700/400/';
			}
		}
	}
	return $src;
}

/*sizes: thumbnail, large, medium, full*/
function wpi_get_post_image($post_id = 0, $size = 'thumbnail', $attr = NULL) {
	$html = '';
	
	if (!$post_id) {
		$post_id = get_the_ID();
		if (!$post_id) {
			global $post;
			if (is_object($post)) {
				if (property_exists($post, 'ID')) {
					$post_id = $post->ID;
				}
			}
		}
	}
	
	if ($post_id) {
	
		if (has_post_thumbnail($post_id)) {
			$html = get_the_post_thumbnail($post_id, $size, $attr);
		} else {
			$content_post = get_post($post_id);
			$content = $content_post->post_content;
			
			// search image in post
			$src = wpi_get_first_image_src_in_content($content, $size);
			if ($src == '') {
				$src = wpi_get_vimeo_image_src_in_content($content, $size);
				if ($src == '') {
					$src = wpi_get_youtube_image_src_in_content($content, $size);
				}
			}
			
			if ($src) {
				if (wpi_get_image_attachment_id($src)) {
					$html .= wp_get_attachment_image( wpi_get_image_attachment_id($src), $size, false, $attr );
				} else {
					// maybe external image or not in library
					$html = '<img src="'.$src.'"';
					foreach ($attr as $key => $value) {
						$html .= ' '.$key.'="'.$value.'"';
					}
					$html .= '/>';
				}
			} else {
				$src = get_theme_mod('default_thumbnail_image');
				if ($src == '') {
					if ($size == 'thumbnail') {
						$src = 'http://lorempixel.com/260/200/';
					} else if ($size == 'medium') {
						$src = 'http://lorempixel.com/340/300/';
					} else if ($size == 'large') {
						$src = 'http://lorempixel.com/700/400/';
					} else if ($size == 'full') {
						$src = 'http://lorempixel.com/1024/600/';
					}
				}
				
				// for post without images
				$html = '<img src="'.$src.'"';
				foreach ($attr as $key => $value) {
					$html .= ' '.$key.'="'.$value.'"';
				}
				$html .= '/>';
			}
			
		}
	}
	return $html;
}


/*  ----------------------------------------------------------------------------
    mbstring support
 */

if (!function_exists('mb_strlen')) {
    function mb_strlen ($string) {
        return strlen($string);
    }
}

if (!function_exists('mb_strpos')) {
    function mb_strpos($haystack,$needle,$offset=0) {
        return strpos($haystack,$needle,$offset);
    }
}
if (!function_exists('mb_strrpos')) {
    function mb_strrpos ($haystack,$needle,$offset=0) {
        return strrpos($haystack,$needle,$offset);
    }
}
if (!function_exists('mb_strtolower')) {
    function mb_strtolower($string) {
        return strtolower($string);
    }
}
if (!function_exists('mb_strtoupper')) {
    function mb_strtoupper($string){
        return strtoupper($string);
    }
}
if (!function_exists('mb_substr')) {
    function mb_substr($string,$start,$length = false) {
	    if ($length) {
		    return substr($string,$start, $length);
	    }
	    return substr($string,$start);
    }
}
if (!function_exists('mb_internal_encoding')) {
    function mb_internal_encoding($string) {
        return $string;
    }
}
if (!function_exists('mb_http_output')) {
    function mb_http_output($string) {
        return $string;
    }
}
if (!function_exists('mb_http_output')) {
    function mb_http_output($string) {
        return $string;
    }
}
if (!function_exists('mb_http_input')) {
    function mb_http_input($string) {
        return $string;
    }
}
if (!function_exists('mb_language')) {
    function mb_language($string) {
        return $string;
    }
}
if (!function_exists('mb_regex_encoding')) {
    function mb_regex_encoding($string) {
        return $string;
    }
}

/*Use this function inside loop
 * wrap = true mean wrap content by p tag
 * one_line = true mean remove all html tags in content
 */
function wpi_get_the_snippet($length = 150, $wrap = true, $one_line = false) {
	$html = '';
	global $post;
	
	if (is_object($post)) {
		if (property_exists($post, 'post_excerpt') && $post->post_excerpt) {
			$html = $post->post_excerpt;
		} else if (property_exists ($post, 'post_content') && $post->post_content){
			$html = $post->post_content;
		}
	}
	
	if ((!$html) && get_the_content('', false)) {
		$html = get_the_content('', false);
	}
	
	if ((!$html) && get_the_excerpt()) {
		$html = get_the_excerpt();
	}

	if ($html) {
		$html = do_shortcode($html);
		$html = strip_tags($html);
		if (strlen($html) > $length) {
			if (	function_exists('mb_internal_encoding') &&
					function_exists('mb_http_output') &&
					function_exists('mb_http_input') &&
					function_exists('mb_language') &&
					function_exists('mb_regex_encoding')) {
				mb_internal_encoding('UTF-8');
				mb_http_output('UTF-8');
				mb_http_input('UTF-8');
				mb_language('uni');
				mb_regex_encoding('UTF-8');
			}
			$html = mb_substr($html, 0, $length) . '...';	
		}
		if ($one_line) {
			$html = str_replace("\n", "", $html);
			$html = str_replace("\r", "", $html);
		}
		if ($wrap) {
			$html = '<p class="snippet">'.$html.'</p>';
		}
		
	}
	return $html;
}

function wpi_remove_html_slashes($content) {
	return filter_var(stripslashes($content), FILTER_SANITIZE_SPECIAL_CHARS);
}

function wpi_safe_array_get($arr, $element, $default = '') {
	$value = $default;
	
	if (is_array($arr) && array_key_exists($element, $arr)) {
		$value = $arr[$element];
	}
	return $value;
}


function wpi_pagenav_index(){
	global $wp_query;
	$big = 999999999; // need an unlikely integer
	echo '<div class="clear"></div><div class="pagination-index sfont">';
	echo paginate_links( array(
		'base' => str_replace( $big, '%#%', esc_url( get_pagenum_link( $big ) ) ),
		'format' => '?paged=%#%',
		'current' => max( 1, get_query_var('paged') ),
		'total' => $wp_query->max_num_pages,
		'prev_text'    => __('<i class="fa fa-chevron-left"></i>'),
		'next_text'    => __('<i class="fa fa-chevron-right"></i>'),
	) );
	echo '<div class="clear"></div></div>';
}

function wpi_pagenav_singular() {
	if (get_adjacent_post(false, '', true) || get_adjacent_post(false, '', false)) :
		
	?>
		<div class="paginations item_pagination post-footer-box">
			<?php if (get_adjacent_post(false, '', false)) : ?>
			<div class="item newer sfont"><span class="nfont"><i class="fa fa-angle-left"></i> <?php echo __wpi('Newer Post'); ?></span><?php next_post_link('%link'); ?></div>
			<?php endif;?>

			<?php if (get_adjacent_post(false, '', true)) : ?>
			<div class="item older sfont"><span class="nfont"><?php echo __wpi('Older Post'); ?> <i class="fa fa-angle-right"></i></span><?php previous_post_link('%link'); ?></div>
			<?php endif;?>
			<div class="clear"></div>
		</div>
	<?php

	endif;
}

function wpi_has_form_controls($str = '') {
	if (!$str) {
		return false;
	}
	if (strpos($str, '<form') !== false) {
		return true;
	}
	if (strpos($str, '<input') !== false) {
		return true;
	}
	if (strpos($str, '<textarea') !== false) {
		return true;
	}
	if (strpos($str, '<select') !== false) {
		return true;
	}
	if (strpos($str, '<option') !== false) {
		return true;
	}
	
	return false;
}

function wpi_get_server_request($key) {
	$value = '';
	if ($key) {
		if (isset($_GET[$key])) {
			$value = $_GET[$key];
		} else if (isset($_POST[$key])) {
			$value = $_POST[$key];
		}
	}
	return $value;
}

function wpi_single_breadcrumbs($pid = null) {
	if (!$pid) {
		global $post;
		$pid = $post->ID;
	}
	$cats = get_the_category($pid);
	$par_cats = $cats;
	$max_url = '';
	$max_name = '';
	$max_count = 0;;
	$par_name = '';
	$par_url = '';
	$child_name = '';
	$child_url = '';
	foreach ($cats as $cat) {
		if ($cat->count > $max_count) {
			$max_count = $cat->count;
			$max_url = get_category_link($cat->cat_ID);
			$max_name = $cat->name;
		}
		if (!$cat->parent) {
			if (!$par_name) {
				$par_name = $cat->name;
				$par_url = get_category_link($cat->cat_ID);
			}
		} else {
			foreach($par_cats as $par_cat) {
				if ($par_cat->cat_ID == $cat->parent) {
					if (!$par_cat->parent) {
						$par_name = $par_cat->name;
						$par_url = get_category_link($par_cat->cat_ID);
						$child_name = $cat->name;
						$child_url = get_category_link($cat->cat_ID);
						break;
					}
				}
			}
		}
		if ($child_name) {
			break;
		}
	}
	if (!$child_name) {
		$par_name = $max_name;
		$par_url = $max_url;
	}
	$sep = '<span class="breadcrumbs-sep fa fa-angle-right"></span>';
	
	
	?>
	<div class="breadcrumbs single-breadcrumbs">
		<a href="<?php echo home_url(); ?>" itemprop="breadcrumb"><span class="color-hover"><?php echo __wpi('Home'); ?></span></a>
		<?php if ($par_name) : ?>
			<?php echo $sep; ?>
			<a href="<?php echo $par_url; ?>" itemprop="breadcrumb"><span class="color-hover"><?php echo $par_name; ?></span></a>
			<?php if ($child_name) : ?>
				<?php echo $sep; ?>
				<a href="<?php echo $child_url; ?>" itemprop="breadcrumb"><span class="color-hover"><?php echo $child_name; ?></span></a>
			<?php endif; ?>
		<?php endif; ?>
		<div class="clear"></div>
		
	</div>
	<?php
}
