<?php
global $wpi_pf_main_sidebar;
global $wpi_pf_small_sidebar;
global $wpi_pf_big_sidebar;
global $wpi_primary_class;
$wpi_pf_main_sidebar = 'content';
$wpi_pf_small_sidebar = 'small-sidebar';
$wpi_pf_big_sidebar = 'big-sidebar';
$wpi_primary_class = ' normal';
// sidebar settings
global $wpi_sidebar_list;
$wpi_sidebar_list = get_option('wpi_sidebar_list');

function wpi_primary_class() {
	global $wpi_pf_main_sidebar;
	global $wpi_pf_small_sidebar;
	global $wpi_pf_big_sidebar;
	global $wpi_primary_class;
	global $wpi_sidebar_list;
	if (is_singular() || 
		(function_exists('is_bbpress') && is_bbpress()) ||
		(function_exists('is_woocommerce') && is_woocommerce()) ||
		(function_exists('is_cart') && is_cart()) ||
		(function_exists('is_checkout') && is_checkout())
	) {
		if (have_posts()) {
			global $post;
			
			$wpi_pf_main_sidebar = get_post_meta($post->ID, 'wpi_pf_main_sidebar', true);
			$wpi_pf_small_sidebar = get_post_meta($post->ID, 'wpi_pf_small_sidebar', true);
			$wpi_pf_big_sidebar = get_post_meta($post->ID, 'wpi_pf_big_sidebar', true);
			if (is_single()) {
				$_wpi_pf_small_sidebar = get_option('wpi_posts_small_sidebar','');
				$_wpi_pf_big_sidebar = get_option('wpi_posts_big_sidebar', '');
				if ($_wpi_pf_small_sidebar && $_wpi_pf_small_sidebar != 'small-sidebar') {
					$wpi_pf_small_sidebar = $_wpi_pf_small_sidebar;
				}
				if ($_wpi_pf_big_sidebar && $_wpi_pf_big_sidebar != 'big-sidebar') {
					$wpi_pf_big_sidebar = $_wpi_pf_big_sidebar;
				}
			} 
			if (is_page()) {
				$_wpi_pf_small_sidebar = get_option('wpi_pages_small_sidebar','');
				$_wpi_pf_big_sidebar = get_option('wpi_pages__big_sidebar', '');
				if ($_wpi_pf_small_sidebar && $_wpi_pf_small_sidebar != 'small-sidebar') {
					$wpi_pf_small_sidebar = $_wpi_pf_small_sidebar;
				}
				if ($_wpi_pf_big_sidebar && $_wpi_pf_big_sidebar != 'big-sidebar') {
					$wpi_pf_big_sidebar = $_wpi_pf_big_sidebar;
				}
			}
			
			/*Forum*/
			if (function_exists('is_bbpress')) {
				if (is_bbpress()) {
					$wpi_pf_main_sidebar = 'content';
					$wpi_pf_small_sidebar = get_option('wpi_bbpress_small_sidebar', '');
					$wpi_pf_big_sidebar = get_option('wpi_bbpress_big_sidebar', '');
				}
			}
			/*shop*/
			if ((function_exists('is_woocommerce') && is_woocommerce()) ||
				(function_exists('is_cart') && is_cart()) ||
				(function_exists('is_checkout') && is_checkout())
			) {	
					$wpi_pf_main_sidebar = 'content';
					$wpi_pf_small_sidebar = get_option('wpi_woocommerce_small_sidebar', '');
					$wpi_pf_big_sidebar = get_option('wpi_woocommerce_big_sidebar', '');

			}
			
		}
	} else if (is_home()) {
		$wpi_pf_small_sidebar = get_option('wpi_home_small_sidebar', $wpi_pf_small_sidebar);
		$wpi_pf_big_sidebar = get_option('wpi_home_big_sidebar', $wpi_pf_big_sidebar);
	} else if (is_404()) {
		$wpi_pf_small_sidebar = get_option('wpi_404_small_sidebar', $wpi_pf_small_sidebar);
		$wpi_pf_big_sidebar = get_option('wpi_404_big_sidebar', $wpi_pf_big_sidebar);
	} else if (is_archive() || is_search()){
		$wpi_pf_small_sidebar = get_option('wpi_archives_small_sidebar', $wpi_pf_small_sidebar);
		$wpi_pf_big_sidebar = get_option('wpi_archives_big_sidebar', $wpi_pf_big_sidebar);
	}

	// set default sidebar if not set
	if (!($wpi_pf_main_sidebar)) {$wpi_pf_main_sidebar = 'content';}
	if (!($wpi_pf_small_sidebar)) {$wpi_pf_small_sidebar = 'small-sidebar';}
	if (!($wpi_pf_big_sidebar)) {$wpi_pf_big_sidebar = 'big-sidebar';}

	$wpi_default_sidebars = array(
		'main-sidebar' => 'Main Sidebar Default',
		'small-sidebar' => 'Small Sidebar Default',
		'small-disable' => 'Disable Small Sidebar',
		'big-sidebar'	=>	'Big Sidebar Default',
		'big-disable'	=>	'Disable Big Sidebar',
	);

	if (!is_array($wpi_sidebar_list) || empty($wpi_sidebar_list)) {
		$wpi_sidebar_list = $wpi_default_sidebars;
	} else {
		$wpi_sidebar_list = wp_parse_args($wpi_sidebar_list, $wpi_default_sidebars);
	}
	// prevent to in case the sidebar was deleted
	if (!isset($wpi_sidebar_list[$wpi_pf_main_sidebar])) {
		$wpi_pf_main_sidebar = 'content';	
	}
	if (!isset($wpi_sidebar_list[$wpi_pf_small_sidebar])) {
		$wpi_pf_small_sidebar = 'small-sidebar';	
	}
	if (!isset($wpi_sidebar_list[$wpi_pf_big_sidebar])) {
		$wpi_pf_big_sidebar = 'big-sidebar';	
	}
			
	if ($wpi_pf_small_sidebar === 'small-disable' && $wpi_pf_big_sidebar === 'big-disable') {
		$wpi_primary_class = ' both-disable';
	} else if ($wpi_pf_small_sidebar === 'small-disable') {
		$wpi_primary_class = ' small-disable';
	} else if ($wpi_pf_big_sidebar === 'big-disable') {
		$wpi_primary_class = ' big-disable';
	} 

}