<?php

function wpi_twitter_recent_entries($twitter_link, $count = 5) {
	$user = $twitter_link;
	if (strpos($user, '/') !== false) {
		$user = substr(strrchr($user, '/'), 1);
	}
	$key_html = 'twitter_page_html_' . $user;
	$response_html = '';
	// get in temporary
	$twitter_html = get_transient($key_html);

	if ($twitter_html === false) {
		// if false, aks direct twitter
		$response = wp_remote_get($twitter_link, array('timeout' => WPI_REMOTE_TIMEOUT));
		if (is_wp_error($response)) {
			// get from latest successful
			$twitter_html = get_option($key_html);
			if ($twitter_html == false) {
				return $response_html;
			}
		} else {
			$twitter_html = $response['body'];
			set_transient($key_html, $twitter_html, 60*60*24); 
			update_option($key_html, $twitter_html); 
		}
	}
	mb_internal_encoding('UTF-8');
	mb_http_output('UTF-8');
	mb_http_input('UTF-8');
	mb_language('uni');
	mb_regex_encoding('UTF-8');
	
	// process twitter HTML
	// <p class="ProfileTweet-text
	$start = 0;
	$end = 0;
	$key_1 = '<p class="ProfileTweet-text';
	$key_2 = '</p>';
	for ($i = 0; $i < $count; $i++) {
		if ($start >= strlen($twitter_html)) {
			break;
		}
		$start = mb_strpos($twitter_html, $key_1, $start);
		if ($start === false) {
			break;
		}
		$end = mb_strpos($twitter_html, $key_2, $start);
		if ($end === false) {
			break;
		}
		$response_html .= '<li>'.mb_substr($twitter_html, $start, $end + strlen($key_2) - $start).'</li>';
		$twitter_html = mb_substr($twitter_html, $end + strlen($key_2));
	}
	
	if ($response_html) {
		$response_html = '<ul>'.$response_html.'</ul>';
	}
	
	// replace hash link
	if (mb_strpos($response_html, '/search?q=') !== false) {
		$response_html = str_replace('/search?q=', 'https://twitter.com/search?q=', $response_html);
	}
	
	return $response_html;
}

function wpi_twitter_fan_counter($twitter_link) {
	$user = $twitter_link;
	if (strpos($user, '/') !== false) {
		$user = substr(strrchr($user, '/'), 1);
	}
	$key = 'twitter_fan_counter_'.$user;
	$key_html = 'twitter_page_html_' . $user;
	$count = get_transient($key);
	if ($count === false) :
		$no_error = true;
		// If there's no cached version we ask Twitter
		$response_html = get_transient($key_html);
		if ($response_html === false) {
			
			$response = wp_remote_get($twitter_link, array('timeout' => WPI_REMOTE_TIMEOUT));
			if (is_wp_error($response)) {
				// In case Twitter is down we return the last successful count
				$response_html = get_option($key_html);
				if ($response_html == false) {
					$count = get_option($key);
					if ($count == false) {
						$count = '100+';
					}
					$no_error = false;
				}
			} else {
				$response_html = $response['body'];
				set_transient($key_html, $response_html, 60*60*24); 
				update_option($key_html, $response_html);
			}
		}
		// search base on HTML structure, 
		// mean you must update your lib when twitter update their UI
		
		if ($no_error) :
			$count = '100+';
			$search_key = array(
				'ProfileNav-item--followers',
				'<span class="ProfileNav-value"',
				'>',/*the result will return between this and the last*/
				'</span>',
			);
			$start = 0;
			$max = count($search_key) - 1;
			for ($i = 0; $i < $max; $i++) {
				$start = strpos($response_html, $search_key[$i], $start);
				if ($start === false) {
					break;
				}
			}
			
			if ($i >= $max) {
				$end = strpos($response_html, $search_key[$max], $start);
				if ($end !== false) {
					$start = $start + 1;
					$end = $end - $start;
					$count = substr($response_html, $start , $end );

					// Store the result in a transient, expires after 1 day
					// Also store it as the last successful using update_option
					set_transient($key, $count, 60*60*24);
					update_option($key, $count);
				}
			}
		endif; // no error when get response HTML
	endif; // can not get count from cache
	
	if ($count === false || $count == '100+') {
		$count = get_option($key);
		if ($count == false) {
			$count = '100+';
		}
	}
	return $count;
	
}
function wpi_facebook_fan_counter($facebook_link) {
	$user = $facebook_link;
	if (strpos($user, '/') !== false) {
		$user = substr(strrchr($user, '/'), 1);
	}
	if (strpos($user,'?') !== false) {
		// prevent ?rel=hl from facebook links
		$user = substr($user, strpos($user, '?')+1);
	}
	$key = 'facebook_fan_counter_'.$user;
	$count = get_transient($key);
	if ($count === false) {
		// If there's no cached version we ask facebook
		
		$response = wp_remote_get('http://graph.facebook.com/' . $user, array('timeout' => WPI_REMOTE_TIMEOUT));
		
		
		if (is_wp_error($response)) {
			// In case facebook is down we return the last successful count
			$count = get_option($key);
			if ($count == false) {
				$count = '100+';
			}
		}
		else {
			$json = json_decode(wp_remote_retrieve_body($response));
			if (property_exists($json, 'likes')) {
				$count = $json->likes;
				set_transient($key, $count, 60*60*24);
				update_option($key, $count);
			} else {
				$count = '100+';
			}
		}
	}
	return $count;
}
function wpi_youtube_fan_counter($youtube_link) {
	$user = $youtube_link;
	if (strpos($user, '/') !== false) {
		$user = substr(strrchr($user, '/'), 1);
	}
	if (strpos($user,'?') !== false) {
		// prevent ?rel=hl from facebook links
		$user = substr($user, strpos($user, '?')+1);
	}
	$key = 'youtube_fan_counter_'.$user;
	$count = get_transient($key);
	if ($count === false) {
		$response = wp_remote_get('http://gdata.youtube.com/feeds/api/users/'.$user.'?alt=json', array('timeout' => WPI_REMOTE_TIMEOUT));
		
		if (is_wp_error($response)) {
			// In case facebook is down we return the last successful count
			$count = get_option($key);
			if ($count == false) {
				$count = '100+';
			}
		}
		else {
			$count = '100+';
			$json = json_decode(wp_remote_retrieve_body($response));
			if (property_exists($json, 'entry')) {
				if (property_exists($json->entry, 'yt$statistics')) {
					if (property_exists($json->entry->{'yt$statistics'}, 'subscriberCount')) {
						$count = $json->entry->{'yt$statistics'}->subscriberCount;
						set_transient($key, $count, 60*60*24);
						update_option($key, $count);
					}
				}
				
			}
		}
	}
	return $count;
}
function wpi_instagram_fan_counter($instagram_link) {
	$user = $instagram_link;
	if (strpos($user, '/') !== false) {
		$user = substr(strrchr($user, '/'), 1);
	}
	$key = 'instagram_fan_counter_'.$user;
	$key_html = 'instagram_page_html_' . $user;
	$count = get_transient($key);
	if ($count === false) {
		$no_error = true;
		// If there's no cached version we ask Twitter
		$response_html = get_transient($key_html);
		if ($response_html === false) {
			
			$response = wp_remote_get($instagram_link, array('timeout' => WPI_REMOTE_TIMEOUT));
			if (is_wp_error($response)) {
				// In case Instagram is down we return the last successful count
				$response_html = get_option($key_html);
				if ($response_html == false) {
					$count = get_option($key);
					if ($count == false) {
						$count = '100+';
					}
					$no_error = false;
				}
			} else {
				$response_html = $response['body'];
				set_transient($key_html, $response_html, 60*60*24); 
				update_option($key_html, $response_html);
			}
		}

		if ($no_error) {
	
			$count = '100+';
			$sstr = '"followed_by":';
			$start = strpos($response_html,$sstr);
			if ($start !== false) {
				$end = strpos($response_html, ',', $start);
				if ($end !== false) {
					$count = substr($response_html, $start + strlen($sstr) , $end - ($start + strlen($sstr)));
					// Store the result in a transient, expires after 1 day
					// Also store it as the last successful using update_option
					set_transient($key, $count, 60*60*24);
					update_option($key, $count);
				}
			}
		}
	}
	if ($count === false || $count == '100+') {
		$count = get_option($key);
		if ($count == false) {
			$count = '100+';
		}
	}
	return $count;
}
function wpi_gplus_fan_counter($gplus_page_url) {
	$count = false;
	// process to get id
	$gplus_page_ids = explode('/', $gplus_page_url);
	$gplus_page_id = 0;
	foreach ($gplus_page_ids as $id) {
		if (is_numeric($id) && strlen($id) > 10) {
			$gplus_page_id = $id;
			break;
		} else if (strpos($id, '+') !== false) {
			$gplus_page_id = $id;
			break;
		}
	}
	$key = 'gplus_like_counter_'.$gplus_page_id;
	
	if ($gplus_page_id) {	
		$count = get_transient($key);
		if ($count === false) {
			$gplus_data_params = array(
				'method'    => 'POST',
				'sslverify' => false,
				'timeout'   => WPI_REMOTE_TIMEOUT,
				'headers'   => array( 'Content-Type' => 'application/json' ),
				'body'      => '[{"method":"pos.plusones.get","id":"p","params":{"nolog":true,"id":"https://plus.google.com/' . $gplus_page_id . '","source":"widget","userId":"@viewer","groupId":"@self"},"jsonrpc":"2.0","key":"p","apiVersion":"v1"}]'
			);
		
			// Get gplus data.
			$response = wp_remote_get( 'https://clients6.google.com/rpc', $gplus_data_params );
			
			if (is_wp_error($response) === false) {
				$json = json_decode( $response['body'], true );
				
				if (isset($json[0]['result']['metadata']['globalCounts']['count'])){
					$count = $json[0]['result']['metadata']['globalCounts']['count'];
					set_transient($key, $count, 60*60*24);
					update_option($key, $count);
				}
				// ------------------
			}
		}
	}
	if ($count === false) {
		// In case google is down we return the last successful count
		$count = get_option($key);
		if ($count == false) {
			$count = '100+';
		}
	}
	
		
	return $count;
}

function wpi_steam_fan_counter($steam_group_url){
	$count = false;
	// process to get id
	$steam_group_ids = explode('/groups/', $steam_group_url);
	
	if (count($steam_group_ids) < 2) {
		return '100+';
	}
	
	$steam_group_id = $steam_group_ids[1];
	if (empty($steam_group_id)) {
		return '100+';
	}
	$steam_group_url = 'http://steamcommunity.com/groups/'.$steam_group_id;
	$user = $steam_group_id;
	$key = 'steam_fan_counter_'.$user;
	$key_html = 'steam_page_html_' . $user;
	$count = get_transient($key);
	if ($count === false) {
		$no_error = true;
		// If there's no cached version we ask Twitter
		$response_html = get_transient($key_html);
		if ($response_html === false) {
			$response = wp_remote_get($steam_group_url, array('timeout' => WPI_REMOTE_TIMEOUT));
			if (is_wp_error($response)) {
				// In case Instagram is down we return the last successful count
				$response_html = get_option($key_html);
				if ($response_html == false) {
					$count = get_option($key);
					if ($count == false) {
						$count = '100+';
					}
					$no_error = false;
				}
			} else {
				$response_html = $response['body'];
				set_transient($key_html, $response_html, 60*60*24); 
				update_option($key_html, $response_html);
			}
		}

		if ($no_error) {
	
			$count = '100+';
			$sstr = 'count oversized">';
			$start = strpos($response_html,$sstr);
			if ($start !== false) {
				$end = strpos($response_html, '</', $start);
				if ($end !== false) {
					$count = substr($response_html, $start + strlen($sstr) , $end - ($start + strlen($sstr)));
					// Store the result in a transient, expires after 1 day
					// Also store it as the last successful using update_option
					set_transient($key, $count, 60*60*24);
					update_option($key, $count);
				}
			}
		}
	}
	if ($count === false || $count == '100+') {
		$count = get_option($key);
		if ($count == false) {
			$count = '100+';
		}
	}
	return $count;
}

function wpi_pinterest_fan_counter($pinterest_profile_url){
	$count = false;
	// process to get id
	$pinterest_profile_ids = explode('pinterest.com/', $pinterest_profile_url);
	
	if (count($pinterest_profile_ids) < 2) {
		return '100+';
	}
	$pinterest_profile_id = $pinterest_profile_ids[1];
	if (strpos($pinterest_profile_id, '/') !== false) {
		$pinterest_profile_id = substr($pinterest_profile_id, 0, strpos($pinterest_profile_id, '/'));
	}
	
	if (empty($pinterest_profile_id)) {
		return '100+';
	}
	
	$pinterest_profile_url = 'http://www.pinterest.com/'.$pinterest_profile_id.'/';
	
	$user = $pinterest_profile_id;
	$key = 'pinterest_fan_counter_'.$user;
	$key_html = 'pinterest_page_html_' . $user;
	$count = get_transient($key);
	if ($count === false) {
		$no_error = true;
		// If there's no cached version we ask Twitter
		$response_html = get_transient($key_html);
		if ($response_html === false) {
			$response = wp_remote_get($pinterest_profile_url, array('timeout' => WPI_REMOTE_TIMEOUT));
			if (is_wp_error($response)) {
				// In case Instagram is down we return the last successful count
				$response_html = get_option($key_html);
				if ($response_html == false) {
					$count = get_option($key);
					if ($count == false) {
						$count = '100+';
					}
					$no_error = false;
				}
			} else {
				$response_html = $response['body'];
				set_transient($key_html, $response_html, 60*60*24); 
				update_option($key_html, $response_html);
			}
		}

		if ($no_error) {
	
			$count = '100+';
			$sstr = '"pinterestapp:followers": "';
			$start = strpos($response_html,$sstr);
			if ($start !== false) {
				$end = strpos($response_html, '",', $start);
				if ($end !== false) {
					$count = substr($response_html, $start + strlen($sstr) , $end - ($start + strlen($sstr)));
					// Store the result in a transient, expires after 1 day
					// Also store it as the last successful using update_option
					set_transient($key, $count, 60*60*24);
					update_option($key, $count);
				}
			}
		}
	}
	if ($count === false || $count == '100+') {
		$count = get_option($key);
		if ($count == false) {
			$count = '100+';
		}
	}
	return $count;
}

function wpi_dribbble_fan_counter($dribbble_link) {
	$count = false;
	// process to get id
	$dribbble_profile_ids = explode('dribbble.com/', $dribbble_link);
	
	if (count($dribbble_profile_ids) < 2) {
		return '100+';
	}
	$dribbble_profile_id = $dribbble_profile_ids[1];
	if (strpos($dribbble_profile_id, '/') !== false) {
		$dribbble_profile_id = substr($dribbble_profile_id, 0, strpos($dribbble_profile_id, '/'));
	}
	
	if (empty($dribbble_profile_id)) {
		return '100+';
	}
	
	$dribbble_api_link = 'http://api.dribbble.com/players/'.$dribbble_profile_id.'/followers';
	
	$user = $dribbble_profile_id;
	$key = 'dribbble_fan_counter_'.$user;
	$key_html = 'dribbble_page_html_' . $user;
	$count = get_transient($key);
	if ($count === false) {
		$no_error = true;
		// If there's no cached version we ask Twitter
		$response_html = get_transient($key_html);
		if ($response_html === false) {
			$response = wp_remote_get($dribbble_api_link, array('timeout' => WPI_REMOTE_TIMEOUT));
			if (is_wp_error($response)) {
				// In case Instagram is down we return the last successful count
				$response_html = get_option($key_html);
				if ($response_html == false) {
					$count = get_option($key);
					if ($count == false) {
						$count = '100+';
					}
					$no_error = false;
				}
			} else {
				$response_html = $response['body'];
				set_transient($key_html, $response_html, 60*60*24); 
				update_option($key_html, $response_html);
			}
		}

		if ($no_error) {
	
			$count = '100+';
			$sstr = '"total":';
			$start = strpos($response_html,$sstr);
			if ($start !== false) {
				$end = strpos($response_html, ',', $start);
				if ($end !== false) {
					$count = substr($response_html, $start + strlen($sstr) , $end - ($start + strlen($sstr)));
					// Store the result in a transient, expires after 1 day
					// Also store it as the last successful using update_option
					set_transient($key, $count, 60*60*24);
					update_option($key, $count);
				}
			}
		}
	}
	if ($count === false || $count == '100+') {
		$count = get_option($key);
		if ($count == false) {
			$count = '100+';
		}
	}
	
	return $count;
}