<?php
function wpi_get_current_cart_info() {
    global $woocommerce;

    if ( get_option( 'woocommerce_tax_display_cart' ) == 'excl' || $woocommerce->customer->is_vat_exempt() ) {
        $subtotal = $woocommerce->cart->subtotal_ex_tax;
    }
    else {
        $subtotal = $woocommerce->cart->subtotal;
    }

    $items = 0;

    if (get_theme_mod( 'minicart-total-items' ) ) {
        foreach ( $woocommerce->cart->get_cart() as $item ) {
            $items += $item['quantity'];
        }
    }
    else {
        $items = count( $woocommerce->cart->get_cart() );
    }

    return array(
        $items,
        $subtotal,
        get_woocommerce_currency_symbol()
    );
}

function wpi_add_to_cart_success_ajax( $datas ) {
    global $woocommerce;

    list( $cart_items, $cart_subtotal, $cart_currency ) = wpi_get_current_cart_info();

    $datas['#wpi-mini-cart .cart-items-number'] = '<span class="cart-items-number background-color">' . $cart_items . '</span>';
	
    return $datas;
}
add_filter( 'add_to_cart_fragments', 'wpi_add_to_cart_success_ajax' );

function wpi_mini_cart() {
	if (!function_exists('is_woocommerce')) {
		return;
	}
	list( $cart_items, $cart_subtotal, $cart_currency ) = wpi_get_current_cart_info();
?>
<div id="wpi-mini-cart">
	<a class="wpi-mini-cart-button ease"><i class="fa fa-shopping-cart"></i>
		<span class="cart-items-number background-color"><?php echo $cart_items ?></span>
	</a>
	
	<div id="wpi-mini-cart-widget">
		<?php the_widget('WC_Widget_Cart'); ?>
	</div>
</div>
<?php
}
