<?php

function wpi_post_format_add_meta_box_render($post) {
	// custom sidebar option
	$wpi_sidebar_list = get_option('wpi_sidebar_list');
	$wpi_pf_main_sidebar = get_post_meta($post->ID, 'wpi_pf_main_sidebar', true);
	$wpi_pf_small_sidebar = get_post_meta($post->ID, 'wpi_pf_small_sidebar', true);
	$wpi_pf_big_sidebar = get_post_meta($post->ID, 'wpi_pf_big_sidebar', true);
	
	if (!($wpi_pf_main_sidebar)) {$wpi_pf_main_sidebar = 'content';}
	if (!($wpi_pf_small_sidebar)) {$wpi_pf_small_sidebar = 'small-sidebar';}
	if (!($wpi_pf_big_sidebar)) {$wpi_pf_big_sidebar = 'big-sidebar';}

	$wpi_default_sidebars = array(
		'main-sidebar' => 'Main Sidebar Default',
		'small-sidebar' => 'Small Sidebar Default',
		'small-disable' => 'Disable Small Sidebar',
		'big-sidebar'	=>	'Big Sidebar Default',
		'big-disable'	=>	'Disable Big Sidebar',
	);
	
	if (!is_array($wpi_sidebar_list) || empty($wpi_sidebar_list)) {
		$wpi_sidebar_list = $wpi_default_sidebars;
	} else {
		$wpi_sidebar_list = wp_parse_args($wpi_sidebar_list, $wpi_default_sidebars);
	}
	// prevent to in case the sidebar was deleted
	if (!isset($wpi_sidebar_list[$wpi_pf_main_sidebar])) {
			$wpi_pf_main_sidebar = 'content';	
	}
	if (!isset($wpi_sidebar_list[$wpi_pf_small_sidebar])) {
			$wpi_pf_small_sidebar = 'small-sidebar';	
	}
	if (!isset($wpi_sidebar_list[$wpi_pf_big_sidebar])) {
			$wpi_pf_big_sidebar = 'big-sidebar';	
	}
	
	?>
<table class="form-table"><tbody>

<?php
if ($wpi_sidebar_list && is_array($wpi_sidebar_list) && !empty($wpi_sidebar_list)) :
	?>
		<tr><h4><?php echo __wpi('Custom Sidebars. You can create custom sidebars at '); ?><a href="<?php echo admin_url('widgets.php'); ?>"><?php echo __wpi('Theme Widgets'); ?></a>.</h4></tr>
<tr>
	
	<!-- MAIN SIDE-BAR -->
	<td style="background: #f0f0f0;width: 50%;border: 1px solid #ddd;">
		<label for="wpi_pf_main_sidebar" style="font-size: 12px"><?php echo __wpi('Sidebar for Main Column')?></label><br/><br/>
		<select name="wpi_pf_main_sidebar">
		<option value="content" <?php if ($wpi_pf_main_sidebar == 'default') { echo 'selected="selected"';} ?>><?php echo __wpi('Page / Post Content'); ?></option>
	<?php
	foreach ($wpi_sidebar_list as $key => $value) :
		if ($value && (strpos($key, 'main-') !== false)) :
		?>
		<option value="<?php echo $key; ?>" <?php if ($wpi_pf_main_sidebar == $key) { echo 'selected="selected"';} ?>><?php echo $value; ?></option>
		<?php
		endif;
	endforeach;
	?>
	</select></td>
	
	<!-- SMALL SIDE-BAR -->
	<td style="width: 20%;background: #f8f8f8;border: 1px solid #ddd;">
		<label for="wpi_pf_small_sidebar" style="font-size: 12px"><?php echo __wpi('Sidebar for Small Column')?></label><br/><br/>
		<select name="wpi_pf_small_sidebar">
	<?php
	foreach ($wpi_sidebar_list as $key => $value) :
		if ($value && (strpos($key, 'small-') !== false)) :
		?>
		<option value="<?php echo $key; ?>" <?php if ($wpi_pf_small_sidebar == $key) { echo 'selected="selected"';} ?>><?php echo $value; ?></option>
		<?php
		endif;
	endforeach;
	?>
	</select></td>
	
	<!-- BIG SIDE-BAR -->
	<td style="width: 30%;background: #f0f0f0;border: 1px solid #ddd;">
		<label for="wpi_pf_big_sidebar" style="font-size: 12px"><?php echo __wpi('Sidebar for Big Column')?></label><br/><br/>
		<select name="wpi_pf_big_sidebar">
	<?php
	foreach ($wpi_sidebar_list as $key => $value) :
		if ($value && (strpos($key, 'big-') !== false)) :
		?>
		<option value="<?php echo $key; ?>" <?php if ($wpi_pf_big_sidebar == $key) { echo 'selected="selected"';} ?>><?php echo $value; ?></option>
		<?php
		endif;
	endforeach;
	?>
	</select></td>
	
</tr>
	<?php
endif;
?>
</tbody></table>
<input type="hidden" name="wpi_pf_nonce" value="<?php echo wp_create_nonce('wpi_pf'); ?>" />
	<?php
}