<?php

function wpi_singular_related_posts() {
	$count = get_theme_mod('num_related_posts');
	$duration = get_theme_mod('duration_related_posts');
	if (!is_numeric($count) || $count == '') {
		$count = 2;
	}

	$count = (int) $count;

	if ($count < 1) {
		return;
	}
	
	// save post for backup later
	global $post;
	$origin_post = $post;
	
	

	/*QUERY*/
	// common query
	$args = array (
		'ignore_sticky_posts' => true,
		'posts_per_page' => $count,
		'order' => 'DESC',
		'orderby' => 'rand',
		'post__not_in' => array($post->ID),
	);

	// time query
	if ($duration == 'year') {//1 year ago
		$args = wp_parse_args($args, array(
			'date_query' => array(
				array(
					'column' => 'post_date_gmt',
					'after' => '1 year ago',
				)
			),
		));
	} else if ($duration == 'month') {//1 month ago
		$args = wp_parse_args($args, array(
			'date_query' => array(
				array(
					'column' => 'post_date_gmt',
					'after' => '1 month ago',
				)
			),
		));
	} else if ($duration == 'week') {//1 week ago
		$args = wp_parse_args($args, array(
			'date_query' => array(
				array(
					'column' => 'post_date_gmt',
					'after' => '1 week ago',
				)
			),
		));
	}
	
	$args_tags = $args;
	$args_cate = $args;
	$tags = wp_get_post_tags($post->ID);  
	$cat_ids = wp_get_post_categories($post->ID);
	if ($tags) {  /*Get post from tags if post had at least 1 tag*/
		$tag_ids = array();  
		foreach($tags as $tag) {
			$tag_ids[] = $tag->term_id;  
		}
		$args_tags = wp_parse_args($args_tags, array('tag__in' => $tag_ids));
	} else if ($cat_ids) { /*in case empty tags, get from cate*/
		$args_cate = wp_parse_args($args_cate, array('category__in' => $cat_ids));
	}

	$my_query = new WP_Query( $args_tags );
	if (empty($tags) || ($my_query->have_posts() == false)) {
		wp_reset_postdata();
		$my_query = new WP_Query( $args_cate );
	}
	if ($my_query->have_posts() == false) {
		wp_reset_postdata();
		$my_query = new WP_Query( $args );
	}
	
	
	// Show HTML
	if ($my_query->have_posts()) : 
		// Show HTML
		echo '<div class="post-footer-box related-posts">';
		echo '<h3 class="sub-title sfont">'.__wpi('Similar artilces') . '</h3>';


		echo '<div class="outer"><ul class="content">';
		$counter = 0;

		while ( $my_query->have_posts() ) : $my_query->the_post();
			$pid = get_the_ID();
			// preparing rating
			$item_review = wpi_rating_item($pid);

			// preparing for flexible home layout output
			$item_img_large = '<a href="'.get_permalink().'" title="'.__('Click to read', THEME_DOMAIN).'" class="item-thumbnail large">'.wpi_get_post_image($pid, 'large', array('alt' => esc_attr(get_the_title()), 'title' => esc_attr(get_the_title()))).$item_review.'</a>';

			
				
			$item_title = '';
					$item_title .= '<h3 class="title"><a href="'.get_permalink().'" title="'. esc_attr(get_the_title()).'"><span class="inner color-hover">';
					$item_title .= '<i class="fa post-format-icon fa-';

					switch (get_post_format()) {
						case 'aside':
							break;
						case 'gallery':
							break;
						case 'link':
							break;
						case 'image':
							$item_title .= 'camera';
							break;
						case 'quote':
							break;
						case 'status':
							break;
						case 'video':
							$item_title .= 'video-camera';
							break;
						case 'audio':
							$item_title .= 'music';
							break;
						case 'chat':
							break;
						default:
							// standard format
							$item_title .= 'thumb-tack post-standard-icon';
							break;
					}
					$item_title .= '"></i> '.get_the_title().'</span></a></h3>';

			echo '<li class="item item-'.$counter.' item-'.(($counter==0)? 'first':'other').' item-'.(($counter%2)? 'odd':'even').(($counter%3)? '':' item-triple').'"><div class="inner">';
			
			// output item
			//echo $item_img_large.'<div class="main"><div class="main-inner">'.$item_title .$item_snip .'</div>'.$item_meta_2.'</div>';
			echo $item_img_large.'<div class="main"><div class="main-inner">'.$item_title .'</div>';

			
			$counter++;
			echo '<div class="clear"></div></div></li>';
		endwhile;
		echo '</ul></div><div class="clear"></div></div>';

	endif;
	wp_reset_postdata();

	$post = $origin_post;
}
