<?php
function wpi_rating_singular($pid) {
	//get information for rating
	$rating_type = get_post_meta($pid, 'wpi-rating-type', true);
	$rating_summary = get_post_meta($pid, 'wpi-rating-summary', true);
	$rating_feature_number = get_post_meta($pid, 'wpi_rating_features_number', true);
	$user_rating_total_value = get_post_meta($pid, 'wpi_user_rating_total_value', true);
	if (!$user_rating_total_value) {
		$user_rating_total_value = 0;
	}
	$user_rating_total_value = (int) $user_rating_total_value;
	if ($user_rating_total_value < 0) {
		$user_rating_total_value = 0;
	}
	if ($user_rating_total_value > 100) {
		$user_rating_total_value = 100;
	}
	$user_rating_total_votes = get_post_meta($pid, 'wpi_user_rating_total_votes', true);
	if (!$user_rating_total_votes) {
		$user_rating_total_votes = 0;
	}
	
	
	if ($rating_feature_number == '') {
		$rating_feature_number = 0;
	}
	$rating_feature_number = (int) $rating_feature_number;
	$rating_value = get_post_meta($pid, 'wpi_rating_value', true);
	if ($rating_value == '') {
		$rating_value = 0;
	}
	$rating_value = (float) $rating_value;
	
	$rating_stars_features_name = array();
	$rating_stars_features_value = array();
	$rating_point_features_name = array();
	$rating_point_features_value = array();
	$rating_percent_features_name = array();
	$rating_percent_features_value = array();

	if ($rating_type) {
		for ($i = 0; $i < $rating_feature_number; $i++) {
			if ($rating_type == 'stars') {
				$rating_stars_features_name = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-stars-feature-name_' . $i, true)),
					$rating_stars_features_name
				);
				$rating_stars_features_value = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-stars-feature-value_' . $i, true)),
					$rating_stars_features_value
				);
			} else if ($rating_type == 'percent') {
				$rating_percent_features_name = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-percent-feature-name_' . $i, true)),
					$rating_percent_features_name
				);
				$rating_percent_features_value = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-percent-feature-value_' . $i, true)),
					$rating_percent_features_value
				);
			} else if ($rating_type == 'point') {
				$rating_point_features_name = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-point-feature-name_' . $i, true)),
					$rating_point_features_name
				);
				$rating_point_features_value = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-point-feature-value_' . $i, true)),
					$rating_point_features_value
				);
			}
		}
	}

	?>
<?php if ($rating_type && $rating_value && $rating_feature_number) : ?>
<div class="post-review">
	<h3 class="sfont border-color color widget-title"><span class="border-color"><?php echo __wpi('Review'); ?></span><div class="clear"></div></h3>
	<div class="clear"></div>
	<div class="inner wpi-author-review">
		<div class="table"><div class="review-total-summary tr">
			<div class="review-value sfont td background-color">
				<?php 
				if ($rating_type == 'stars') {
					echo '<div class="item-review stars">
						<div class="stars-value">
							'.number_format($rating_value / 20, 1, '.', ' ').'
						</div>
						<div class="stars-bar">
							<div class="stars-backgound">
								<div class="text">&#9733;&#9733;&#9733;&#9733;&#9733;</div>
							</div>
							<div class="stars-active" style="width:'.$rating_value.'%">
								<div class="text">&#9733;&#9733;&#9733;&#9733;&#9733;</div>
							</div>
						</div>
					</div>';
				} else if ($rating_type == 'percent') {
					echo '<div class="item-review percent">
						'. ((int) $rating_value) .'%
					</div>';
				} else if ($rating_type == 'point') {
					echo '<div class="item-review point">
						'. number_format($rating_value / 10, 1, '.', ' ') .'
					</div>';
				}
				?>
			</div>
			
			<div class="review-summary td"><strong><?php echo __wpi('Summary'); ?>: </strong><?php echo $rating_summary; ?></div>
			
		</div></div><!-- review-total-summary --><!-- table -->
		<div class="clear"></div>
		<div class="review-items <?php echo $rating_type;?>-items">
			<?php 
			for ($i = 0; $i < $rating_feature_number; $i++) {
				echo '<div class="review-item item-'.$rating_type.'">';
				if ($rating_type == 'stars') {
					echo '<div class="value">
						<div class="stars-backgound">
							<div class="text">&#9733;&#9733;&#9733;&#9733;&#9733;</div>
						</div>
						<div class="stars-active" style="width:'.(((int) $rating_stars_features_value[$i]) * 20).'%">
							<div class="text color">&#9733;&#9733;&#9733;&#9733;&#9733;</div>
						</div>
					</div>
					<div class="name"> - '.$rating_stars_features_name[$i].'</div>';
				} else if ($rating_type == 'percent') {
					echo '<div class="name">
						'.$rating_percent_features_name[$i].' - <strong>'.$rating_percent_features_value[$i].'%</strong>
					</div>
					<div class="value-bar">
						<div class="active background-color" style="width: '.$rating_percent_features_value[$i].'%"></div>
					</div>';
				} else if ($rating_type == 'point') {
					echo '<div class="name">
						'.$rating_point_features_name[$i].' - <strong>'.$rating_point_features_value[$i].'</strong>
					</div>
					<div class="value-bar">
						<div class="active background-color" style="width: '.(((float) $rating_point_features_value[$i]) * 10).'%"></div>
					</div>';
				}
				echo '<div class="clear"></div></div>';
			}
			?>
		</div>
		<div class="clear"></div>
	</div>
	<div class="inner wpi-user-rating" data-pid="<?php echo $pid;?>" data-type="<?php echo $rating_type; ?>">
		<h4>
			<strong><?php echo __wpi('User Rating:'); ?></strong> <span class="wpi-total-user-rating-value"><?php
			if ($rating_type == 'stars') {
				echo number_format(((int) $user_rating_total_value) / 20, 2) . ' ' . __wpi('stars');
			} else if ($rating_type == 'percent') {
				echo ((int) $user_rating_total_value) . '%' ;
			} else {
				echo number_format(((int) $user_rating_total_value) / 10, 1);
			}
			?></span> (<span class="wpi-total-user-rating-votes"><?php
				echo $user_rating_total_votes;
				?></span> <?php echo __wpi('votes'); ?>). <span class="wpi-current-user-rating-wrapper" style="display:none"><strong><?php echo __wpi('You rated:'); ?></strong> <span class="wpi-current-user-rating">__</span></span></h4>
		<div class="review-items <?php echo $rating_type;?>-items">
			<div class="review-item item-<?php echo $rating_type; ?>">
			<?php if ($rating_type == 'stars') { ?>
				<div class="value">
					<div class="stars-backgound">
						<div class="text">&#9733;&#9733;&#9733;&#9733;&#9733;</div>
					</div>
					<div class="stars-active" style="width:<?php echo ((int) $user_rating_total_value); ?>%">
						<div class="text color">&#9733;&#9733;&#9733;&#9733;&#9733;</div>
					</div>
				</div>
			<?php } else { ?>
					<div class="value-bar">
						<div class="active background-color" style="width: <?php echo ((int) $user_rating_total_value); ?>%"></div>
					</div>
			<?php } ?>
			<div class="clear"></div></div>
		</div>
		<div class="clear"></div>	
	</div>
	
	<!-- Rating snippet -->
	<div class="hide">
	<?php if ($user_rating_total_value) : 
		$total_votes = $user_rating_total_votes + 1;
		$average_rating = ($user_rating_total_value * $user_rating_total_votes + $rating_value) / $total_votes;
	?>
	<div itemscope itemtype="http://data-vocabulary.org/Review-aggregate">
    <?php if (get_the_title($pid)): ?>
	<span itemprop="itemreviewed"><?php echo get_the_title($pid); ?></span>
	<?php endif; ?>
    <span itemprop="rating" itemscope itemtype="http://data-vocabulary.org/Rating">
		<span itemprop="average"><?php echo number_format($average_rating / 20, 1, '.', ' '); ?></span>
		<span itemprop="best">5</span>
    </span>
   <span itemprop="votes"><?php echo $total_votes; ?></span>
  </div> 
	<?php else: ?>

  <div itemscope itemtype="http://data-vocabulary.org/Review">
    <?php if (get_the_title($pid)): ?>
	<span itemprop="itemreviewed"><?php echo get_the_title($pid); ?></span>
	<?php endif; ?>
	
	<?php if (get_the_author()): ?>
		<span itemprop="reviewer"><?php echo get_the_author(); ?></span>
	<?php endif; ?>
		
	<?php if (get_the_date()): ?>
	<time itemprop="dtreviewed" datetime="<?php echo get_the_date('Y-m-d'); ?>"><?php echo get_the_date(); ?></time>
	<?php endif; ?>
	
	<?php if ($rating_summary): ?>
		<span itemprop="summary"><?php echo $rating_summary; ?></span>
	<?php endif; ?>
		
	<?php if (wpi_get_the_snippet()): ?>
	<span itemprop="description"><?php echo wpi_get_the_snippet(); ?></span>
	<?php endif; ?>

	<span itemprop="rating"><?php echo number_format($rating_value / 20, 1, '.', ' '); ?></span>

  </div>
	<?php endif; ?>
		</div><!-- end rating snippet -->
</div>

<?php endif; ?>

<?php
}

function wpi_rating_item($pid, $source = 'author') {
	$item_review = '';
	$rating_type = get_post_meta( $pid, 'wpi-rating-type', true);
	$rating_feature_num = '';
	$rating_value = '';
	
	if ($source == 'user') {
		$rating_feature_num = get_post_meta( $pid, 'wpi_user_rating_total_votes', true);
		$rating_value = get_post_meta( $pid, 'wpi_user_rating_total_value', true);
	} else {
		$rating_feature_num = get_post_meta( $pid, 'wpi_rating_features_number', true);
		$rating_value = get_post_meta( $pid, 'wpi_rating_value', true);
	}
	if (!$rating_type || 
		!$rating_feature_num ||
		!$rating_value) {
		return;
	}
	if ((is_numeric($rating_feature_num)) && 
		(is_numeric($rating_value))) {
		$rating_feature_num = (float) $rating_feature_num;
		$rating_value = (float) $rating_value;
		if ($rating_feature_num > 0 && $rating_feature_num > 0) {
			if ($rating_type == 'stars') {
				$item_review = '<span class="item-review stars background-color"><span class="item-review-inner">
					<span class="stars-backgound">
						<span class="text">&#9733;&#9733;&#9733;&#9733;&#9733;</span>
					</span>
					<span class="stars-active" style="width:'.$rating_value.'%">
						<span class="text">&#9733;&#9733;&#9733;&#9733;&#9733;</span>
					</span>
				</span></span>';
			} else if ($rating_type == 'percent') {
				$item_review = '<div class="item-review percent background-color sfont">
					'. ((int) $rating_value) .'%
				</div>';
			} else if ($rating_type == 'point') {
				$item_review = '<div class="item-review point background-color sfont">
					'. number_format(($rating_value/10), 1, '.', ' ').'
				</div>';
			}
		}
	}
	return $item_review;
}