<?php

function wpi_rating_add_meta_box_render($post) {
	$pid = $post->ID;
	$rating_type = get_post_meta($pid, 'wpi-rating-type', true);
	$rating_summary = get_post_meta($pid, 'wpi-rating-summary', true);
	$rating_feature_number = get_post_meta($pid, 'wpi_rating_features_number', true);
	if ($rating_feature_number == '') {
		$rating_feature_number = 0;
	}
	$rating_feature_number = (int) $rating_feature_number;
	$rating_stars_features_name = array();
	$rating_stars_features_value = array();
	$rating_point_features_name = array();
	$rating_point_features_value = array();
	$rating_percent_features_name = array();
	$rating_percent_features_value = array();

	if ($rating_type) {
		for ($i = 0; $i < $rating_feature_number; $i++) {
			if ($rating_type == 'stars') {
				$rating_stars_features_name = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-stars-feature-name_' . $i, true)),
					$rating_stars_features_name
				);
				$rating_stars_features_value = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-stars-feature-value_' . $i, true)),
					$rating_stars_features_value
				);
			} else if ($rating_type == 'percent') {
				$rating_percent_features_name = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-percent-feature-name_' . $i, true)),
					$rating_percent_features_name
				);
				$rating_percent_features_value = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-percent-feature-value_' . $i, true)),
					$rating_percent_features_value
				);
			} else if ($rating_type == 'point') {
				$rating_point_features_name = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-point-feature-name_' . $i, true)),
					$rating_point_features_name
				);
				$rating_point_features_value = wp_parse_args(
					array(get_post_meta($pid, 'wpi-rating-point-feature-value_' . $i, true)),
					$rating_point_features_value
				);
			}
		}
	}


	$rating_type_option_select_none = ($rating_type == '') ? ' selected="selected"' : '';
	$rating_type_option_select_stars = ($rating_type == 'stars') ? ' selected="selected"' : '';
	$rating_type_option_select_point = ($rating_type == 'point') ? ' selected="selected"' : '';
	$rating_type_option_select_percent = ($rating_type == 'percent') ? ' selected="selected"' : '';

	$rating_type_section_display_none = ($rating_type == '') ? 'style="display:none"' : '';
	$rating_type_section_display_stars = ($rating_type == 'stars') ? '' : ' style="display:none"';
	$rating_type_section_display_point = ($rating_type == 'point') ? '' : ' style="display:none"';
	$rating_type_section_display_percent = ($rating_type == 'percent') ? '' : ' style="display:none"';
	?>
	<div class="wpi-meta-box-content rating">
		<div class="section always-show">
			<div class="field wpi-rating-type">
				<label for="wpi-rating-type"><?php echo __wpi('Is product review?'); ?> :</label>

				<select name="wpi-rating-type">
					<option value=""<?php echo $rating_type_option_select_none; ?>>
						<?php echo __wpi('No'); ?>
					</option>
					<option value="stars"<?php echo $rating_type_option_select_stars; ?>>	
						<?php echo __wpi('Stars'); ?>
					</option>
					<option value="percent"<?php echo $rating_type_option_select_percent; ?>>
						<?php echo __wpi('Percentages'); ?>
					</option>
					<option value="point"<?php echo $rating_type_option_select_point; ?>>
						<?php echo __wpi('Points'); ?>
					</option>
				</select>
			</div>
		</div>


		<div class="section show-hide rating-stars"<?php echo $rating_type_section_display_stars; ?>>
			<h4 class="title"><strong><?php echo __wpi('Add star ratings for this product'); ?>:</strong></h4>
			<?php if ($rating_type == 'stars' && $rating_feature_number > 0) : ?>
				<?php for ($i = 0; $i < $rating_feature_number; $i++) : ?>
					<div class="field wpi-rating-stars-feature">
						<label for="wpi-rating-stars-feature-name_<?php echo $i; ?>"><?php echo __wpi('Feature name'); ?>:</span>
							<input type="text" name="wpi-rating-stars-feature-name_<?php echo $i; ?>" value="<?php echo $rating_stars_features_name[$i]; ?>"/>
							<select name="wpi-rating-stars-feature-value_<?php echo $i; ?>">
								<?php for ($j = 0; $j <= 5; $j++) : ?>
								<option value="<?php echo $j; ?>"<?php
									if (((int) $rating_stars_features_value[$i]) == $j) {
										echo ' selected="selected"';
									}
								?>><?php echo $j; ?> <?php echo __wpi('stars'); ?></option>
								<?php endfor; ?>
							</select>

							<a href="#do-delete" class="rating-field-delete button"><?php echo __wpi('Delete'); ?></a>
					</div>
				<?php endfor; ?>
			<?php else: ?>
				<div class="field wpi-rating-stars-feature">
					<label for="wpi-rating-stars-feature-name_0"><?php echo __wpi('Feature name'); ?>:</span>
						<input type="text" name="wpi-rating-stars-feature-name_0" value=""/>
						<select name="wpi-rating-stars-feature-value_0">
							<option value="0" selected="selected">0 <?php echo __wpi('stars'); ?></option>
							<option value="1">1 <?php echo __wpi('stars'); ?></option>
							<option value="2">2 <?php echo __wpi('stars'); ?></option>
							<option value="3">3 <?php echo __wpi('stars'); ?></option>
							<option value="4">4 <?php echo __wpi('stars'); ?></option>
							<option value="5">5 <?php echo __wpi('stars'); ?></option>
						</select>

						<a href="#do-delete" class="rating-field-delete button"><?php echo __wpi('Delete'); ?></a>
				</div>
			<?php endif; ?>
			<p><a href="#do-duplicate" class="rating-field-copy button"><?php echo __wpi('Add new feature'); ?></a></p>
			
		</div>

		<div class="section show-hide rating-percent"<?php echo $rating_type_section_display_percent; ?>>
			<h4 class="title"><strong><?php echo __wpi('Add percent ratings for this product'); ?>:</strong></h4>
			<?php if ($rating_type == 'percent' && $rating_feature_number > 0) : ?>
				<?php for ($i = 0; $i < $rating_feature_number; $i++) : ?>
					<div class="field wpi-rating-percent-feature">
						<label for="wpi-rating-percent-feature-name_<?php echo $i; ?>"><?php echo __wpi('Feature name'); ?>:</span>
						<input type="text" name="wpi-rating-percent-feature-name_<?php echo $i; ?>" value="<?php echo $rating_percent_features_name[$i];?>"/>
						<label for="wpi-rating-percent-feature-value_<?php echo $i; ?>">- <?php echo __wpi('Percent'); ?>:</span>
						<input type="text" name="wpi-rating-percent-feature-value_<?php echo $i; ?>" value="<?php echo $rating_percent_features_value[$i];?>"/>
						<a href="#do-delete" class="rating-field-delete button"><?php echo __wpi('Delete'); ?></a>
					</div>
				<?php endfor; ?>
			<?php else: ?>
				<div class="field wpi-rating-percent-feature">
					<label for="wpi-rating-percent-feature-name_0"><?php echo __wpi('Feature name'); ?>:</span>
					<input type="text" name="wpi-rating-percent-feature-name_0" value=""/>
					<label for="wpi-rating-percent-feature-value_0">- <?php echo __wpi('Percent'); ?>:</span>
					<input type="text" name="wpi-rating-percent-feature-value_0" value=""/>
					<a href="#do-delete" class="rating-field-delete button"><?php echo __wpi('Delete'); ?></a>
				</div>
			<?php endif; ?>
			<p><a href="#do-duplicate" class="rating-field-copy button"><?php echo __wpi('Add new feature'); ?></a></p>
		</div>

		<div class="section show-hide rating-point"<?php echo $rating_type_section_display_point; ?>>
			<h4 class="title"><?php echo __wpi('Add point ratings for this product'); ?>:</h4>
			<?php if ($rating_type == 'point' && $rating_feature_number > 0) : ?>
				<?php for ($i = 0; $i < $rating_feature_number; $i++) : ?>
					<div class="field wpi-rating-point-feature">
						<label for="wpi-rating-point-feature-name_<?php echo $i; ?>"><?php echo __wpi('Feature name'); ?>:</span>
						<input type="text" name="wpi-rating-point-feature-name_<?php echo $i; ?>" value="<?php echo $rating_point_features_name[$i];?>"/>
						<label for="wpi-rating-point-feature-value_<?php echo $i; ?>">- <?php echo __wpi('Point'); ?>:</span>
						<input type="text" name="wpi-rating-point-feature-value_<?php echo $i; ?>" value="<?php echo $rating_point_features_value[$i];?>"/>
						<a href="#do-delete" class="rating-field-delete button"><?php echo __wpi('Delete'); ?></a>
					</div>
				<?php endfor; ?>
			<?php else: ?>
				<div class="field wpi-rating-point-feature">
					<label for="wpi-rating-point-feature-name_0"><?php echo __wpi('Feature name'); ?>:</span>
					<input type="text" name="wpi-rating-point-feature-name_0" value=""/>
					<label for="wpi-rating-point-feature-value_0">- <?php echo __wpi('Point'); ?>:</span>
					<input type="text" name="wpi-rating-point-feature-value_0" value=""/>
					<a href="#do-delete" class="rating-field-delete button"><?php echo __wpi('Delete'); ?></a>
				</div>
			<?php endif; ?>
			<p><a href="#do-duplicate" class="rating-field-copy button"><?php echo __wpi('Add new feature'); ?></a></p>
			
		</div>


		<div class="section show-hide rating-summary"<?php echo $rating_type_section_display_none; ?>>
			<h4 class="title"><?php echo __wpi('Review Summary'); ?>:</h4>
			<div class="field wpi-rating-summary">
				<textarea style="width: 50%;height: 100px" type="text" name="wpi-rating-summary"><?php echo $rating_summary; ?></textarea>
			</div>
		</div>
	</div><!--wpi-meta-box-content rating-->
	<input type="hidden" name="wpi_rating_nonce" value="<?php echo wp_create_nonce('wpi_rating'); ?>" />
	
	<?php if (($rating_type != '') && ($rating_feature_number > 0)) {
		echo '<input type="hidden" name="wpi_rating_features_number" value="'.$rating_feature_number.'" />';
	} else {
		echo '<input type="hidden" name="wpi_rating_features_number" value="1" />';
	}
}
									