<?php
add_shortcode('contact', 'contact_handler');

function contact_handler($atts, $content=null, $code="") {
	
	$RES_HTML = '';
	extract(shortcode_atts(array(
		'target_email' => '',
		'nocaptcha' => ''), $atts));

	$mail_to = get_option( 'admin_email' ); 
	if ($target_email) {
		$mail_to = $target_email;
	}
	$website = '';
	$email = '';
	$u_name = '';
	$message = '';
	$captcha = '';

	// get contact message
	if(isset($_POST["website"])){
		$website=sanitize_text_field($_POST["website"]);
	}
	if(isset($_POST["email"])){
		$email=sanitize_text_field($_POST["email"]);
	}
	if(isset($_POST["u_name"])){
		$u_name=sanitize_text_field($_POST["u_name"]);
	}
	if(isset($_POST["message"])){
		$message=sanitize_text_field($_POST["message"]);
	}
	if(isset($_POST["captcha"])){
		$captcha=sanitize_text_field($_POST["captcha"]);
	}

	$ip = $_SERVER['REMOTE_ADDR'];

	$before="<tr><td colspan=\"2\"><div class=\"top-error-message\">";
	$after="</div></td></tr>";
	$error="";
	// check error
	if(isset($_POST["addnew"])){
		$addnew=$_POST["addnew"];

		// show error message when submit form

		if($addnew)
		{
			if(!$u_name) {
				$error.=$before.( __wpi( 'Please enter your name!' )).$after;
			}
			if(!$email) {
				$error.=$before.( __wpi( 'Please enter your e-mail!' )).$after;
			}
			if($email && !preg_match("/@/i", "$email")) {
				$error.=$before.( __wpi( 'Please enter a valid e-mail!' )).$after;
			}
			if(!$message) {
				$error.=$before.( __wpi( 'Please enter your message!' )).$after;
			}
		}
		if (!$nocaptcha) {
			// check captcha code
			//$valid_captcha = get_transient('captcha_code');
			$valid_captcha = get_option('captcha_code');
			/*
			$captcha_code = '';
			for ($i = 0; $i < 5; $i++) {
				// this numbers refer to numbers of the ascii table (lower case)
				$captcha_code .= chr(rand(97, 122));
			}
			// allow captcha code in 10 mins
			//set_transient('captcha_code', $captcha_code, 60*10);
			update_option('captcha_code', $captcha_code);
			 */
			if ($valid_captcha != $captcha) {
				$error.=$before.( __wpi( 'Wrong captcha!' )).$after;
			}
		}
	}


	// is submit message and has no error, then send email
	if((isset($addnew) && !$error)) :

		$subject = ( __wpi( 'From' ))." ".get_bloginfo('name')." ".( __wpi( 'Contact Page' ));

		$eol="\n";
		$mime_boundary=md5(time());
		$headers = "From: ".$email." <".$email.">".$eol;
		//$headers .= "Reply-To: ".$email."<".$email.">".$eol;
		$headers .= "Message-ID: <".time()."-".$email.">".$eol;
		$headers .= "X-Mailer: PHP v".phpversion().$eol;
		$headers .= 'MIME-Version: 1.0'.$eol;
		$headers .= "Content-Type: text/html; charset=UTF-8; boundary=\"".$mime_boundary."\"".$eol.$eol;
		
		ob_start(); 
	?>
<?php printf ( __wpi( 'Message:' ));?> <?php echo $message;?>
<div style="padding-top:100px;">
<?php printf ( __wpi( 'Name:' ));?> <?php echo $u_name;?><br/>
<?php printf ( __wpi( 'Website:' ));?> <?php echo $website;?><br/>
<?php printf ( __wpi( 'E-mail:' ));?> <?php echo $email;?><br/>
<?php printf ( __wpi( 'IP Address:' ));?> <?php echo $ip;?><br/>
</div>
	<?php
		$message = ob_get_clean();
		$wpi_contact_counter = get_option('wpi_contact_counter');
		if ($wpi_contact_counter) {
			$wpi_contact_counter = (int) $wpi_contact_counter;
		} else {
			$wpi_contact_counter = 0;
		}
		if ($wpi_contact_counter && (int) $wpi_contact_counter == 2) {
			wp_mail($mail_to,$subject,$message,$headers);
			update_option('wpi_contact_counter', 0);
		} else {
			$wpi_contact_counter++;
			update_option('wpi_contact_counter', $wpi_contact_counter);
		}
		
	endif;// check add new && error

	?>

<?php // javascript for validate form ?>

<?php 

$RES_HTML = '
<scr'.'ipt type="text/javascript">
		
	function Validate() 
	{

		var errors = "";
		var reason_name = "";
		var reason_mail = "";
		var reason_message = "";


		reason_name += validateName(document.getElementById("contact-form").u_name);
		reason_mail += validateEmail(document.getElementById("contact-form").email);
		reason_message += validateMessage(document.getElementById("contact-form").message);



		if (reason_name != "") 
		{
			jQuery("#name_error").text(reason_name).fadeIn(1000);
			jQuery("#name_input").addClass("input-error-1");
			document.getElementById("name_error").style.display = "block";
			errors = "Error";
		}
		else{
			jQuery("#name_input").removeClass("input-text-1-error");
			document.getElementById("name_error").style.display = "none";
		}


		if (reason_mail != "") 
		{
			jQuery("#mail_error").text(reason_mail).fadeIn(1000);
			jQuery("#mail_input").addClass("input-error-1");
			document.getElementById("mail_error").style.display = "block";
			errors = "Error";
		}
		else{
			jQuery("#mail_input").removeClass("input-text-1-error");
			document.getElementById("mail_error").style.display = "none";
		}
		
		if (reason_message != "") 
		{
			jQuery("#message_error").text(reason_message).fadeIn(1000);
			jQuery("#message_input").addClass("input-error-1");
			document.getElementById("message_error").style.display = "block";
			errors = "Error";
		}
		else{
			jQuery("#message_input").removeClass("input-text-1-error");
			document.getElementById("message_error").style.display = "none";
		}
		
		if (errors != ""){
			return false;
		}
		
		document.getElementById("contact-form").submit(); return false;
	}
	
		function validateName(fld) 
	{

		var error = "";
		
		if (fld.value == "")
		{
			error = "'. __wpi( "You did not enter your name." ) .'\n";
		}
		else if ((fld.value.length < 2) || (fld.value.length > 50))
		{
			error = "'. __wpi( "Name has a wrong length." ) .'\n";
		}


		return error;
	}
	
		function validateEmail(fld) 
	{

		var error="";
		var illegalChars = /^[^@]+@[^@.]+\.[^@]*\w\w$/;
		
		if (fld.value == ""){
			error = "'. __wpi( "You did not enter email address." ) .'\n";
		}
		else if ( fld.value.match( illegalChars ) == null){
			error = "'. __wpi( "The email address contains illegal characters." ).'\n";
		}


		return error;

	}
	
	function validateMessage(fld) 
	{

		var error = "";
		
		if (fld.value == "")
		{
			error = "'. __wpi( "You did not enter message." ).'\n";
		}
		else if (fld.value.length<3)
		{
			error = "'. __wpi( "The message is to short." ).'\n";
		}


		return error;
	}

		
	</script>';
	
?>

	
					
	<?php if(!isset($addnew) || $error) :?>

	<?php
	update_option('wpi_contact_counter', 0);
	$RES_HTML .= '
	<form method="post" class="contact-form" id="contact-form" name="contact-form" action="">
		<input type="hidden"  name="addnew" value="yes" />
		<table>	
			'. $error.'
			<tr>
				<td class="label">'. __wpi( 'Name' ).'</td>
				<td>
					<div class="input-error-1-label error-message" id="name_error" style="display: none;"></div>
					<input type="text" name="u_name" value="'. $u_name.'" class="input-text-1" id="name_input" />

				</td>
			</tr>
			<tr><td class="spacer-1" colspan="2"></td></tr>
			<tr>
				<td class="label">'. __wpi( 'E-mail' ).'</td>
				<td>
					<div class="input-error-1-label error-message" id="mail_error" style="display: none;"></div>
					<input type="text" name="email" value="'. $email.'" class="input-text-1" id="mail_input"/>

				</td>
			</tr>
			<tr><td class="spacer-1" colspan="2"></td></tr>
			<tr>
				<td class="label">'. __wpi( 'Website' ).'</td>
				<td>
					<input type="text" name="website" value="'. $website.'" class="input-text-1"/>
				</td>
			</tr>
			<tr><td class="spacer-1" colspan="2"></td></tr>
			<tr>
				<td class="label">'. __wpi( 'Comment' ).'</td>
				<td>
					<div class="input-error-1-label error-message" id="message_error" style="display: none;"></div>
					<textarea name="message" id="message_input" class="text-area-1">'. $message.'</textarea>

				</td>
			</tr>';
		if (!$nocaptcha) {


			$RES_HTML .= '<tr><td class="spacer-1" colspan="2"></td></tr>
			<tr>
				<td class="label">'. __wpi( 'Captcha' ).'</td>
				<td>
					<div class="input-error-1-label error-message" id="message_error" style="display: none;"></div>
					<input type="text" name="captcha" value="" class="input-text-1"/>
					<div><img src="'.  admin_url( 'admin-ajax.php' ).'?action=wpi_captcha"/></div>
				</td>
			</tr>';
		}
			$RES_HTML .= '<tr><td class="spacer-1" colspan="2"></td></tr>
			<tr>
				<td></td>
				<td> 
					<p class="show-all"><a href="javascript:{}" onclick="return Validate(); submitform();" class="background-color sfont"><span>'. __wpi( 'Send contact form' ).'</span></a></p>

				</td>
			</tr>
		</table>
	</form>'; 

	?>

	<?php endif;//addnew_error ?>	

	<?php if(isset($addnew) && !$error) : ?>
		<?php
		$RES_HTML .= '<div class="contact-success">
			<p><span>'. __wpi( 'Thanks!' ).'</span></p>
			<p>'. __wpi( 'Your message has been sent!' ).'</p>
		</div>'; 

		?>
	<?php endif; // addnew_error ?>
												

<?php 
	return $RES_HTML;
}