<?php

/*THEME SETUP*/
global $wpi_social_names;
$wpi_social_names = array(
	'twitter'			=> 'Twitter',
	'facebook' 			=> 'Facebook',
	'google-plus' 		=> 'Google Plus',
	'pinterest' 		=> 'Pinterest',
	'rss'				=> 'RSS',
	'tumblr' 			=> 'Tumblr',
	'instagram'			=> 'Instagram',
	'flickr' 			=> 'Flickr',
	'youtube' 			=> 'Youtube',
	'vimeo-square'		=> 'Vimeo',
	'linkedin'			=> 'Linkedin',
	'dribbble' 			=> 'Dribbble',
	'dropbox' 			=> 'Dropbox',
	'skype' 			=> 'Skype',
	'foursquare'		=> 'Foursquare',
	'weibo' 			=> 'Weibo',
	'xing' 				=> 'Xing',
	'github' 			=> 'Github',
	'gittip' 			=> 'Gittip',
	'stack-exchange' 	=> 'Stack Exchange',
	'stack-overflow' 	=> 'Stack Overflow',
	'maxcdn' 			=> 'Maxcdn',
	'css3' 				=> 'CSS3',
	'html5' 			=> 'HTML5',
	'adn' 				=> 'Adn',
	'android' 			=> 'Android',
	'apple' 			=> 'Apple',
	'bitbucket' 		=> 'Bitbucket',
	'btc' 				=> 'Bitcoins',
	'linux' 			=> 'Linux',
	'pagelines' 		=> 'Pagelines',
	'renren' 			=> 'Renren',
	'trello' 			=> 'Trello',
	'vk' 				=> 'Vk',
	'windows' 			=> 'Windows',
	'globe'				=> 'Website'
);

global $wpi_social_links;
$wpi_social_links = get_option('wpi_social_links');
if (!$wpi_social_links) { /*init for the first time launching theme*/
	$wpi_social_links = $wpi_social_names;
	foreach ($wpi_social_links as $key => $value) {
		$wpi_social_links[$key] = '';
	}
	update_option('wpi_social_links', $wpi_social_links);
} else if (count($wpi_social_links) != count($wpi_social_names)) { /*in case developer update social names*/
	foreach ($wpi_social_names as $key => $value) {
		if (!isset($wpi_social_links[$key])) {
			$wpi_social_links[$key] = '';
		}
		if (!isset($wpi_social_names[$key])) {
			unset($wpi_social_links[$key]);
		}
	}
	update_option('wpi_social_links', $wpi_social_links);
}


/*
 * Set up the content width value based on the theme's design.
 *
 */
if ( ! isset( $content_width ) ) {
	$content_width = 490;
}

function theme_basic_setup() {
	// http://codex.wordpress.org/Function_Reference/load_theme_textdomain
	load_theme_textdomain( THEME_DOMAIN, get_template_directory() . '/languages' );

	// http://codex.wordpress.org/Function_Reference/add_editor_style
	add_editor_style( THEME_URL_CSS . 'editor.css' );
	
	add_theme_support( 'woocommerce' );
	
	// http://codex.wordpress.org/Function_Reference/add_theme_support
	// http://codex.wordpress.org/Post_Formats
	add_theme_support( 'post-formats', array(/*'aside','gallery', 'link',*/ 'image', /*'quote', 'status',*/ 'video', 'audio',/* 'chat'*/));
	
	
	// http://codex.wordpress.org/Post_Thumbnails
	// http://codex.wordpress.org/Function_Reference/set_post_thumbnail_size
	// http://codex.wordpress.org/Function_Reference/add_image_size
	add_theme_support( 'post-thumbnails' );
	set_post_thumbnail_size( 150, 9999 );
	add_image_size( 'large', 500, 9999 ); 
	add_image_size( 'medium', 300, 9999 );
	add_image_size( 'thumbnail', 150, 9999 );

	add_theme_support( 'automatic-feed-links' );
}	
add_action( 'after_setup_theme', 'theme_basic_setup' );


/**
 * Enqueue scripts and styles for the front end.
 *
 */
function enqueue_scripts_styles() {
	global $wp_styles;
	global $opt_lang_dir;
	
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-ui-widget');
	wp_enqueue_script('jquery-ui-tabs');
	wp_enqueue_script('jquery-ui-accordion');
	
	// Adds JavaScript to pages with the comment form to support
	// sites with threaded comments (when in use).
	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
	
	// Loads JavaScript file with functionality specific
	wp_enqueue_script( THEME_DOMAIN . '-lib', THEME_URL_JS . 'lib.js', array( 'jquery' ), THEME_VERSION, true );
	if (get_theme_mod('disable_responsive') != true) {
		if (get_theme_mod('responsive_nav') === 'select' || 
			get_theme_mod('responsive_nav') === '' ||
			get_theme_mod('responsive_nav') == false) {
			wp_enqueue_script( THEME_DOMAIN . '-selectnav', THEME_URL_JS . 'jquery.plugin.selectnav.js', array( 'jquery' ), THEME_VERSION, true );
		} else if (get_theme_mod('responsive_nav') === 'dropdown') {
			wp_enqueue_script( THEME_DOMAIN . '-dropdownnav', THEME_URL_JS . 'jquery.plugin.dropdownnav.js', array( 'jquery' ), THEME_VERSION, true );
		}
	}

	wp_enqueue_script( THEME_DOMAIN . '-ticker', THEME_URL_JS . 'jquery.plugin.ticker.js', array( 'jquery' ), THEME_VERSION, true );
	wp_enqueue_script( THEME_DOMAIN . '-slider', THEME_URL_JS . 'jquery.plugin.slider.js', array( 'jquery' ), THEME_VERSION, true );
	wp_enqueue_script( THEME_DOMAIN . '-carousel', THEME_URL_JS . 'jquery.plugin.carousel.js', array( 'jquery' ), THEME_VERSION, true );
	
	wp_enqueue_script( THEME_DOMAIN . '-two-grid', THEME_URL_JS . 'jquery.auto.two.grid.js', array( 'jquery' ), THEME_VERSION, true );
	
	
	wp_enqueue_script( THEME_DOMAIN . '-site', THEME_URL_JS . 'site.js', array( 'jquery', 'jquery-ui-tabs', 'jquery-ui-accordion' , THEME_DOMAIN.'-lib', THEME_DOMAIN.'-ticker', THEME_DOMAIN.'-slider' ), THEME_VERSION, true );
	
	wp_enqueue_script( THEME_DOMAIN . '-thumbnail', THEME_URL_JS . 'thumbnail.js', array( 'jquery', THEME_DOMAIN.'-site'), THEME_VERSION, true );
	
	wp_enqueue_script( THEME_DOMAIN . '-article-box-pagination', THEME_URL_JS . 'ajax.article_box.js', array( 'jquery', THEME_DOMAIN.'-lib', THEME_DOMAIN . '-thumbnail'), THEME_VERSION, true );
	
	if (is_singular()) {
		wp_enqueue_script( THEME_DOMAIN . '-ajax-comment', THEME_URL_JS . 'ajax.comment.js', array( 'jquery', THEME_DOMAIN.'-lib'), THEME_VERSION, true );
		wp_enqueue_script( THEME_DOMAIN . '-ajax-rating', THEME_URL_JS . 'rating/ajax.rating.js', array( 'jquery', THEME_DOMAIN.'-lib'), THEME_VERSION, true );
		if (get_theme_mod('enable_lightbox')) {
			add_thickbox();
		}
	}
	
	
	
	$wpi_dynamic_js = array(
		'ticker_animation_speed' => get_theme_mod('ticker_animation_speed'),
		'ticker_pause_time' => get_theme_mod('ticker_pause_time'),
		'ticker_animation_type' => get_theme_mod('ticker_animation_type'),
		'slider_animation_speed' => get_theme_mod('slider_animation_speed'),
		'slider_pause_time' => get_theme_mod('slider_pause_time'),
		'slider_animation_type' => get_theme_mod('slider_animation_type'),
		'twitter_roll_animation_speed' => get_theme_mod('twitter_roll_animation_speed'),
		'twitter_roll_pause_time' => get_theme_mod('twitter_roll_pause_time'),
		'txt_loadmore' => __wpi('Load More'),
		'txt_newernews' => __wpi('Newer'),
		'txt_oldernews' => __wpi('Older'),
		'theme_url' => get_template_directory_uri(),
		'theme_css' => THEME_URL_CSS,
		'home_url' => get_home_url(),
		'ajaxurl' => admin_url( 'admin-ajax.php' ),
		'date_format' => get_option('date_format'),
		'txt_month' => array(
				'january' => __wpi('January'),    
				'february' => __wpi('February'),
				'march' => __wpi('March'),
				'april' => __wpi('April'),
				'may' => __wpi('May'),
				'june' => __wpi('June'),
				'july' => __wpi('July'),
				'august' => __wpi('August'),
				'september' => __wpi('September'),
				'october' => __wpi('October'),
				'november' => __wpi('November'),
				'december' => __wpi('December')
		),
		'txtforumsearch' => __wpi('Search Forums Topics'),
	);
		
		
	
	wp_localize_script( 'jquery', 'wpi_dynamic_js', $wpi_dynamic_js);


	// Loads our main stylesheets.
	wp_enqueue_style( THEME_DOMAIN . '-font-awesome', THEME_URL_FONTS . 'font-awesome/css/font-awesome.min.css', array(), THEME_VERSION );
	wp_enqueue_style( THEME_DOMAIN . '-style', THEME_URL . '/style.css', array(), THEME_VERSION );
	wp_enqueue_style( THEME_DOMAIN . '-widgets', THEME_URL_CSS . 'widgets.css', array(), THEME_VERSION );
	wp_enqueue_style( THEME_DOMAIN . '-article-box', THEME_URL_CSS . 'article-box.css', array(), THEME_VERSION );
	wp_enqueue_style( THEME_DOMAIN . '-shortcodes', THEME_URL_CSS . 'shortcodes.css', array(THEME_DOMAIN . '-style'), THEME_VERSION );
	
	if (get_theme_mod('disable_responsive') != true) {
		wp_enqueue_style( THEME_DOMAIN . '-responsive', THEME_URL_CSS . 'responsive.css', array(THEME_DOMAIN . '-style'), THEME_VERSION );
	}
	
	if ($opt_lang_dir) {
		wp_enqueue_style( THEME_DOMAIN . '-rtl', THEME_URL_CSS . 'rtl.css', array(THEME_DOMAIN . '-style'), THEME_VERSION );
	}
	wp_enqueue_style( THEME_DOMAIN . '-print', THEME_URL_CSS . 'print.css', array(THEME_DOMAIN . '-style'), THEME_VERSION );
	
	// Loads the Internet Explorer specific stylesheet.
	wp_enqueue_style( THEME_DOMAIN . '-ie', THEME_URL_CSS . 'ie.css', array( THEME_DOMAIN.'-style' ), THEME_VERSION );
	
	if (function_exists('wp_style_add_data')) {
		wp_style_add_data( THEME_DOMAIN . '-ie', 'conditional', 'lt IE 9' );
	} else {
		$wp_styles->add_data( THEME_DOMAIN . '-ie', 'conditional', 'lt IE 9' );
	}
	
	
	if (get_theme_mod('theme_switcher')) {
		wp_enqueue_style( THEME_DOMAIN . '-theme_switcher', THEME_URL_CSS . 'theme_switcher.css', array(THEME_DOMAIN . '-font-awesome'), THEME_VERSION );
		wp_enqueue_script( THEME_DOMAIN . '-theme_switcher', THEME_URL_JS . 'theme_switcher.js', array('jquery'), THEME_VERSION, true );
	}
	
	/*Forum*/
	if (function_exists('is_bbpress')) {
		wp_enqueue_style( THEME_DOMAIN . '-bbpress', THEME_URL_CSS . 'bbpress.css', THEME_VERSION );
		wp_enqueue_script( THEME_DOMAIN . '-bbpress', THEME_URL_JS . 'bbpress.js', array( 'jquery'), THEME_VERSION, true );
	}
	
	/*Shop*/
	if (function_exists('is_woocommerce')) {
		wp_enqueue_style( THEME_DOMAIN . '-woocommerce', THEME_URL_CSS . 'woocommerce.css', THEME_VERSION );
		wp_enqueue_script( THEME_DOMAIN . '-woocommerce', THEME_URL_JS . 'woocommerce.js', array( 'jquery'), THEME_VERSION, true );
	}
}
add_action( 'wp_enqueue_scripts', 'enqueue_scripts_styles' );

/*Admin enqueue*/
function enqueue_admin_scripts_styles($page) {
	if ($page === 'tools_page_codestyling-localization/codestyling-localization') {
		return;
	}
	// enqueue for admin common
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-ui-widget');
	wp_enqueue_script('jquery-ui-tabs');
	wp_enqueue_script('jquery-ui-accordion');
	wp_enqueue_script('jquery-ui-dialog');
	wp_enqueue_script( 'wp-color-picker' );
	
	$wpi_admin_js = array(
		'loading_image' => THEME_URL_IMG . 'loading.gif'
	);
	wp_localize_script( 'jquery', 'wpi_admin_js', $wpi_admin_js);
		
	wp_enqueue_script( THEME_DOMAIN . '-admin-script', THEME_URL_JS . 'admin-script.js', array( 'jquery', 'jquery-ui-tabs', 'jquery-ui-accordion' ), THEME_VERSION, true );
	
	// Loads our main admin stylesheets.
	wp_enqueue_style( 'wp-color-picker' );
	wp_enqueue_style( THEME_DOMAIN . '-font-awesome', THEME_URL_FONTS . 'font-awesome/css/font-awesome.min.css', array(), THEME_VERSION );
	wp_enqueue_style( THEME_DOMAIN . '-admin-style', THEME_URL_CSS . '/admin-style.css', array(), THEME_VERSION );
	
	// equeue for WPI theme option pages
	if ($page == 'appearance_page_wpi-theme-options') {
		wp_enqueue_script(THEME_DOMAIN .'-theme-options-admin-js', THEME_URL_JS . 'theme_options_admin.js', array('jquery'), THEME_VERSION);
	}
	
	// enqueue for WPI post rating meta box
	if ($page == 'post-new.php' || $page == 'post.php') {
		wp_enqueue_style( 'wpi-rating-admin-css', THEME_URL_CSS . 'rating-admin.css', array(), THEME_VERSION);
		wp_enqueue_script( 'wpi-rating-admin-js', THEME_URL_JS . 'rating/rating-admin.js', array('jquery'), THEME_VERSION);
	
		// add translation for page rating panel
		wp_localize_script( 
			'wpi-rating-admin-js', 
			'wpi_ro', 
			array(
				'txt' => array(
					'canNotDelete' => __wpi('You must have at least 1 feature for rating'),
					'sureDelete' => __wpi('Are you sure delete this feature?'),
				),
			) 
		);
	}
	
	// display right font for post editor in TEXT mode
	if ($page == 'post-new.php' || $page == 'post.php') {
		wp_enqueue_style( 'wpi-post-editor-admin-css', THEME_URL_CSS . 'post-editor-admin.css', array(), THEME_VERSION);
		
		$editor_css = '';

		$em_font = get_theme_mod('emphasis_font_family');
		if ($em_font == '' || $em_font == NULL) {
			$em_font = 'font-62';
		}

		$body_font = get_theme_mod('body_font_family');
		if ($body_font == '' || $body_font == NULL) {
			$body_font = 'font-0';
		}

		$em_font_index = (int) substr($em_font, strpos($em_font, '-')+1);
		$body_font_index = (int) substr($body_font, strpos($body_font, '-')+1);

		// google font
		$em_font_text = 'Oswald';
		$body_font_text = 'Arial';
		global $Google_Font_List;
		if ($em_font && $body_font) :
			// loading google fonts
			if (strpos($em_font, 'cufont') === false) {
				$em_font_text = $Google_Font_List[$em_font_index];
				if ($em_font_index > 6) {
					echo '<link href="http://fonts.googleapis.com/css?family='.str_replace(' ', '+', $em_font_text).'" rel="stylesheet" type="text/css">';
				}
			} else {
				$fid = get_the_ID($em_font_index);
				$fname = get_the_title($em_font_index);
				$fguid = get_the_guid($em_font_index);
				$editor_css .= '@font-face {
	  font-family: \''.$fname.'\';
	  src: url('.$fguid.') format(\'woff\');
	}
';
			$em_font_text = $fname;
			}
			if (strpos($body_font, 'cufont') === false) {
				$body_font_text = $Google_Font_List[$body_font_index];
				if ($body_font_index > 6) {
					echo '<link href="http://fonts.googleapis.com/css?family='.str_replace(' ', '+', $body_font_text).'" rel="stylesheet" type="text/css">';
				}
			} else {
				$fid = get_the_ID($body_font_index);
				$fname = get_the_title($body_font_index);
				$fguid = get_the_guid($body_font_index);
				$editor_css .= '@font-face {
font-family: \''.$fname.'\';
src: url('.$fguid.') format(\'woff\');
}';
				$body_font_text = $fname;
			}
			$editor_css .='
body#tinymce.wp-editor, #content, .wp-editor-area {
font-family: '.$body_font_text.';
}
#titlediv #title {
font-family: \''.$em_font_text.'\', sans-serif;
}';

		endif; // google fonts

		wp_add_inline_style( 'wpi-post-editor-admin-css', $editor_css );
	}
}
add_action( 'admin_enqueue_scripts', 'enqueue_admin_scripts_styles' );

/*js for IE*/
function wpi_js_for_IE() {
	echo '<!--[if lt IE 9]>';
	echo '<scr'.'ipt src="'.THEME_URL_JS.'html5.js"></scr'.'ipt>';
	echo '<![endif]-->';
	
	
}
add_action( 'wp_head', 'wpi_js_for_IE' );




// modify <title> format for SEO
function custom_wp_title( $title, $sep ) {
	global $paged, $page;

	if ( is_feed() ) {
		return $title;
	}

	// Add the site name.
	$title .= get_bloginfo( 'name' );

	// Add the site description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) )
		$title = "$title $sep $site_description";

	// Add a page number if necessary.
	if ( $paged >= 2 || $page >= 2 ) {
		$title = "$title $sep " . __wpi( 'Page' ) . ' ' . max( $paged, $page );
	}
	return $title;
}
add_filter( 'wp_title', 'custom_wp_title', 10, 2 );


/*create theme option menu*/
get_template_part(THEME_PART_THEME_OPTIONS	. 'theme_options_html');
function wpi_theme_options_menu() {
	// Check that the user is allowed to update options  
	if (current_user_can('manage_options')) {  
		add_theme_page(__wpi('Theme Options'), __wpi('Theme Options'), 'edit_theme_options', 'wpi-theme-options', 'wpi_theme_options_html' );
	}
}
add_action('admin_menu', 'wpi_theme_options_menu');

// Custome login logo
add_action("login_head", "wpi_login_logo");
function wpi_login_logo() {
	
	if (get_theme_mod('blog_logo')) {
		wp_enqueue_script('jquery');
		wp_localize_script( 'jquery', 'wpi_login_js', array(
			'home_url' => get_home_url(),
			'blog_logo_src' => get_theme_mod('blog_logo')
		) );
		wp_enqueue_script(THEME_DOMAIN .'-login', THEME_URL_JS . 'login.js', array('jquery'), THEME_VERSION, true);
	}
 
}

// add file type support
// http://en.wikipedia.org/wiki/List_of_file_formats
global $font_ext;
$font_ext = array('abf','afm','bdf','bmf','fnt','fon','mgf','otf','pcf','pfa','pfb','pfm','afm','fond','sfd','snf','tdf','tfm','ttf','ttc','woff');

add_filter('upload_mimes', 'custom_upload_mimes');
function custom_upload_mimes ( $existing_mimes=array() ) {
	global $font_ext;
	foreach ($font_ext as $value) {
		$existing_mimes[$value] = 'font/opentype';
	}
	return $existing_mimes;
}

function wpi_advance_header() {	
	// css
	$advance_css = force_balance_tags(get_option('advance_css'));
	if ($advance_css == false) {
		$advance_css = '';
	}
	if ($advance_css) {
		echo '<sty'.'le type="text/c'.'ss">'.$advance_css.'</st'.'yle>';
	}
}

function wpi_advance_footer() {
	// js
	$advance_js = force_balance_tags(get_option('advance_js'));
	if ($advance_js == false) {
		$advance_js = '';
	}
	if ($advance_js) {
		echo '<scr'.'ipt type="text/jav'.'asc'.'ript">'.$advance_js.'</scr'.'ipt>';
	}
	
	// HTML
	$advance_html = force_balance_tags(get_option('advance_html'));
	if ($advance_html == false) {
		$advance_html = '';
	}
	if (isset($_POST["update_settings"])) {  
		// Do the saving  
		if (isset($_POST["advance_html"])) {  
			$advance_html = force_balance_tags(html_entity_decode(htmlentities(stripslashes($_POST["advance_html"]))));
			update_option("advance_html", $advance_html);
		}
	}  
	echo $advance_html;
}