<form method="POST" action="">
<?php

$wpi_default_sidebars = array(
	'main-sidebar' => 'Main Sidebar Default',
	'small-sidebar' => 'Small Sidebar Default',
	'small-disable' => 'Disable Small Sidebar',
	'big-sidebar'	=>	'Big Sidebar Default',
	'big-disable'	=>	'Disable Big Sidebar',
);
$wpi_sidebar_list = get_option('wpi_sidebar_list');

// update side bar for adding custom sidebar to list
if (!is_array($wpi_sidebar_list) || empty($wpi_sidebar_list)) {
	$wpi_sidebar_list = $wpi_default_sidebars;
} else {
	$wpi_sidebar_list = wp_parse_args($wpi_sidebar_list, $wpi_default_sidebars);
}

$wpi_sidebar_options = array('home', 'posts','pages','archives','404');
if (function_exists('is_bbpress')) {
	$wpi_sidebar_options = wp_parse_args($wpi_sidebar_options, array('bbpress'));
}
if (function_exists('is_woocommerce')) {
	$wpi_sidebar_options = wp_parse_args($wpi_sidebar_options, array('woocommerce'));
}

foreach ($wpi_sidebar_options as $name) :
	$small_key = 'wpi_'.$name.'_small_sidebar';
	$big_key = 'wpi_'.$name.'_big_sidebar';
	$small_sidebar_value = get_option($small_key, '');
	$big_sidebar_value = get_option($big_key, '');
	if (isset($_POST['update_settings'])) {
		if (isset($_POST[$small_key])) {
			$small_sidebar_value = $_POST[$small_key];
		}
		if (isset($_POST[$big_key])) {
			$big_sidebar_value = $_POST[$big_key];
		}
		update_option($small_key, $small_sidebar_value);
		update_option($big_key, $big_sidebar_value);
	}
	if (!($small_sidebar_value)) {$small_sidebar_value = 'small-sidebar';}
	if (!($big_sidebar_value)) {$big_sidebar_value = 'big-sidebar';}
	
	if (!isset($wpi_sidebar_list[$small_sidebar_value])) {
			$small_sidebar_value = 'small-sidebar';	
	}
	if (!isset($wpi_sidebar_list[$big_sidebar_value])) {
			$big_sidebar_value = 'big-sidebar';
	}
	
	// show HTML
	?>
	
	<h3 style="margin: 1.5em 0 0.5em 0;"><?php echo __wpi('Sidebar Settings for '); ?><?php echo strtoupper($name); ?></h3>
<table class="form-table"><tbody><tr>
	<!-- MAIN SIDE-BAR -->
	<td style="background: #f0f0f0;width: 50%;border: 1px solid #ddd;">
		<label for="wpi_<?php echo $name; ?>_main_sidebar" style="font-size: 12px"><?php echo __wpi('Sidebar for Main Column'); echo ' (' . __wpi('locked') . ')'; ?></label><br/><br/>
		<select name="wpi_<?php echo $name; ?>_main_sidebar" disabled="disabled">
			<option value="content"><?php echo __wpi('Default'); ?></option>
		</select>
	</td>

	<!-- SMALL SIDE-BAR -->
	<td style="width: 20%;background: #f8f8f8;border: 1px solid #ddd;">
		<label for="wpi_<?php echo $name; ?>_small_sidebar" style="font-size: 12px"><?php echo __wpi('Sidebar for Small Column')?></label><br/><br/>
		<select name="wpi_<?php echo $name; ?>_small_sidebar">
	<?php
	foreach ($wpi_sidebar_list as $key => $value) :
		if ($value && (strpos($key, 'small-') !== false)) :
		?>
		<option value="<?php echo $key; ?>" <?php if ($small_sidebar_value == $key) { echo 'selected="selected"';} ?>><?php echo $value; ?></option>
		<?php
		endif;
	endforeach;
	?>
	</select></td>

	<!-- BIG SIDE-BAR -->
	<td style="width: 30%;background: #f0f0f0;border: 1px solid #ddd;">
		<label for="wpi_<?php echo $name; ?>_big_sidebar" style="font-size: 12px"><?php echo __wpi('Sidebar for Big Column')?></label><br/><br/>
		<select name="wpi_<?php echo $name; ?>_big_sidebar">
	<?php
	foreach ($wpi_sidebar_list as $key => $value) :
		if ($value && (strpos($key, 'big-') !== false)) :
		?>
		<option value="<?php echo $key; ?>" <?php if ($big_sidebar_value == $key) { echo 'selected="selected"';} ?>><?php echo $value; ?></option>
		<?php
		endif;
	endforeach;
	?>
	</select></td>
</tr>
</tbody></table>
<?php
endforeach;
?>

 
	
<h4><?php echo __wpi('You can create custom sidebars at '); ?><a href="<?php echo admin_url('widgets.php'); ?>"><?php echo __wpi('Theme Widgets'); ?></a>.</h4>

<p class="submit">
		<input type="submit" name="submit" id="submit-1" class="button button-primary" value="<?php echo __wpi('Save Sidebar Settings');?>">
	</p>
	<input type="hidden" name="update_settings" value="Y" />  
</form>