<?php
/* custom author fields*/
/*#######################*/

function wpi_show_extra_profile_fields( $user ) { 
		global $wpi_social_names;
?>

	<h3><?php echo __wpi('Social Links for Author box'); ?></h3>

	<table class="form-table">
		<?php
		foreach ($wpi_social_names as $item => $name) : 
			if ($item == 'globe') {
				continue;
			}
			?>
			<tr>			
				<th><label for="<?php echo $item;?>"><i class="fa fa-<?php echo $item; ?>"></i> <?php echo $name; ?> </label></th>
				<td>
						<input type="text" name="<?php echo $item;?>" id="<?php echo $item;?>" value="<?php echo esc_attr( get_the_author_meta( $item, $user->ID ) ); ?>" class="regular-text" /><br />
				</td>
			</tr>
		<?php
		endforeach;
		?>
		
	</table>
<?php }
add_action( 'show_user_profile', 'wpi_show_extra_profile_fields' );
add_action( 'edit_user_profile', 'wpi_show_extra_profile_fields' );


function wpi_save_extra_profile_fields( $user_id ) {

	if ( !current_user_can( 'edit_user', $user_id ) ) {
		return false;
	}
	global $wpi_social_names;
	foreach ($wpi_social_names as $item => $name) {
		if ($item == 'globe') {
			continue;
		}
		update_user_meta( $user_id, $item, $_POST[$item] );
	}
}

add_action( 'personal_options_update', 'wpi_save_extra_profile_fields' );
add_action( 'edit_user_profile_update', 'wpi_save_extra_profile_fields' );


function wpi_author_box() {
	global $wpi_social_names;
	$author_id = get_the_author_meta( 'ID' );
	if (is_author()) {
		$author = get_user_by( 'slug', get_query_var( 'author_name' ) );
		if ($author) {
			$author_id = $author->ID;
		}
	}
	
	if ($author_id) :
		$author = get_userdata($author_id);
		$author_name = $author->data->display_name;
		$author_nice_name = $author->data->user_nicename;
		$author_profile_url = home_url().'/author/'.$author_nice_name;
		$author_avatar = get_avatar( $author_id, 64, 'http://assets.tumblr.com/images/default_avatar_64.png', 'author-avatar' );
		$author_description = get_the_author_meta('description',$author_id);
		
		?>
		
		<div class="post-footer-box post-author">
			<h3 class="sub-title sfont"><?php echo __wpi('About author'); ?></h3>
			<div class="post-author-header">
				<div class="left-col post-author-avatar">
					<a href="<?php echo $author_profile_url; ?>" title="<?php echo __wpi('Posted by'); echo esc_attr($author_name); ?> " rel="author"><?php echo $author_avatar; ?></a>
				</div>
				<div class="right-col">
					<a class="sfont post-author-name" href="<?php echo $author_profile_url; ?>" title="<?php echo __wpi('Posted by') . ' '; echo esc_attr($author_name); ?>">
						<?php echo $author_name; ?>
					</a>
					
					<div class="post-author-connect">
					<?php foreach ($wpi_social_names as $item => $name) :
							if ($item == 'globe') {
								continue;
							}
							$social = get_user_meta($author_id, $item, true);
							$rel = '';
							if ($item == 'google-plus') {
								$rel = ' rel="author"';
							}
							if ($social) {
									echo '<a href="'.$social.'" '.$rel.' title="'.  esc_attr($name).'"><span class="background-color-hover"><i class="fa fa-'.$item.'"></i></span></a>';
							}
						endforeach;
					if ($author->data->user_url) {
							echo '<a href="'.$author->data->user_url.'"><span class="background-color-hover"><i class="fa fa-globe"></i></span></a>';
					}
					?>
					
					
					</div>
					
				</div>
			</div>
			<div class="post-author-bio"><?php echo $author_description; ?></div>
		</div><!--.post-author-->
		
		<?php
		
	endif;
}
