<?php
// save exclude posts into list for next boxes
global $exclude_posts;
$exclude_posts = array();

function wpi_article_box_common_content($widget_args = null, $instance = null, $design = 'tumblr') {
	// valid widget ID
	if (!is_array($widget_args)) {$widget_args = array('widget_id' => $widget_args);}
	if (!array_key_exists('widget_id', $widget_args)) {return;}
	$widget_id = $widget_args['widget_id'];
	
	global $exclude_posts;
	
	// add exclude posts for ajax page builder
	// pagebuilder pagination ajax
	$pagination_ajax = false;
	if (isset($_POST['action'])) {
		if ($_POST['action'] == 'wpi_article_box') {
			$pagination_ajax = true;
		}
	}
	
	if ($pagination_ajax && wpi_get_server_request('exclude_post_list')) {
		$exclude_posts = explode(',',wpi_get_server_request('exclude_post_list'));
	}
	// PARSE ARGUMENTS
	
	$args['type'] = $design;
	$args['title']					= wpi_safe_array_get($instance, 'title');
	$args['title_url']				= wpi_safe_array_get($instance, 'title_url');
	$args['sort']					= wpi_safe_array_get($instance, 'sort');
	$args['pagination']				= wpi_safe_array_get($instance, 'pagination');
	$args['category_check']			= wpi_safe_array_get($instance, 'category_check');
	$args['category']				= wpi_safe_array_get($instance, 'category');
	$args['author']					= wpi_safe_array_get($instance, 'author');
	$args['count']					= wpi_safe_array_get($instance, 'count');
	$args['exclude_loaded_posts']	= wpi_safe_array_get($instance, 'exclude_loaded_posts');
	$args['exclude_sticky_posts']	= wpi_safe_array_get($instance, 'exclude_sticky_posts');
	$args['show_rss']				= wpi_safe_array_get($instance, 'show_rss');
	$args['full_first_thumb']		= wpi_safe_array_get($instance, 'full_first_thumb');
	$args['show_category']			= wpi_safe_array_get($instance, 'show_category');
	$args['show_date']				= wpi_safe_array_get($instance, 'show_date');
	$args['show_comment_number']	= wpi_safe_array_get($instance, 'show_comment_number');
	$args['show_view_count']		= wpi_safe_array_get($instance, 'show_view_count');
	$args['show_next_prev']			= wpi_safe_array_get($instance, 'show_next_prev');
	$args['show_thumb_nav']			= wpi_safe_array_get($instance, 'show_thumb_nav');
	$args['show_corner_border']		= wpi_safe_array_get($instance, 'show_corner_border');
	$args['show_bar_nav']			= wpi_safe_array_get($instance, 'show_bar_nav');
	$args['show_snippet']			= wpi_safe_array_get($instance, 'show_snippet');
	$args['snippet_length']			= wpi_safe_array_get($instance, 'snippet_length');
	$args['color']					= wpi_safe_array_get($instance, 'color');
	$args['animation']				= wpi_safe_array_get($instance, 'animation');
	$args['speed']					= wpi_safe_array_get($instance, 'speed');
	$args['pause_time']				= wpi_safe_array_get($instance, 'pause_time');
	$args['control']				= wpi_safe_array_get($instance, 'control');
	$args['columns']				= wpi_safe_array_get($instance, 'columns');
	
	// valid data
	if (is_numeric($args['snippet_length'])) {$args['snippet_length'] = (int) $args['snippet_length'];} else {$args['snippet_length'] = 150;}
	if (is_numeric($args['count'])) {$args['count'] = (int) $args['count'];} else {$args['count'] = 0;}
	if (is_numeric($args['category'])) {$args['category'] = (int) $args['category'];} else {$args['category'] = 0;}
	if (is_numeric($args['author'])) {$args['author'] = (int) $args['author'];} else {$args['author'] = 0;}

	// only load the posts from a page (when use pagebuilder pagination ajax)
	$page_number = 1;
	if (isset($_POST['pn'])) {
		$page_number = (int) $_POST['pn'];
	}
	
// show html
$item_clear = '<div class="clear"></div>';
	
if (!$pagination_ajax) {
	// check specific color setting
	if ($args['color'] && $args['color'] != get_theme_mod('main_color')) {
		$cl = $args['color'];
		echo '<sty'.'le t'.'ype="te'.'xt/cs'.'s">';
		
		// main css
		echo '#'.$widget_id.' .color,
		#'.$widget_id.' .color-hover:hover,
		#'.$widget_id.' .color-active:active,
		#'.$widget_id.' .color-visited:visited,
		#'.$widget_id.' .color-link:link,
		#'.$widget_id.' .tab-header.active a {
			color:'.$cl.'
		}
		#'.$widget_id.' .pagination-index .page-numbers,
		#'.$widget_id.' .background-color,
		#'.$widget_id.' .bar_nav li.active,
		#'.$widget_id.' .background-color-hover:hover {
			background-color:'.$cl.'
		}
		#'.$widget_id.' .border-color{border-color: '.$cl.'}';
		
		// specific css
		echo '#'.$widget_id.' .article-box-pagination.number .nav-item:hover,
		#'.$widget_id.' .article-box-pagination.number .nav-item.active {
			color: #333;
			background: #ddd;
		}';

	
		echo '</sty'.'le>';
	}
}
	
	$count_key = 'post_views_count';
	if (get_theme_mod('view_count_key')) {
		$count_key = get_theme_mod('view_count_key');
	}
			
	switch ($args['type']) :
		case 'break':
		case 'slider':
		case 'one_left':
		case 'one_right':
		case 'two':
		case 'one_horizon':
		case 'carousel':
		case 'complex':
		case 'blog_roll':
		case 'trending':
		case 'high_light':
			$querya = array(
				'post_type' => 'post',
				'posts_per_page'=> ((int) $args['count'])
			);
			if ($args['exclude_sticky_posts']) {
				$querya = wp_parse_args($querya, array(
					'ignore_sticky_posts' => true,
				));
			}
			if ($args['category'] != '0') {
				$querya = wp_parse_args($querya, array(
					'cat' => ((int)$args['category'])
				));
			}
			// source query
			if ($args['sort'] == 'popular') {//POPULAR POSTS
				$querya = wp_parse_args($querya, array(
					'meta_key' => $count_key, 
					'orderby' => 'meta_value_num'
				));
			} else if ($args['sort'] == 'random') {// RANDOM POSTS
				$querya = wp_parse_args($querya, array(
					'orderby' => 'rand'
				));
			}
			
			
			if (isset($args['author'])) {
				$author_id = ((int) $args['author']);
				if ($author_id) {
					$querya = wp_parse_args($querya, array(
						'author' => $author_id
					));
				}
				
			}
	
			if ($pagination_ajax) {
				$querya = wp_parse_args($querya, array(
					'paged' => $page_number
				));
			}
	
			
			if (($args['exclude_loaded_posts']) && (!empty($exclude_posts))) {
				$querya = wp_parse_args($querya, array(
					'post__not_in' => $exclude_posts
				));
			}
			$querya = wp_parse_args($querya, array(
				'post_status' => 'publish'
			));
			
			
			$wpi_query = new WP_Query( $querya );
			
			
			// Show HTML for none ajax
			if (!$pagination_ajax) :
				$max_page = 0;
				if (property_exists($wpi_query, 'max_num_pages')) {
					$max_page = $wpi_query->max_num_pages;
				}
				
				// box data
				$box_data = '';
				if ($args['animation']) {
					$box_data .= ' data-animation="'.$args['animation'].'"';
				}
				if ($args['speed']) {
					$box_data .= ' data-speed="'.$args['speed'].'"';
				}
				if ($args['pause_time']) {
					$box_data .= ' data-pause_time="'.$args['pause_time'].'"';
				}
				if ($args['control']) {
					$box_data .= ' data-control="'.$args['control'].'"';
				}
				if ($args['show_next_prev']) {
					$box_data .= ' data-next_prev="on"';
				}
				if ($args['show_thumb_nav']) {
					$box_data .= ' data-thumb_nav="on"';
				}
				if ($args['show_bar_nav']) {
					$box_data .= ' data-bar_nav="on"';
				}
				if ($args['show_corner_border']) {
					$box_data .= ' data-corner_border="on"';
				}
				if ($args['columns']) {
					$box_data .= ' data-columns="'.$args['columns'].'"';
				}
				
				// box class
				$box_class = 'news-box widget '.$args['type'];
				
				echo '<div class="'.$box_class.'" id="'.$widget_id.'" '.$box_data.'>';
				if ($args['title']) {
					echo '<h2 class="widget-title sfont background-color"><a href="';
					if ($args['title_url']) {
						echo $args['title_url'];
					}else {
						if ($args['category'] == '0') {
							echo get_home_url().'?index=post';
						} else {
							echo get_category_link((int) $args['category']);
						}
					}
					echo '" class="widget-title-content">'.$args['title'].'</a><span class="arrow background-color"></span>';
					echo '</h2>';
					if ($args['show_rss']) {
						echo '<a class="rss-button" href="';
						if ($args['category'] == '0') {
							echo get_bloginfo('rss2_url');
						} else {
							echo get_category_feed_link($args['category']);
						}
						echo '">RSS <i class="fa fa-rss"></i></a>';
					}

				}
				
				

				if ($args['type'] != 'break') {
					echo '<div class="clear"></div>';
				}

				$outer_class = '';
				if ($args['type']=='slider') {
					$outer_class .= ' wpi_snow_slider';
				} else if ($args['type']=='carousel'){
					$outer_class .= ' wpi_snow_carousel';
				} else if ($args['type']=='break'){
					$outer_class .= ' wpi_snow_ticker';
				}
				if ($design == 'high_light') {
					$outer_class .= ' background-color';
				}

				echo '<div class="outer'.$outer_class.'">';
				echo '<ul class="content">';
			
				$pbpnav_data = '';
				
				$pbpnav_data .= ' data-pbpnav="'.$args['pagination'].'"';
				$pbpnav_data .= ' data-page="'.$page_number.'"';
				$pbpnav_data .= ' data-maxpage="'.$max_page.'"';
				$pbpnav_data .= ' data-type="'.$design.'"';
				$pbpnav_data .= ' data-count="'.wpi_safe_array_get($instance,'count').'"';
				$pbpnav_data .= ' data-category="'.wpi_safe_array_get($instance,'category').'"';
				$pbpnav_data .= ' data-sort="'.wpi_safe_array_get($instance,'sort').'"';
				$pbpnav_data .= ' data-author="'.wpi_safe_array_get($instance,'author').'"';
				$pbpnav_data .= ' data-exclude_loaded_posts="'.wpi_safe_array_get($instance,'exclude_loaded_posts').'"';
				$pbpnav_data .= ' data-show_category="'.wpi_safe_array_get($instance,'show_category').'"';
				$pbpnav_data .= ' data-show_date="'.wpi_safe_array_get($instance,'show_date').'"';
				$pbpnav_data .= ' data-show_comment_number="'.wpi_safe_array_get($instance,'show_comment_number').'"';
				$pbpnav_data .= ' data-show_snippet="'.wpi_safe_array_get($instance,'show_snippet').'"';
				$pbpnav_data .= ' data-snippet_length="'.wpi_safe_array_get($instance,'snippet_length').'"';
				$pbpnav_data .= ' data-full_first_thumb="'.wpi_safe_array_get($instance,'full_first_thumb').'"';
				$pbpnav_data .= ' data-exclude_post_list="'.  implode(',', $exclude_posts).'"';
					
					
			endif; // (not) pagebuilde_ajax
			
			$counter = 0;
			
			// ##       ####     ####   #####
			// ##     ##    ## ##    ## ##   ##
			// ##     ##    ## ##    ## ##   ##
			// ##     ##    ## ##    ## #####
			// ######   ####     ####   ##
			
			if ($wpi_query->have_posts()) :
				while ( $wpi_query->have_posts() ) : $wpi_query->the_post();
					$p = new Wpi_Article_Item($args);
					
					// only update exclude posts for none ajax pagination 
					// to prevent change max page
					if (!$pagination_ajax) {
						global $exclude_posts;
						if (!in_array($p->id, $exclude_posts)) {
							$exclude_posts = wp_parse_args(array($p->id), $exclude_posts);
						}
					}
					
					// START ITEM
					// ##########################################################################
					
					
					echo '<li class="item item-'.$counter.' item-'.(($counter==0)? 'first active':'other').' item-'.(($counter%2)? 'odd':'even').(($counter%3)? '':' item-triple').'"><div class="inner'.(($args['type']=='portfolio')? ' ease':'').'">';
					
					switch ($args['type']) :
						// ########################################################################
						case 'break':
							echo $p->title(false);
							break;
						
						// ########################################################################
						case 'slider':
							echo '<div class="media-wrapper">'.$p->thumbnail('full').'</div>';
							
							echo '<div class="effect-line-1">'.$p->review().'</div><div class="effect-line-2"><div class="overlay"></div><div class="content">'.$p->cate('background-color').'<div class="clear"></div>'.$p->title().$p->meta().$p->snippet().'</div></div>';
							break;
							
						// CAROUSEL ##################################
						case 'carousel':
							echo '<div class="media-wrapper">'.$p->review().$p->thumbnail('medium').'</div><div class="content-wrapper">'.$p->cate('color').$p->title().$p->meta().$p->snippet().'</div>';
							break;
						
						// COMPLEX #####################################
						// ONE LEFT ####################################
						// ONE RIGHT ###################################
						case 'complex':
						case 'one_left':
						case 'one_right':
							echo '<div class="complex-wrapper">';
							if ($counter==0) {
								echo $p->review();
								if ($args['full_first_thumb']) {
									echo $p->thumbnail('natural_medium');
								} else {
									echo $p->thumbnail('medium');;
								}
								echo $p->cate('color').$p->title().$p->meta().$p->snippet();
								
							} else {
								echo '<div class="thumbnail">'.$p->review().$p->thumbnail().'</div><div class="text">'.$p->title(false).'</div>';
							}
							echo '<div class="clear"></div></div>';
							break;
							
						// BLOG ROLL ###############################################
						case 'blog_roll':
							echo $p->review().$p->thumbnail('natural_full').$p->cates('cate-item color').$p->title().$p->meta().$p->snippet(true);
							break;
						// ########################################################################
						case 'one_horizon':
							echo $p->review().$p->thumbnail('medium').'<div class="right-content">'.$p->cate('color').$p->title().$p->meta().$p->snippet().'</div><div class="clear"></div>';
							break;
						
						// ########################################################################
						case 'two':
							echo $p->review().$p->thumbnail('natural_medium').$p->cate('color').$p->title().$p->meta().$p->snippet();
							break;
						
						
						// ########################################################################
						case 'trending':
							echo $p->cate('color'). '<div class="trending-wrap">
	'.$p->review().$p->thumbnail().'
	<div class="trending-title">'.$p->title().'<div class="overlay"></div></div>
</div>'.$p->meta().$p->snippet();
							break;
						
						case 'high_light':
							if ($counter == 0) {
								if ($args['full_first_thumb']) {
									echo $p->thumbnail('natural_large');
								} else {
									echo $p->thumbnail('large');
								}
								
							} else {
								echo $p->thumbnail('medium');
							}
							echo '<div class="high-light-content">'.$p->cate('color').$p->title().$p->meta().$p->snippet().'</div>';
							break;
					endswitch;
					
					echo $item_clear.'</div></li>';
					
					$counter++;
					
					if ($counter >= (int) $args['count']) {
						break;
					}
				endwhile;
				
			else:
				if (!$pagination_ajax) {
					echo '<p><em>'.__wpi('Have no posts').'</em></p>';
				}
			endif;
			if (!$pagination_ajax) {
				echo '</ul>'.$item_clear.'</div>'.$item_clear;
				
				if ($args['pagination'] && $args['pagination'] != 'none') {
					
					echo '<div class="article-box-pagination '.$args['pagination'].'"'.$pbpnav_data.'>';
					echo $item_clear.'</div>'.$item_clear;
				}
				
				
				echo '<div class="clear"></div></div>';
			}
			wp_reset_postdata();
			
			break;
			
		/*
		TAB
		#####################################################################################
		*/
		case 'tabs':
			if ($args['category_check']) :
				$cates = $args['category_check'];
				echo '<div class="news-box widget '.$args['type'].'" id="'.$widget_id.'">';
				
				
				// show cate tabs
				echo '<div class="tabs-header-outer border-color"><ul class="tabs-header">';
				$tab_index = 0;
				foreach($cates as $cate) :
					$cate_name = get_category( (int) $cate );
					if (!$cate_name) {
						$cate_name = 'No exist category';
					} else {
						$cate_name = get_the_category_by_ID( (int) $cate );
					}
						
					echo '<li class="tab-header'.(($tab_index == 0)? ' active':'').'"><a class="sfont border-color color-hover" href="#tab-'.$tab_index.'">'.$cate_name.'</a></li>';
					$tab_index++;
				endforeach;
				echo '</ul>'.$item_clear.'</div>';
				
				
				// show cate content
				$tab_index = 0;
				
				
				foreach ($cates as $cate):
					$querya = array(
						'post_type' => 'post',
						'ignore_sticky_posts' => true,
						'cat' => $cate,
						'posts_per_page'=> ((int) $args['count'])
					);
					
					// source query
					if ($args['sort'] == 'popular') {//POPULAR POSTS
						$querya = wp_parse_args($querya, array(
							'meta_key' => $count_key, 
							'orderby' => 'meta_value_num'
						));
					} else if ($args['sort'] == 'random') {// RANDOM POSTS
						$querya = wp_parse_args($querya, array(
							'orderby' => 'rand'
						));
					}
					global $exclude_posts;
					if (($args['exclude_loaded_posts'])  && (!empty($exclude_posts))) {
						$querya = wp_parse_args($querya, array(
							'post__not_in' => $exclude_posts
						));
					}

					
					
					$wpi_query = new WP_Query( $querya );
					// Show HTML
					echo '<div class="tabs-content-outer tab-'.$tab_index.(($tab_index == 0)? ' active':'').'"><ul class="tabs-content">';
					$counter = 0;
					$tab_index++;
					if ($wpi_query->have_posts()) :
						while ( $wpi_query->have_posts() ) : $wpi_query->the_post();
							
							$p = new Wpi_Article_Item($args);
							
							if (!$pagination_ajax) {
								global $exclude_posts;
								if (!in_array($p->id, $exclude_posts)) {
									$exclude_posts = wp_parse_args(array($p->id), $exclude_posts);
								}
							}
							
							echo '<li class="item item-'.$counter.' item-'.(($counter==0)? 'first active':'other').' item-'.(($counter%2)? 'odd':'even').(($counter%3)? '':' item-triple').'"><div class="inner'.(($args['type']=='portfolio')? ' ease':'').'">';
							echo '<div class="complex-wrapper">';
							if ($counter==0) {
								echo $p->review();
								if ($args['full_first_thumb']) {
									echo $p->thumbnail('natural_medium');
								} else {
									echo $p->thumbnail('medium');;
								}
								echo $p->cate('color').$p->title().$p->meta().$p->snippet();
								
							} else {
								echo '<div class="table"><div class="tr"><div class="td">'.$p->review().$p->thumbnail().'</div><div class="td" style="width: 100%">'.$p->title(false).'</div></div></div>';
							}
							echo '<div class="clear"></div></div>';
							
							$counter++;
							echo $item_clear.'</div></li>';
							
						endwhile;
						
					else:
						echo '<p><em>'.__wpi('Have no posts').'</em></p>';
					endif;
					echo '</ul></div>';
					
					wp_reset_postdata();
				endforeach;// foreach of cate_ids
				echo $item_clear.'</div>';// end news box div
			endif; //check that at least one cate was checked
		
			break;
	endswitch;// swith type to show html
}
