<?php
class AB_Two_Widget extends WP_Widget {
	var $wpi_widget_builder;
	function __construct() {
		global $common_article_widget_instance;
		$cf = $common_article_widget_instance;//common fields
		$instance = array(
			$cf['title_url'],
			$cf['sort'],
			$cf['pagination'],
			$cf['category'],
			$cf['author'],
			$cf['count'],
			$cf['exclude_loaded_posts'],
			$cf['exclude_sticky_posts'],
			$cf['show_rss'],
			$cf['show_category'],
			$cf['show_date'],
			$cf['show_comment_number'],
			$cf['show_view_count'],
			$cf['show_snippet'],
			$cf['snippet_length'],
			$cf['color'],
		); 
		$this->wpi_widget_builder = new Wpi_Widget_Builder($this, array(
			'id'	=> 'wpi_ab_two',
			'name'	=> 'Article Box - TWO COLUMNS',
			'desc'	=> 'Show Articles in a Box with Two Columns Design',
			'instance'	=> $instance
		));
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$this->wpi_widget_builder->form($instance);
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		return $this->wpi_widget_builder->update($new_instance, $old_instance);
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		$instance = $this->wpi_widget_builder->valid($instance);
		wpi_article_box_common_content($args, $instance, 'two');
	}
}

// register News_Article_Box_Widget
add_action('widgets_init', create_function('', 'return register_widget("AB_Two_Widget");'));
