<?php
class Brand_About_Widget extends WP_Widget {
	var $wpi_widget_builder;
	function __construct() {
		$this->wpi_widget_builder = new Wpi_Widget_Builder($this, array(
			'id'	=> 'wpi_brand_about',
			'name'	=> 'Brand About',
			'desc'	=> 'Show Site Logo, Description, Keep in Touch and Social Icons',
			'instance'	=> array(
				array(
					'id'	=>	'show_tagline',
					'type'	=>	'checkbox'
				),
				array(
					'id'	=>	'show_social_icons',
					'type'	=>	'checkbox'
				),
				array(
					'id'	=>	'address',
				),
				array(
					'id'	=>	'email',
				),
				array(
					'id'	=>	'phone',
				),
				
			)
		));
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$this->wpi_widget_builder->form($instance);
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		return $this->wpi_widget_builder->update($new_instance, $old_instance);
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		extract( $args );
		$instance = $this->wpi_widget_builder->valid($instance);
		echo $before_widget;
		echo '<div class="widget-content">';
		?>
		<div class="sfont"><?php wpi_blog_title(); ?></div>
		<?php
			if ($instance['show_tagline']) {
				echo '<p class="blog-desc">' . get_bloginfo('description') .'</p>';
			}
		?>
		<div class="clear"></div>
		<?php if ($instance['address'] || $instance['email'] || $instance['phone']) : ?>
			<h3 class="kit-title sfont"><?php echo __wpi('Keep in touch'); ?></h3>
			<ul class="kit-content">
				<?php if ($instance['address']) : ?>
				<li>
					<i class="fa fa-map-marker"></i> 
					<?php echo __wpi('Address'); ?>: <?php echo $instance['address'];?>
				</li>
				<?php endif; ?>

				<?php if ($instance['email']) : ?>
				<li>
					<i class="fa fa-envelope-o"></i> <?php echo __wpi('Email'); ?>: 
					<?php echo $instance['email'];?>
				</li>
				<?php endif; ?>

				<?php if ($instance['phone']) : ?>
				<li>
					<i class="fa fa-phone"></i> 
					<?php echo __wpi('Phone'); ?>: <?php echo $instance['phone'];?>
				</li>
				<?php endif; ?>
			</ul>
		<?php endif; ?>
			
		<?php if ($instance['show_social_icons']) {
			global $wpi_social_links;
			global $wpi_social_names;
			$social_html = '';
			foreach ($wpi_social_links as $key => $value) {
				if ($value) {
					$social_html .= '<a href="'.$value.'" class="fa fa-'.$key.'"><span class="txtindent">'.$wpi_social_names[$key].'</span></a>';
				}
			}
			if ($social_html) {
				echo '<div class="social-icons widget-social-icons">'.$social_html.'<div class="clear"></div></div>';
			}
		}
		?>
		<?php
		
		echo '<div class="clear"></div></div>';
		echo $after_widget;
	}
}

// register News_Article_Box_Widget
add_action('widgets_init', create_function('', 'return register_widget("Brand_About_Widget");'));
