<?php

// just pick fields you want, you can also modify it
global $common_post_feed_data_widget_instance;
$common_post_feed_data_widget_instance = array(
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'count' => array(
		'id'		=>	'count',
		'label'		=>	'Post Count',
		'default'	=>	5
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'category' => array(
		'id'	=>	'category',
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'high_light' => array(
		'id'	=>	'high_light',
		'label'	=>	'Solid background color',
		'type'	=>	'checkbox'
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'show_category' => array(
		'id'	=>	'show_category',
		'type'	=>	'checkbox'
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'show_thumbnail' => array(
		'id'	=>	'show_thumbnail',
		'type'	=>	'checkbox'
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'show_date' => array(
		'id'	=>	'show_date',
		'type'	=>	'checkbox'
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'show_comment_number' => array(
		'id'	=>	'show_comment_number',
		'type'	=>	'checkbox'
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'show_view_count' => array(
		'id'	=>	'show_view_count',
		'type'	=>	'checkbox'
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'show_snippet' => array(
		'id'	=>	'show_snippet',
		'label'	=>	'Show Post Snippet / Excerpt',
		'type'	=>	'checkbox'
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'snippet_length' => array(
		'id'	=>	'snippet_length',
		'label'	=>	'Snippet Length',
		'default' => 150
	),
	//+++++++++++++++++++++++++++++++++++++++++++++++++
	'style' => array(
		'id'		=>	'style',
		'type'		=>	'select',
		'default'	=>	'list',
		'choices'	=> array(
			'list'		=>	'List',
			'column'	=>	'Column',
		)
	),
	'duration' => array(
		'id'		=>	'duration',
		'type'		=>	'select',
		'default'	=>	'month',
		'choices'	=> array(
			'all'		=>	'All Time',
			'year'		=>	'This Year',
			'month'		=>	'This Month',
			'week'		=>	'This Week',
		)
	),
);

/*Paste this then remove the ones you don't want*/
/*
		global $common_post_feed_data_widget_instance;
		$cf = $common_post_feed_data_widget_instance;//common fields
		$instance = array(
			$cf['count'],
			$cf['show_thumbnail'],
			$cf['high_light'],
			$cf['show_category'],
			$cf['show_date'],
			$cf['show_comment_number'],
			$cf['show_snippet'],
			$cf['snippet_length'],
			$cf['style'],
			$cf['duration'],
			$cf['category'],
		); 
 */

function wpi_post_feed_data($args, $instance, $design) {
	extract($args);
	if (!isset($instance['duration'])) {
		$instance['duration'] = '';
	}
	if (!isset($instance['high_light'])) {
		$instance['high_light'] = '';
	}
	if (!isset($instance['category'])) {
		$instance['category'] = '';
	}
	extract($instance);
	$title = '';
	$title = esc_attr(wpi_safe_array_get($instance, 'title'));
	$title = apply_filters('widget_title', $title);
	$high_light_class = '';
	if ($high_light) {
		$high_light_class = ' high_light';
	}
	// Show HTML
	echo '<div class="feed-data feed-data-style-'.$instance['style'].$high_light_class.'">';
	echo $before_widget;
	if ($title) {
		echo $before_title . $title . $after_title;
	} else {
		echo '<div class="widget-content">';
	}
	
	if ($high_light) {
		echo '<div class="high_light_inner background-color">';
	}
	// common query
	$args = array (
		'ignore_sticky_posts'	=> true,
		'post_type'				=> 'post',
		'posts_per_page'		=> $count,
		'order'					=> 'DESC',
	);

	// category
	if ($category) {
		$args = wp_parse_args($args, array('cat' => (int) $category));
	}
	
	// time query
	if ($duration) {
		if ($duration == 'year') {//1 year ago
			$args = wp_parse_args($args, array(
				'date_query' => array(
					array(
						'column' => 'post_date_gmt',
						'after' => '1 year ago',
					)
				),
			));
		} else if ($duration == 'month') {//1 month ago
			$args = wp_parse_args($args, array(
				'date_query' => array(
					array(
						'column' => 'post_date_gmt',
						'after' => '1 month ago',
					)
				),
			));
		} else if ($duration == 'week') {//1 week ago
			$args = wp_parse_args($args, array(
				'date_query' => array(
					array(
						'column' => 'post_date_gmt',
						'after' => '1 week ago',
					)
				),
			));
		}
	}
	
	$count_key = 'post_views_count';
	if (get_theme_mod('view_count_key')) {
		$count_key = get_theme_mod('view_count_key');
	}

	// change query base on design
	switch ($design) {
		case 'popular_posts':
			$args = wp_parse_args($args, array(
				'meta_key'		=> $count_key, 
				'orderby'		=> 'meta_value_num'
			));
			break;
		
		case 'popular_review_posts':
			$args = wp_parse_args($args, array(
				'meta_key'		=> 'wpi_rating_value', 
				'orderby'		=> 'meta_value_num'
			));
			break;
		
		case 'popular_user_rating_posts':
			$args = wp_parse_args($args, array(
				'meta_key'		=> 'wpi_user_rating_total_value', 
				'orderby'		=> 'meta_value_num'
			));
			break;
		case 'random_posts':
			$args = wp_parse_args($args, array(
				'orderby' => 'rand'
			));
			
			break;
		
		case 'recent_review_posts':
			$args = wp_parse_args($args, array(
				'meta_key'		=> 'wpi_rating_value',
			));
			break;
		
		default:
			break;
	}
	
	$feed_query = new WP_Query( $args );
	
	$counter = 0;
		if ($feed_query->have_posts()) :
			while ( $feed_query->have_posts() ) : $feed_query->the_post();
				$p = new Wpi_Article_Item($instance);
				echo '<div class="item item-'.$counter. ((!$show_thumbnail)?' no-thumb':' thumb').'">';
				if ($design == 'popular_user_rating_posts') {
					echo $p->review('user');
				} else {
					echo $p->review();
				}
				
				if ($show_thumbnail) {
					if ($style == 'list') {
						echo $p->thumbnail();
					} else {
						echo $p->thumbnail('natural_large');
					}
				} else {
					echo '<div class="clear"></div>';
				}
				if ($style == 'list') {
					echo '<div class="content-wrapper">'.$p->cate().$p->title(false).$p->meta().$p->snippet().'</div>';
				} else {
					echo $p->cate().$p->title().$p->meta().$p->snippet();
				}
				
				echo '<div class="clear"></div></div>';

				$counter++;
			endwhile;
			
		else:
			echo '<p><em>'.__wpi('Have no posts').'</em></p>';
		endif;
		wp_reset_postdata();
		
		if ($high_light) {
			echo '<div class="clear"></div></div>';
		}
	if (!$title) {
		echo '<div class="clear"></div></div>';
	}
	echo $after_widget;
	echo '</div>';
}