<?php
class Flickr_Photos_Widget extends WP_Widget {
	var $wpi_widget_builder;
	function __construct() {
		$this->wpi_widget_builder = new Wpi_Widget_Builder($this, array(
			'id'	=> 'wpi_flickr_photos',
			'name'	=> 'Flickr Photos',
			'desc'	=> 'Show list of Flickr Photos from your Flickr Username',
			'instance'	=> array(
				array(
					'id'	=>	'user_id',
					'label'	=>	'Your Flickr User ID (Example: 52617155@N08)'
				),
				array(
					'id'		=>	'count',
					'default'	=>	12
				),
				array(
					'id'		=>	'order',
					'label'		=>	'Ordering your image',
					'type'		=>	'select',
					'default'	=>	'latest',
					'choices'	=>	array(
						'latest'	=>	'Latest',
						'random'	=>	'Random'
					)
				),
				
			)
		));
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$this->wpi_widget_builder->form($instance);
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		return $this->wpi_widget_builder->update($new_instance, $old_instance);
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		extract( $args );
		$instance = $this->wpi_widget_builder->valid($instance);
		$title = apply_filters('widget_title', wpi_safe_array_get($instance, 'title'));
		echo $before_widget;
		if ($title) {
			echo $before_title . $title .  $after_title;
		} else {
			echo '<div class="widget-content">';
		}
		
		if (strpos($instance['user_id'], '/') !== false) {
			$instance['user_id'] = substr(strrchr($instance['user_id'], '/'), 1);
		}
		?>
		<?php echo '<scr'.'ipt type="t'.'ext/jav'.'asc'.'ript" src="http://www.flickr.com/badge_code.gne?count='.$instance['count'].'&amp;display='. $instance['order'].'&amp;size=125&amp;nsid='. $instance['user_id'].'&amp;raw=1"></sc'.'ript>';
		
		if (!$title) {
			echo '<div class="clear"></div></div>';
		}
		echo $after_widget;
	}
}

// register News_Article_Box_Widget
add_action('widgets_init', create_function('', 'return register_widget("Flickr_Photos_Widget");'));
