<?php
function register_widget_areas() {
	$before_title = '</div><h2 class="widget-title sfont background-color"><span class="widget-title-content">';
	$after_title = '</span><span class="arrow background-color"></span></h2><div class="clear"></div><div class="widget-content">';
	register_sidebar( array(
		'name'          => __wpi( 'Header Right Section' ),
		'id'            => 'header-right',
		'description'   => '',
		'class'         => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s"><div>',
		'after_widget'  => '<div class="clear"></div></div></aside>',
		'before_title'  => $before_title,
		'after_title'   => $after_title
	) );
	register_sidebar( array(
		'name'          => __wpi( 'Header Wide Section' ),
		'id'            => 'header-wide',
		'description'   => '',
		'class'         => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s"><div>',
		'after_widget'  => '<div class="clear"></div></div></aside>',
		'before_title'  => $before_title,
		'after_title'   => $after_title
	) );
	
	// #########################################################################
	register_sidebar( array(
		'name'          => __wpi( 'Main Sidebar Default' ),
		'id'            => 'main-sidebar',
		'description'   => '',
		'class'         => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s"><div>',
		'after_widget'  => '<div class="clear"></div></div></aside>',
		'before_title'  => $before_title,
		'after_title'   => $after_title
	) );
	
	register_sidebar( array(
		'name'          => __wpi( 'Small Sidebar Default' ),
		'id'            => 'small-sidebar',
		'description'   => '',
		'class'         => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s"><div>',
		'after_widget'  => '<div class="clear"></div></div></aside>',
		'before_title'  => $before_title,
		'after_title'   => $after_title
	) );
	
	register_sidebar( array(
		'name'          => __wpi( 'Big Sidebar Default' ),
		'id'            => 'big-sidebar',
		'description'   => '',
		'class'         => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s"><div>',
		'after_widget'  => '<div class="clear"></div></div></aside>',
		'before_title'  => $before_title,
		'after_title'   => $after_title
	) );
	
	
	// ###############################################################################
	register_sidebar( array(
		'name'          => __wpi( 'Footer Section' ),
		'id'            => 'footer',
		'description'   => '',
		'class'         => '',
		'before_widget' => '<aside id="%1$s" class="widget %2$s"><div>',
		'after_widget'  => '<div class="clear"></div></div></aside>',
		'before_title'  => $before_title,
		'after_title'   => $after_title
	) );
	
	/*Register custom sidebar*/
	$wpi_sidebar_list = get_option('wpi_sidebar_list');
	if ($wpi_sidebar_list && is_array($wpi_sidebar_list) && !empty($wpi_sidebar_list)) {
		foreach ($wpi_sidebar_list as $key => $value) {
			if ($value) {
				register_sidebar( array(
					'name'          => $value,
					'id'            => $key,
					'description'   => '',
					'class'         => '',
					'before_widget' => '<aside id="%1$s" class="widget %2$s"><div>',
					'after_widget'  => '<div class="clear"></div></div></aside>',
					'before_title'  => $before_title,
					'after_title'   => $after_title
				) );				
			}
		}
	}
	
}
// only load widget settings when out of customizer to prevent slow down speed for widget management
if (strpos($_SERVER["REQUEST_URI"], 'customize.php') === false) :
	
	add_action( 'widgets_init', 'register_widget_areas' );


	global $widget_prefix_name;
	$widget_prefix_name = '&#9733;&nbsp; ';
	
		
	// LIB
	get_template_part(THEME_PART_WIDGETS . 'widgets_builder');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_lib');
	get_template_part(THEME_PART_WIDGETS . 'widgets_feed_data_lib');

	// CUSTOM WIDGET LAYOUT DESIGN
	get_template_part(THEME_PART_WIDGETS . 'widgets_admin_layout');
	get_template_part(THEME_PART_WIDGETS . 'widgets_admin_ajax');

	// COMMON WIDGETS
	get_template_part(THEME_PART_WIDGETS . 'widgets_social_counter');
	get_template_part(THEME_PART_WIDGETS . 'widgets_social_icons');
	get_template_part(THEME_PART_WIDGETS . 'widgets_popular_posts');
	get_template_part(THEME_PART_WIDGETS . 'widgets_recent_posts');
	get_template_part(THEME_PART_WIDGETS . 'widgets_random_posts');
	get_template_part(THEME_PART_WIDGETS . 'widgets_recent_review_posts');
	get_template_part(THEME_PART_WIDGETS . 'widgets_popular_review_posts');
	get_template_part(THEME_PART_WIDGETS . 'widgets_popular_user_rating');
	get_template_part(THEME_PART_WIDGETS . 'widgets_recent_comments');
	get_template_part(THEME_PART_WIDGETS . 'widgets_top_like_comments');
	get_template_part(THEME_PART_WIDGETS . 'widgets_login_form');
	get_template_part(THEME_PART_WIDGETS . 'widgets_subscribe_form');
	get_template_part(THEME_PART_WIDGETS . 'widgets_recent_tweets');

	get_template_part(THEME_PART_WIDGETS . 'widgets_brand_about');
	get_template_part(THEME_PART_WIDGETS . 'widgets_flickr_photos');
	get_template_part(THEME_PART_WIDGETS . 'widgets_popular_categories');
	
	get_template_part(THEME_PART_WIDGETS . 'widgets_responsive_ads');

	// ARTICLE BOX WIDGETS
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_break');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_slider');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_carousel');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_complex');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_one_left');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_one_right');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_two');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_tabs');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_blog_roll');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_trending');
	get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_one_horizon');
	//get_template_part(THEME_PART_WIDGETS . 'widgets_article_box_high_light');
	

endif;// not load in customizer