<?php
class Poplular_Categories_Widget extends WP_Widget {
	var $wpi_widget_builder;
	function __construct() {
		$this->wpi_widget_builder = new Wpi_Widget_Builder($this, array(
			'id'	=> 'wpi_popular_categories',
			'name'	=> 'Popular Categories',
			'desc'	=> 'Show Popular Categories with Many Design Styles',
			'instance'	=> array(
				array(
					'id'		=>	'count',
					'default'	=>	14
				),
				array(
					'id'		=>	'design_style',
					'type'		=>	'select',
					'default'	=>	'one',
					'choices'	=>	array(
						'one'	=>	'One Column',
						'two'	=>	'Two Columns'
					)
				),
				array(
					'id'		=>	'show_post_number',
					'type'		=>	'checkbox',
				),
			)
		));
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$this->wpi_widget_builder->form($instance);
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		return $this->wpi_widget_builder->update($new_instance, $old_instance);
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		extract( $args );
		$instance = $this->wpi_widget_builder->valid($instance);
		$title = apply_filters('widget_title', wpi_safe_array_get($instance, 'title'));
		echo $before_widget;
		if ($title) {
			echo $before_title . $title . $after_title;
		} else {
			echo '<div class="widget-content">';
		}		
		$querya = array(
            'orderby' => 'count',
            'hide_empty' => true,
            'order' => 'DESC',
            'number' => $instance['count'],
        );
		
		if ($instance['show_post_number']) {
			$querya['show_count'] = true;
		}

        $cates = get_categories($querya);

		if (!empty($cates)) {
			echo '<ul class="popular-category-list '.$instance['design_style'].'">';
				$index = 0;
				foreach ($cates as $cat) {
					$item_class = ' class="item item-'.$index;
					if ($index % 2 == 0) {
						$item_class .= ' item-even';
					} else {
						$item_class .= ' item-odd';
					}
					$item_class .= '" ';
					echo '<li'.$item_class.'><a class="color-hover" href="' . get_category_link($cat->cat_ID) . '">' . $cat->name;
					if ($instance['show_post_number']) {
						echo ' <span class="post-number background-color">' . $cat->count . '</span>';
					}
					echo '</a></li>';
					$index++;
				}
			echo '</ul>';
		}
       
		?>

		<?php
		if (!$title) {
			echo '<div class="clear"></div></div>';
		}
		echo $after_widget;
	}
}

// register News_Article_Box_Widget
add_action('widgets_init', create_function('', 'return register_widget("Poplular_Categories_Widget");'));
