<?php
class Popular_User_Rating_Posts_Widget extends WP_Widget {
	var $wpi_widget_builder;
	function __construct() {
		global $common_post_feed_data_widget_instance;
		$cf = $common_post_feed_data_widget_instance;//common fields
		$instance = array(
			$cf['count'],
			$cf['high_light'],
			$cf['show_thumbnail'],
			$cf['show_category'],
			$cf['show_date'],
			$cf['show_comment_number'],
			$cf['show_view_count'],
			$cf['show_snippet'],
			$cf['snippet_length'],
			$cf['style'],
			$cf['duration'],
			$cf['category'],
		); 
		$this->wpi_widget_builder = new Wpi_Widget_Builder($this, array(
			'id'	=> 'wpi_popular_user_rating_posts',
			'name'	=> 'Popular User Rating Posts',
			'desc'	=> 'Show Highest Rating / Review Score Posts from Post Users / Visitors',
			'instance'	=> $instance
		));
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$this->wpi_widget_builder->form($instance);
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		return $this->wpi_widget_builder->update($new_instance, $old_instance);
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		$instance = $this->wpi_widget_builder->valid($instance);
		wpi_post_feed_data($args, $instance, 'popular_user_rating_posts');
	}
}

// register widget
add_action('widgets_init', create_function('', 'return register_widget("Popular_User_Rating_Posts_Widget");'));
