<?php
class Recent_Tweets_Widget extends WP_Widget {
	var $wpi_widget_builder;
	function __construct() {
		$this->wpi_widget_builder = new Wpi_Widget_Builder($this, array(
			'id'	=> 'wpi_recent_tweets',
			'name'	=> 'Recent Tweets',
			'desc'	=> 'Show your recent tweets as list (update each 24h)',
			'instance'	=> array(
				array(
					'id'	=>	'twitter_url',
				),
				array(
					'id'	=>	'count',
					'default'	=> 5
				),
				array(
					'id'	=>	'high_light',
					'label'	=>	'Solid background color',
					'type'	=>	'checkbox'
				)
			)
		));
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$this->wpi_widget_builder->form($instance);
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		return $this->wpi_widget_builder->update($new_instance, $old_instance);
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		extract( $args );
		$instance = $this->wpi_widget_builder->valid($instance);
		if (!isset($instance['high_light'])) {
			$instance['high_light'] = '';
		}
		$title = apply_filters('widget_title', wpi_safe_array_get($instance, 'title'));
		echo $before_widget;
		if ($title) {
			echo $before_title .$title . $after_title;
		} else {
			echo '<div class="widget-content">';
		}
		
		if ($instance['high_light']) {
			echo '<div class="high_light">';
		}
	
		$twitter_link = $instance['twitter_url'];
		$count = $instance['count'];
		if ($twitter_link) :
			$twitter_html = wpi_twitter_recent_entries($twitter_link, $count);
			if ($twitter_html) {
				
				echo $twitter_html;
				
			}
		endif;
		if ($instance['high_light']) {
			echo '<div class="clear"></div></div>';
		}
		
		if (!$title) {
			echo '<div class="clear"></div></div>';
		}
		echo $after_widget;
	}
}

// register News_Article_Box_Widget
add_action('widgets_init', create_function('', 'return register_widget("Recent_Tweets_Widget");'));
