<?php
class Responsive_Ads_Widget extends WP_Widget {
	var $wpi_widget_builder;
	function __construct() {
		$this->wpi_widget_builder = new Wpi_Widget_Builder($this, array(
			'id'	=> 'wpi_responsive_ads',
			'name'	=> 'Responsive Ads',
			'desc'	=> 'Show / Hide your ads base on screen width',
			'instance'	=> array(
				array(
					'id' => 'ads_728',
					'label'=> '728px in width ads code',
					'type'=> 'textarea',
				),
				
				array(
					'id' => 'ads_468',
					'label'=> '468px in width ads code',
					'type'=> 'textarea',
				),
				
				array(
					'id' => 'ads_300',
					'label'=> '300px in width ads code',
					'type'=> 'textarea',
				),
				
				array(
					'id' => 'ads_160',
					'label'=> '160px in width ads code',
					'type'=> 'textarea',
				),
				
			)
		));
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$this->wpi_widget_builder->form($instance);
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		return $this->wpi_widget_builder->update($new_instance, $old_instance);
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		extract( $args );
		$instance = $this->wpi_widget_builder->valid($instance);
		$title = apply_filters('widget_title', wpi_safe_array_get($instance, 'title'));
		echo $before_widget;
		if ($title) {
			echo $before_title . $title . $after_title;
		} else {
			echo '<div class="widget-content">';
		}
		if ($instance['ads_728']) {
			echo '<div class="responsive-ads ads-728">'.$instance['ads_728'].'</div>';
		}
		if ($instance['ads_468']) {
			echo '<div class="responsive-ads ads-468">'.$instance['ads_468'].'</div>';
		}
		if ($instance['ads_300']) {
			echo '<div class="responsive-ads ads-300">'.$instance['ads_300'].'</div>';
		}
		if ($instance['ads_160']) {
			echo '<div class="responsive-ads ads-160">'.$instance['ads_160'].'</div>';
		}
		if (!$title) {
			echo '<div class="clear"></div></div>';
		}
		echo $after_widget;
	}
}

// register News_Article_Box_Widget
add_action('widgets_init', create_function('', 'return register_widget("Responsive_Ads_Widget");'));
