<?php
class Social_Counter_Widget extends WP_Widget {
	var $wpi_widget_builder;
	function __construct() {
		$this->wpi_widget_builder = new Wpi_Widget_Builder($this, array(
			'id'	=> 'wpi_social_counter',
			'name'	=> 'Social Counter',
			'desc'	=> 'Show social counter for your social pages (update once for each 24h)',
			'instance'	=> array(
				/*TWITTER*/
				array(
					'label'		=>	'Twitter URL (https://twitter.com/tiennguyentweet)',
					'id'		=>	'twitter_url',
					'default'	=>	''
				),
				array(
					'id'		=>	'twitter_like_text',
					'default'	=>	'Followers'
				),
				array(
					'label'		=>	'Manual Input Number',
					'id'		=>	'twitter_fixed',
				),
				
				/*FACEBOOK*/
				array(
					'label'		=>	'Facebook Page URL (https://www.facebook.com/wpinhands)',
					'id'		=>	'facebook_url',
					'default'	=>	''
				),
				array(
					'id'		=>	'facebook_like_text',
					'default'	=>	'Likes'
				),
				array(
					'label'		=>	'Manual Input Number',
					'id'		=>	'facebook_fixed',
				),
				
				/*GOOGLE PLUS*/
				array(
					'label'		=>	'Google Plus Page URL (https://plus.google.com/+Wpinhands)',
					'id'		=>	'google-plus_url',
					'default'	=>	''
				),
				array(
					'id'		=>	'google-plus_like_text',
					'label'		=>	'Google Plus Like Text',
					'default'	=>	'Shares'
				),
				array(
					'label'		=>	'Manual Input Number',
					'id'		=>	'google-plus_fixed',
				),
				
				/*YOUTUBE*/
				array(
					'label'		=>	'Youtube Channel URL (http://www.youtube.com/user/TienNguyenMark)',
					'id'		=>	'youtube_url',
					'default'	=>	'',
				),
				array(
					'id'		=>	'youtube_like_text',
					'default'	=>	'Fans'
				),
				array(
					'label'		=>	'Manual Input Number',
					'id'		=>	'youtube_fixed',
				),
				
				/*INSTAGRAM*/
				array(
					'label'		=>	'Instagram URL (http://instagram.com/insideenvato)',
					'id'		=>	'instagram_url',
					'default'	=>	'',
				),
				array(
					'id'		=>	'instagram_like_text',
					'default'	=>	'Followers'
				),
				array(
					'label'		=>	'Manual Input Number',
					'id'		=>	'instagram_fixed',
				),
				
				/*STEAM*/
				array(
					'label'		=>	'Steam Group URL (http://steamcommunity.com/groups/dota2lounge)',
					'id'		=>	'steam_url',
					'default'	=>	'',
				),
				array(
					'id'		=>	'steam_like_text',
					'default'	=>	'Members'
				),
				array(
					'label'		=>	'Manual Input Number',
					'id'		=>	'steam_fixed',
				),
				
				/*PINTEREST*/
				array(
					'label'		=>	'Pinterest Profile URL (http://www.pinterest.com/tvnguyen/)',
					'id'		=>	'pinterest_url',
					'default'	=>	'',
				),
				array(
					'id'		=>	'pinterest_like_text',
					'default'	=>	'Followers'
				),
				array(
					'label'		=>	'Manual Input Number',
					'id'		=>	'pinterest_fixed',
				),
				
				/*DRIBBBLE*/
				array(
					'label'		=>	'Dribbble Profile URL (https://dribbble.com/envato)',
					'id'		=>	'dribbble_url',
					'default'	=>	'',
				),
				array(
					'id'		=>	'dribbble_like_text',
					'default'	=>	'Followers'
				),
				array(
					'label'		=>	'Manual Input Number',
					'id'		=>	'dribbble_fixed',
				),
				
				array(
					'id'	=>	'target',
					'label' =>	'Open in New window',
					'type'	=>	'checkbox'
				),
			)
		));
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$this->wpi_widget_builder->form($instance);
		?>
<script type="text/javascript">
	/*widget field redesign*/
	var social_icons = ['twitter', 'facebook', 'google-plus', 'youtube', 'instagram', 'steam', 'pinterest', 'dribbble'];
	for (var i = 0; i < social_icons.length; i++) {
		$ = jQuery
		$('label[for*="'+social_icons[i]+'_url"]').each(function (){
			var html = $(this).html();
			if (html.indexOf('fa-'+social_icons[i]) === -1) {
				$(this).prepend('<div class="social-icon"><i class="fa fa-'+social_icons[i]+'"></i> '+social_icons[i]+'</div>');
			}
		});
		
	}
</script>
		<?php
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		return $this->wpi_widget_builder->update($new_instance, $old_instance);
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		extract( $args );
		$instance = $this->wpi_widget_builder->valid($instance);
		$title = apply_filters('widget_title', wpi_safe_array_get($instance, 'title'));
		echo $before_widget;
		if ($title) {
			echo $before_title . $title . $after_title;
		} else {
			echo '<div class="widget-content">';
		}
		
		$counter_list = array('twitter','facebook', 'google-plus','youtube','instagram', 'steam', 'pinterest', 'dribbble');
		$index = 0;
		foreach ($counter_list as $value) :
			
			if ($instance[$value.'_url']) :?>

<div class="social-counter-item <?php echo $value; ?> ease social-counter-item-<?php echo $index % 2; ?>">
	<a href="<?php echo $instance[$value.'_url'];?>" class="link" <?php if ($instance['target']) {echo ' target="_blank"';}?> title="<?php echo ucfirst($value); ?>">
		<span class="logo">
			<?php $icon_code = $value;
			if ($value === 'vimeo') {
				$icon_code = 'vimeo-square';
			} ?>
			<i class="icon fa fa-<?php echo $icon_code; ?>"></i>
		</span>
		<span class="counter">
			<span class="value">
				<strong><?php 
					if (isset($instance[$value.'_fixed']) && !empty($instance[$value.'_fixed'])) :
						echo $instance[$value.'_fixed'];
					else:
						switch ($value) :
							case 'facebook':
								echo wpi_facebook_fan_counter($instance[$value.'_url']);
								break;
							case 'twitter':
								echo wpi_twitter_fan_counter($instance[$value.'_url']); 
								break;
							case 'google-plus':
								echo wpi_gplus_fan_counter($instance[$value.'_url']); 
								break;
							case 'youtube':
								echo wpi_youtube_fan_counter($instance[$value.'_url']); 
								break;
							case 'instagram':
								echo wpi_instagram_fan_counter($instance[$value.'_url']); 
								break;
							case 'steam':
								echo wpi_steam_fan_counter($instance[$value.'_url']); 
								break;
							case 'pinterest':
								echo wpi_pinterest_fan_counter($instance[$value.'_url']);
								break;
							case 'dribbble':
								echo wpi_dribbble_fan_counter($instance[$value.'_url']);
								break;
						endswitch;
					endif;
					
				?></strong>
			</span>
			<span class="text">
				<?php echo $instance[$value.'_like_text']; ?>
			</span>
		</span>
	</a>
	<div class="clear"></div>
</div>
			
			<?php 
			$index++;
			endif;
			
		endforeach;
		?>
		
		
		<?php
		if (!$title) {
			echo '<div class="clear"></div></div>';
		}
		echo $after_widget;
	}
}

// register News_Article_Box_Widget
add_action('widgets_init', create_function('', 'return register_widget("Social_Counter_Widget");'));
