<?php


/*SOCIAL ICONS WIDGET*/
/*###############*/
class Social_Icons_Widget extends WP_Widget {

	/** Main */
	function __construct() {
		global $widget_prefix_name;
		parent::__construct(
			'wpi_social_icons_widget', // Base ID
			$widget_prefix_name . __wpi('Social Icons'), // Name
			array( 'description' => __wpi('Show social icons on right side bar (you must input social links in customizer).'), ) // Desc
		);
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		
		$title = esc_attr(wpi_safe_array_get($instance, 'title'));
		$open_blank = wpi_safe_array_get($instance, 'open_blank');
		?>
		
                <p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php echo __wpi( 'Title' ); ?> 
				<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</label>
		</p>    
		<p>
			<em><?php echo __wpi('Input your '); ?><a href="<?php echo admin_url('themes.php?page=wpi-theme-options&act=social'); ?>" target="_blank"><?php echo __wpi('Social Links here'); ?></a></em>
		</p>
		
                <p>
			<label for="<?php echo $this->get_field_id('open_blank'); ?>">
				<input class="checkbox" type="checkbox" <?php if ( $open_blank ) { echo 'checked';} ?> id="<?php echo $this->get_field_id( 'open_blank' ); ?>" name="<?php echo $this->get_field_name( 'open_blank' ); ?>" />   
				<?php echo __wpi('Open social link in new window of browser' );?>
			</label>
		</p>
		<?php 
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['open_blank']		= $new_instance[ 'open_blank' ];
		return $instance;
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		extract( $args );
		$title = apply_filters('widget_title', wpi_safe_array_get($instance, 'title'));
		$open_blank = wpi_safe_array_get($instance, 'open_blank');
		
		
		$blank_html = '';
		if ($open_blank) {
			$blank_html = ' target="blank"';
		}
		
		
		echo '<div class="social-icons">';
		echo $before_widget;
		if ($title) {
			echo $before_title . $title . $after_title;
		} else {
			echo '<div class="widget-content">';
		}
		global $wpi_social_links;
		global $wpi_social_names;
		$social_html = '';
		foreach ($wpi_social_links as $key => $value) {
			if ($value) {
				$social_html .= '<a href="'.$value.'" class="social-icon fa fa-'.$key.'" title="'.  esc_attr($wpi_social_names[$key]).'"></a>';
			}
		}
		
		echo $social_html;
		
		echo '<div class="clear"></div>';
		if (!$title) {
			echo '</div>';
		}
		echo $after_widget;
		echo '</div>';
	}
}

// register
add_action('widgets_init', create_function('', 'return register_widget("Social_Icons_Widget");'));

