<?php
class Subscribe_Form_Widget extends WP_Widget {

	/** Main */
	function __construct() {
		global $widget_prefix_name;
		parent::__construct(
			'wpi_subscribe_form', // Base ID
			$widget_prefix_name . __wpi('Subscribe Form'), // Name
			array( 'description' => __wpi('Show Subscribe form of your Feedburner services'), ) // Desc
		);
	}


	/** use this function to decide how the widget settings 
	will display in your admin dashboard */
	public function form( $instance ) {
		$title = '';
		$title = esc_attr(wpi_safe_array_get($instance, 'title'));
		$desc = wpi_safe_array_get($instance, 'desc');
		$uri = wpi_safe_array_get($instance, 'uri');
		
				
		?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php echo __wpi( 'Title' ); ?> 
			
				<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</label>
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id( 'desc' ); ?>"><?php echo __wpi( 'Description' ); ?> 
			
				<textarea class="widefat" id="<?php echo $this->get_field_id( 'desc' ); ?>" name="<?php echo $this->get_field_name( 'desc' ); ?>"><?php echo $desc; ?></textarea>
			</label>
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id( 'uri' ); ?>"><?php echo __wpi( 'Feedburner Uri' ); ?> 
			
				<input class="widefat" id="<?php echo $this->get_field_id( 'uri' ); ?>" name="<?php echo $this->get_field_name( 'uri' ); ?>" type="text" value="<?php echo esc_attr( $uri ); ?>" />
			</label>
		</p>
		
		
		<?php 
	}

	/** use this function to decide the way widget data will
	be saved after admin update widget data */
	public function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['desc'] = $new_instance['desc'];
		$instance['uri'] = $new_instance['uri'];
		return $instance;
	}
	
	
	/** use this function to decide how the widget
	will display in your theme */
	public function widget( $args, $instance ) {
		extract( $args );
		$title = '';
		$title = esc_attr(wpi_safe_array_get($instance, 'title'));
		$title = apply_filters('widget_title', $title);
		$uri = wpi_safe_array_get($instance, 'uri');
		$desc = wpi_safe_array_get($instance, 'desc');
		if ($uri == '') {
			$uri = get_theme_mod('social_feed_link');
			if ($uri == '') {
				return;
			}
			if (strpos($uri, 'feedburner') === false) {
				return;
			}
		}
		if (strpos($uri, '/') !== false) {
			$uri = substr(strrchr($uri, '/'), 1);
		}
		if (strpos($uri, '=') !== false) {
			$uri = substr(strrchr($uri, '='), 1);
		}
		// Show HTML
		echo $before_widget;
		?>
		

	<?php
		echo '<div class="widget-content">';
		if ($title) {
			echo '<h3 class="subscribe-title">'.$title.'</h3>';
		}
	?>
	<?php if ($desc) {
		echo '<p class="desc">'.$desc.'</p>';
	} ?>
     <form action="http://feedburner.google.com/fb/a/mailverify" method="post" target="popupwindow" onsubmit="window.open('http://feedburner.google.com/fb/a/mailverify?uri=<?php echo $uri; ?>', 'popupwindow', 'scrollbars=yes,width=550,height=520');return true" class="subscribe-form">
	<input type="hidden" name="loc" value="en_US"/>
	<input type="hidden" value="<?php echo $uri; ?>" name="uri"/>
	<input type="text" class="subscribe-email" name="email" value="<?php echo __wpi('Email address ...'); ?>" onfocus="if(this.value=='<?php echo __wpi('Email address ...'); ?>')this.value='';" onblur="if(this.value=='')this.value='<?php echo __wpi('Email address ...'); ?>';"/>
	 <input type="submit" class="subscribe-submit" value="<?php echo __wpi('Subscribe');?>" />
     </form>
	<div class="clear"></div>
		
		<?php
		
		echo '<div class="clear"></div></div>';
		
		echo $after_widget;
	}
}

// register News_Article_Box_Widget
add_action('widgets_init', create_function('', 'return register_widget("Subscribe_Form_Widget");'));
