jQuery(document).ready(function($){
    $('.my-color-field').wpColorPicker();
	
	/*WIDGET ADMIN PAGE*/
	// move visual layout
	$('#wpi-widgets-admin-layout').detach().prependTo('.widget-liquid-right #widgets-right');
	
	// add edit buttons for custom side bar
	$('div#widgets-right .widgets-holder-wrap .widgets-sortables[id*="main-"]').each(function(){
		if (!$(this).is('#main-sidebar')) {
			$(this).find('.sidebar-description').prepend('<div class="wpi-custom-sidebar-actions">\
	<a href="#delete-'+$(this).attr('id')+'" class="delete"><i class="fa fa-trash-o"></i> Delete</a>\
	<a href="#rename-'+$(this).attr('id')+'" class="rename"><i class="fa fa-pencil"></i> Rename</a>\
</div>');
		}
	});
	
	$('div#widgets-right .widgets-holder-wrap .widgets-sortables[id*="small-"]').each(function(){
		if (!$(this).is('#small-sidebar')) {
			$(this).find('.sidebar-description').prepend('<div class="wpi-custom-sidebar-actions">\
	<a href="#delete-'+$(this).attr('id')+'" class="delete"><i class="fa fa-trash-o"></i> Delete</a>\
	<a href="#rename-'+$(this).attr('id')+'" class="rename"><i class="fa fa-pencil"></i> Rename</a>\
</div>');
		}
	});
	
	$('div#widgets-right .widgets-holder-wrap .widgets-sortables[id*="big-"]').each(function(){
		if (!$(this).is('#big-sidebar')) {
			$(this).find('.sidebar-description').prepend('<div class="wpi-custom-sidebar-actions">\
	<a href="#delete-'+$(this).attr('id')+'" class="delete"><i class="fa fa-trash-o"></i> Delete</a>\
	<a href="#rename-'+$(this).attr('id')+'" class="rename"><i class="fa fa-pencil"></i> Rename</a>\
</div>');
		}
	});

	// move sections into layout
	$('div#widgets-right .widgets-holder-wrap').each(function (){
		if ($(this).find('#header-right').length) {
			$(this).detach().appendTo('#wpi-widgets-admin-layout .header .header-2 .holder');
		}
		if ($(this).find('#header-wide').length) {
			$(this).detach().appendTo('#wpi-widgets-admin-layout .header .header-3');
		}
		
		if ($(this).find('.widgets-sortables[id*="main-"]').length) {
			$(this).detach().appendTo('#wpi-widgets-admin-layout .body .main-col .inner');
		}
		if ($(this).find('.widgets-sortables[id*="small-"]').length) {
			$(this).detach().appendTo('#wpi-widgets-admin-layout .body .small-col .inner');
		}
		if ($(this).find('.widgets-sortables[id*="big-"]').length) {
			$(this).detach().appendTo('#wpi-widgets-admin-layout .body .big-col .inner');
		}
		
		if ($(this).find('#footer').length) {
			$(this).detach().appendTo('#wpi-widgets-admin-layout .footer');
		}
		
		$(this).removeClass('closed');
	});
	
	// add button actions
	$('#wpi-widgets-admin-layout .add-custom-sidebar').click(function () {
		var area = 'main';
		if ($(this).is('.custom-small-sidebar')) {
			area = 'small';
		} else if ($(this).is('.custom-big-sidebar')) {
			area = 'big';
		}
		var name = prompt('Name of sidebar');

		if (name) {
			holder = $(this);
			holder.hide();
			holder.next().show();
			$.post(ajaxurl, {
				'action': 'wpi_widgets_add_custom_sidebar',
				'area':  area,
				'name': name
			}, 
			function(response){
				if (response && response.indexOf('warning') == -1 && response.indexOf('error') == -1) {
					location.reload();
				} else {
					holder.show();
					holder.next().hide();
					alert('Can not create sidebar, unknown server errors!');
				}
			}
			);
		}
	});
	
	// delete button actions
	$('#wpi-widgets-admin-layout .wpi-custom-sidebar-actions a.delete').click(function () {
		if (!confirm('Are you sure delete this sidebar?')) {
			return;
		}
		var base = $(this).attr('href');
		base = base.replace('#delete-', '');
		
		if (base) {
			$('#' + base).hide();
			$.post(ajaxurl, {
				'action': 'wpi_widgets_delete_custom_sidebar',
				'base':  base,
			}, 
			function(response){
				if (response && response.indexOf('warning') == -1 && response.indexOf('error') == -1) {
					location.reload();
				} else {
					$('#' + base).show();
					alert('Can not delete sidebar, unknown server errors!');
				}
			}
			);
		}
	});
	
	// rename button actions
	$('#wpi-widgets-admin-layout .wpi-custom-sidebar-actions a.rename').click(function () {
		var name = prompt('Name of sidebar');
		if (name == '') {
			return;
		}
		var base = $(this).attr('href');
		base = base.replace('#rename-', '');
		
		if (base) {
			$('#' + base).hide();
			$.post(ajaxurl, {
				'action': 'wpi_widgets_rename_custom_sidebar',
				'base':  base,
				'name': name
			}, 
			function(response){
				if (response && response.indexOf('warning') == -1 && response.indexOf('error') == -1) {
					location.reload();
				} else {
					$('#' + base).show();
					alert('Can not delete sidebar, unknown server errors!');
				}
			}
			);
		}
	});
	
	// widget icon attachment
	function wpi_wid_fa_icon(code) {
		return '<div class="wpi_wid_fa_icon"><i class="fa fa-'+code+'"></i></div>';
	}
	var wpi_wid_fa_icon_map = {
		'wpi_login_form'				:	'key',
		'wpi_popular_posts'				:	'eye',
		'wpi_popular_review_posts'		:	'star',
		'wpi_popular_user_rating_posts'	:	'users',
		'wpi_random_posts'				:	'random',
		'wpi_recent_comments'			:	'comment',
		'wpi_recent_posts'				:	'clock-o',
		'wpi_recent_review_posts'		:	'thumbs-up',
		'wpi_social_counter'			:	'sort-numeric-asc',
		'wpi_social_icons'				:	'th',
		'wpi_subscribe_form'			:	'rss',
		'wpi_top_like_comments'			:	'comments-o',
		'wpi_recent_tweets'				:	'twitter',
		'wpi_brand_about'				:	'info',
		'wpi_flickr_photos'				:	'flickr',
		'wpi_popular_categories'		:	'building-o',
		'wpi_responsive_ads'			:	'tasks',
		
		'wpi_ab_blog_roll'				:	'paste',
		'wpi_ab_break'					:	'flash',
		'wpi_ab_carousel'				:	'ellipsis-h',
		'wpi_ab_complex'				:	'list-alt',
		'wpi_ab_one_right'				:	'ellipsis-v',
		'wpi_ab_one_left'				:	'ellipsis-v',
		'wpi_ab_slider'					:	'play',
		'wpi_ab_tabs'					:	'table',
		'wpi_ab_two'					:	'columns',
		'wpi_ab_one_horizon'			:	'list',
		'wpi_ab_trending'				:	'th-large',
		
		
	};
	for (key in wpi_wid_fa_icon_map) {
		$('.widget[id*="'+key+'"] .widget-title h4').prepend(wpi_wid_fa_icon(wpi_wid_fa_icon_map[key]));
	}
	
	$('.my-color-field').wpColorPicker();
	$('.widget-control-save').click(function () {
		setTimeout(function (){
			$('.my-color-field').wpColorPicker();
		}, 2000);
	});
	
	
   
	// loading message for customizer
	if ($('#customize-controls').length) {
		$('#customize-controls').hide();
		$('.wp-full-overlay').removeClass('expanded').addClass('collapsed');
		$('#customize-preview').append('<div class="customize-preview-loading"><span>INITIALIZING CONTROLS</span> <img src="'+wpi_admin_js.loading_image+'"/></div>');
		var loading_counter = 0;
		var loading_interval = setInterval(function () {
			var preview_html = $('#customize-preview').html();
			if (typeof(preview_html) === 'undefine') {
				return;
			}
			if (preview_html.indexOf('<iframe') != -1) {
				clearInterval(loading_interval);
				$('#customize-controls').show();
				$('.wp-full-overlay').removeClass('collapsed').addClass('expanded');
				$('.customize-preview-loading').hide();
			}
			if (loading_counter == 7) {
				$('.customize-preview-loading span').html('GETTING PAGE');
			} else if (loading_counter == 9) {
				$('.customize-preview-loading span').html('LOADING FONT SETS');
			} else if (loading_counter == 14) {
				$('.customize-preview-loading span').html('MAKING INTERFACE');
			}
			loading_counter++;
		}, 1000);
		/*
		setTimeout(function () {
			$('#customize-controls').show();
			$('.wp-full-overlay').removeClass('collapsed').addClass('expanded');
			$('.customize-preview-loading').hide();
		}, 20000);
		*/

		var loading_timer = null;


		$('.wp-picker-container *').mousedown(function () {
			if (loading_timer != null) {
				clearInterval(loading_timer);
			}
			$('.customize-preview-loading span').html('LOADING SETTINGS');
			$('.customize-preview-loading').show();
			loading_timer = setTimeout(function () {
				$('.customize-preview-loading').hide();
				loading_timer = null;
			}, 20000);
		});
		$('#customize-controls *').on('change', function () {
			if (loading_timer != null) {
				clearInterval(loading_timer);
			}
			$('.customize-preview-loading span').html('LOADING SETTINGS');
			$('.customize-preview-loading').show();
			loading_timer = setTimeout(function () {
				$('.customize-preview-loading').hide();
				loading_timer = null;
			}, 20000);
		});
	}
	
	// customizer reset font to default
	$('#customize-theme-controls .font-reset').click(function () {
		var default_font = $(this).attr('data-default');
		if (!default_font) {
			return;
		}
		console.log(default_font);
		$(this).parent('.google-font').find('.font-container').each(function () {
			$(this).find('input[type="radio"]').prop("checked", false);
			$(this).find('input[type="radio"][value="'+default_font+'"]').prop("checked", true);
		});
	});
});