
jQuery(function($) {
	(function() {
		var ed_btn_img_url = '/../img/editor_buttons/';
		// prepare box for input content



		tinymce.create('tinymce.plugins.Wpi_post_editor', {
			init : function(ed, url) {
				// Contact
				ed.addButton('contact', {
					title : 'Contact Form',
					cmd : 'contact',
					image : url + ed_btn_img_url + 'contact.png'
				});

				ed.addCommand('contact', function() {
					var target_email = prompt('Input your target email (optional)');
					$ret = '[contact/]';
					if (target_email) {
						$ret = '[contact target_email = "'+target_email+'"/]';
					}
					ed.execCommand('mceInsertContent', 0, $ret);
				});

				// Team
				ed.addButton('team', {
					title : 'Team List',
					cmd : 'team',
					image : url + ed_btn_img_url + 'team.png'
				});

				ed.addCommand('team', function() {
					ed.execCommand('mceInsertContent', 0, '[team/]');
				});

				// dropcap
				ed.addButton('dropcap', {
					title : 'Dropcap',
					cmd : 'dropcap',
					image : url + ed_btn_img_url + 'dropcap.png'
				});

				ed.addCommand('dropcap', function() {
					var ret = ed.selection.getContent();
					ret = '[dropcap]' + ret + '[/dropcap]';
					ed.execCommand('mceInsertContent', 0, ret);
				});

				// highlight
				ed.addButton('highlight', {
					title : 'Highlight',
					cmd : 'highlight',
					image : url + ed_btn_img_url + 'highlight.png'
				});

				ed.addCommand('highlight', function() {
					var ret = ed.selection.getContent();
					ret = '[highlight]' + ret + '[/highlight]';
					ed.execCommand('mceInsertContent', 0, ret);
				});

				// button
				// #########################################################
				ed.addButton('button', {
					title : 'Button',
					cmd : 'button',
					image : url + ed_btn_img_url + 'button.png'
				});

				ed.addCommand('button', function() {
					var form = '<div id="wpi-dialog-button" title="Button settings">\
		<form class="wpi-pf-dialog-form" id="wpi-pf-button">\
			<label for="wpi-pf-btn-text">Text</label>\
			<input type="text" name="wpi-pf-btn-text" value="'+ed.selection.getContent()+'"/>\
			<label for="wpi-pf-btn-link">Link</label>\
			<input type="text" name="wpi-pf-btn-link"/>\
			<label for="wpi-pf-btn-size">Size</label>\
			<select name="wpi-pf-btn-size">\
				<option value="medium">Medium</option>\
				<option value="small">Small</option>\
				<option value="large">Large</option>\
			</select>\
			<label for="wpi-pf-btn-color">Color</label>\
			<select name="wpi-pf-btn-color">\
				<option value="red">Red</option>\
				<option value="blue">Blue</option>\
				<option value="green">Green</option>\
				<option value="orange">Orange</option>\
				<option value="magenta">Magenta</option>\
				<option value="pink">Pink</option>\
				<option value="black">Black</option>\
				<option value="white">White</option>\
				<option value="gray">Gray</option>\
				<option value="yellow">Yellow</option>\
			</select>\
			<label for="wpi-pf-btn-target">Open in</label>\
			<select name="wpi-pf-btn-target">\
				<option value="_self">Same window</option>\
				<option value="_blank">New window</option>\
				<option value="_parent">Parent window</option>\
				<option value="_top">Top windown</option>\
			</select>\
			<label for="wpi-pf-btn-icon">Icon Code (example: <strong style="color: red">fa-home</strong>) <a href="http://fortawesome.github.io/Font-Awesome/icons/" target="_blank">Learn more.</a></label>\
			<input type="text" name="wpi-pf-btn-icon"/>\
		</form>\
	</div>';
					
					$(form).dialog({ 
						modal: true,
						closeText: 'X',
						buttons: [ 
							{ 
								text: "Insert", 
								click: function() { 
									// get options
									var text = $('#wpi-pf-button input[name="wpi-pf-btn-text"]').val();
									var link = $('#wpi-pf-button input[name="wpi-pf-btn-link"]').val();
									var size = $('#wpi-pf-button select[name="wpi-pf-btn-size"]').val();
									var color = $('#wpi-pf-button select[name="wpi-pf-btn-color"]').val();
									var target = $('#wpi-pf-button select[name="wpi-pf-btn-target"]').val();
									var icon = $('#wpi-pf-button input[name="wpi-pf-btn-icon"]').val();
									var ret = '[button link="'+link+'" size="'+size+'" color="'+color+'" target="'+target+'" icon="'+icon+'"]' + text + '[/button]';
									ed.execCommand('mceInsertContent', 0, ret);
									
									$( this ).dialog( "destroy" ); 
									$( this ).remove();
								} 
							}, 
							{ 
								text: "Cancel", 
								click: function() { 
									$( this ).dialog( "destroy" ); 
									$( this ).remove();
								} 
							}
						] 
					});// end dialog show
					
				}); // END BUTTON SHORTCODE
				// ###############################################
				
				
				// TABS
				// #########################################################
				ed.addButton('tabs', {
					title : 'Tabs',
					cmd : 'tabs',
					image : url + ed_btn_img_url + 'tabs.png'
				});

				ed.addCommand('tabs', function() {
					var tab_number = prompt("How many tabs you want to show?");
					if (isNaN(tab_number)) {
						return;
					}
					tab_number = Number(tab_number);
					if (tab_number == 0) {
						return;
					}
					
					var form = '<div id="wpi-dialog-tabs" title="Tabs settings">\
		<form class="wpi-pf-dialog-form" id="wpi-pf-tabs">';
					for (var i = 0; i < tab_number; i++) {
						form += '<div style="border-bottom: 1px solid #ccc;display: block;clear: both;padding: 0 0 10px 0;margin: 0 0 10px 0;">\
	<span style="font-weight:bold;color: black;font-family: Arial;font-size: 14px;">Tab '+i+'</span><div class="clear"></div>\
	<label for="wpi-pf-tab-title-'+i+'">Title</label>\
	<input type="text" name="wpi-pf-tab-title-'+i+'" value="Tab Title '+i+'"/>\
	<label for="wpi-pf-tab-title-'+i+'">Content</label>\
	<textarea name="wpi-pf-tab-content-'+i+'" style="width: 300px; height: 50px; padding: 5px;display: block;">Tab Content '+i+'</textarea>\
<div class="clear"></div></div><div class="clear"></div>';
					}
				form += '</form>';
			
					$(form).dialog({ 
						modal: true,
						closeText: 'X',
						width: 500,
						dialogClass: 'no-float',
						buttons: [ 
							{ 
								text: "Insert", 
								click: function() { 
									var ret = '<p>[tabs]<br/>';
									for (var i = 0; i < tab_number; i++) {
										ret += '[tab title="'+$('input[name="wpi-pf-tab-title-'+i+'"]').val()+'"]'+$('textarea[name="wpi-pf-tab-content-'+i+'"]').val()+'[/tab]<br/>';
									}
									ret += '[/tabs]<br/></p>';
									
									ed.execCommand('mceInsertContent', 0, ret);
									
									$( this ).dialog( "destroy" ); 
									$( this ).remove();
								} 
							}, 
							{ 
								text: "Cancel", 
								click: function() { 
									$( this ).dialog( "destroy" ); 
									$( this ).remove();
								} 
							}
						] 
					});// end dialog show
					
				}); // END TABS SHORTCODE
				// ###############################################
				
				
				
				// ACCORDIONS
				// #########################################################
				ed.addButton('accordions', {
					title : 'Accordions',
					cmd : 'accordions',
					image : url + ed_btn_img_url + 'accordions.png'
				});

				ed.addCommand('accordions', function() {
					var accordions_number = prompt("How many accordions you want to show?");
					if (isNaN(accordions_number)) {
						return;
					}
					accordions_number = Number(accordions_number);
					if (accordions_number == 0) {
						return;
					}
					
					var form = '<div id="wpi-dialog-accordions" title="Accordions settings">\
		<form class="wpi-pf-dialog-form" id="wpi-pf-accordions">';
					for (var i = 0; i < accordions_number; i++) {
						form += '<div style="border-bottom: 1px solid #ccc;display: block;clear: both;padding: 0 0 10px 0;margin: 0 0 10px 0;">\
	<span style="font-weight:bold;color: black;font-family: Arial;font-size: 14px;">Accordion '+i+'</span><div class="clear"></div>\
	<label for="wpi-pf-accordion-title-'+i+'">Title</label>\
	<input type="text" name="wpi-pf-accordion-title-'+i+'" value="Accordion Title '+i+'"/>\
	<label for="wpi-pf-accordion-title-'+i+'">Content</label>\
	<textarea name="wpi-pf-accordion-content-'+i+'" style="width: 300px; height: 50px; padding: 5px;display: block;">Accordion Content '+i+'</textarea>\
<div class="clear"></div></div><div class="clear"></div>';
					}
				form += '</form>';
			
					$(form).dialog({ 
						modal: true,
						closeText: 'X',
						width: 500,
						dialogClass: 'no-float',
						buttons: [ 
							{ 
								text: "Insert", 
								click: function() { 
									var ret = '<p>[accordions]<br/>';
									for (var i = 0; i < accordions_number; i++) {
										ret += '[accordion title="'+$('input[name="wpi-pf-accordion-title-'+i+'"]').val()+'"]'+$('textarea[name="wpi-pf-accordion-content-'+i+'"]').val()+'[/accordion]<br/>';
									}
									ret += '[/accordions]<br/></p>';
									ed.execCommand('mceInsertContent', 0, ret);
									
									$( this ).dialog( "destroy" ); 
									$( this ).remove();
								} 
							}, 
							{ 
								text: "Cancel", 
								click: function() { 
									$( this ).dialog( "destroy" ); 
									$( this ).remove();
								} 
							}
						] 
					});// end dialog show
					
				}); // END ACCORDIONS SHORTCODE
				// ###############################################
				
			},
		});
		// Register plugin
		tinymce.PluginManager.add( 'wpi_post_editor', tinymce.plugins.Wpi_post_editor );
	})();
});