jQuery(function($) {
	function wpi_rating_delete_fields(e) {
				
		// prevent delete all fields
		var num_fields = $(e).parents('.section').find('.field').length;
		
		if (num_fields == 1) {
			alert(wpi_ro.txt.canNotDelete);
		} else {
			// if more than 1 field, can delete
			// ask and delete the current field
			if (confirm(wpi_ro.txt.sureDelete)) {
				var delete_holder = $(e).parents('.section').find('.field').first();
				$(e).parents('.field').remove();

				// reindex the fields after delete
				wpi_rating_reindex_fields(delete_holder);
			}
		}
	}
	function wpi_rating_reindex_fields(e) {
		
		var index = 0;
		// replace name by index
		$(e).parents('.section').find('.field').each(function () {
			$(this).find('input').each(function () {
				var name = $(this).attr('name');
				name = name.split('_');
				name = name[0] + '_' + index;
				$(this).attr('name', name);
			});
			$(this).find('select').each(function () {
				var name = $(this).attr('name');
				name = name.split('_');
				name = name[0] + '_' + index;
				$(this).attr('name', name);
			});
			$(this).find('label').each(function () {
				var name = $(this).attr('for');
				name = name.split('_');
				name = name[0] + '_' + index;
				$(this).attr('for', name);
			});
			index++;
		});
		// update number of features
		$('input[name="wpi_rating_features_number"]').val(index);
	}
	$(document).ready(function() {
		// add function for delete button
		$('.wpi-meta-box-content.rating .field .rating-field-delete').click(function () {
			wpi_rating_delete_fields($(this));
		});
		// when select a rating type
		$('select[name="wpi-rating-type"]').change(function() {
			var val = $(this).val();
			$('.wpi-meta-box-content.rating .section.show-hide').hide();
			$('.wpi-meta-box-content.rating .section.rating-'+val).show();
			if (val != '') {
				$('.wpi-meta-box-content.rating .section.rating-summary').show();
				// reindex
				wpi_rating_reindex_fields($('.wpi-meta-box-content.rating .section.rating-'+val).find('.field'));
			}
		});
		
		// when add a new feature
		$('.wpi-meta-box-content.rating .rating-field-copy').click(function () {
			// duplicate field
			$(this).parents('.section').find('.field').first().clone().insertBefore($(this).parent('p'));
			// clean the new field
			$(this).parents('.section').find('.field').last().each(function () {
				$(this).find('input').val('');
				$(this).find('select').find('option').removeAttr('selected');
				$(this).find('select').find('option').first().attr('selected', 'selected');
			});
			// reindex fields
			wpi_rating_reindex_fields($(this));
			$(this).parents('.section').find('.field').last().find('.rating-field-delete').click(function () {
				wpi_rating_delete_fields($(this));
			});
			
			
		});
	});
});