		
<?php get_header();  
global $wpi_pf_main_sidebar;
global $wpi_pf_small_sidebar;
global $wpi_pf_big_sidebar;
?>
	<div class="content-col col-main">
		<?php
			/**
			 * woocommerce_before_main_content hook
			 *
			 * @hooked woocommerce_output_content_wrapper - 10 (outputs opening divs for the content)
			 * @hooked woocommerce_breadcrumb - 20
			 */
			do_action( 'woocommerce_before_main_content' );
		?>

			<?php if ( apply_filters( 'woocommerce_show_page_title', true ) ) : ?>

				<h1 class="page-title"><?php woocommerce_page_title(); ?></h1>

			<?php endif; ?>

			<?php do_action( 'woocommerce_archive_description' ); ?>

			<?php if ( have_posts() ) : ?>

				<?php
					/**
					 * woocommerce_before_shop_loop hook
					 *
					 * @hooked woocommerce_result_count - 20
					 * @hooked woocommerce_catalog_ordering - 30
					 */
					do_action( 'woocommerce_before_shop_loop' );
				?>

				<?php woocommerce_product_loop_start(); ?>

					<?php woocommerce_product_subcategories(); ?>

					<?php while ( have_posts() ) : the_post(); ?>

						<?php wc_get_template_part( 'content', 'product' ); ?>

					<?php endwhile; // end of the loop. ?>

				<?php woocommerce_product_loop_end(); ?>

				<?php
					/**
					 * woocommerce_after_shop_loop hook
					 *
					 * @hooked woocommerce_pagination - 10
					 */
					do_action( 'woocommerce_after_shop_loop' );
				?>

			<?php elseif ( ! woocommerce_product_subcategories( array( 'before' => woocommerce_product_loop_start( false ), 'after' => woocommerce_product_loop_end( false ) ) ) ) : ?>

				<?php wc_get_template( 'loop/no-products-found.php' ); ?>

			<?php endif; ?>

		<?php
			/**
			 * woocommerce_after_main_content hook
			 *
			 * @hooked woocommerce_output_content_wrapper_end - 10 (outputs closing divs for the content)
			 */
			do_action( 'woocommerce_after_main_content' );
		?>
		
		<?php
		if ($wpi_pf_main_sidebar != 'content') :
			if ( is_active_sidebar($wpi_pf_main_sidebar)) : ?>
				<div id="<?php echo $wpi_pf_main_sidebar; ?>" class="sidebar">
					<?php dynamic_sidebar( $wpi_pf_main_sidebar ); ?>
				</div>
			<?php endif; 
		endif;
		?>
		
	</div><!-- .col-main -->
	
	<?php if ( is_active_sidebar( $wpi_pf_small_sidebar ) && $wpi_pf_small_sidebar !== 'small-disable') : ?>
		<div class="content-col col-small">
			<div id="<?php echo $wpi_pf_small_sidebar; ?>" class="sidebar">
				<?php dynamic_sidebar( $wpi_pf_small_sidebar ); ?>
			</div>
		</div><!-- .col-small -->
	<?php endif; ?>
	
	
	
	<?php if ( is_active_sidebar( $wpi_pf_big_sidebar ) && $wpi_pf_big_sidebar !== 'big-disable') : ?>
		<div class="content-col col-big">
			<div id="<?php echo $wpi_pf_big_sidebar; ?>" class="sidebar">
				<?php dynamic_sidebar( $wpi_pf_big_sidebar ); ?>
			</div>
		</div><!-- .col-big -->
	<?php endif; ?>
	

<?php get_footer(); ?>			